#!/bin/bash

function check_dir {
  if [ "$1" = "" ]; then
    echo "adsl/global.cfg - $2 - $3: not defined" 1>&2
    exit 1
  fi
  if [ ! -d "$1" ]; then
    echo "adsl/global.cfg - $2 - $3: directory $1 not found" 1>&2
    exit 1
  fi
}

dir=`perl -MFDN::Common::Config -e 'print Config_Key("adsl/global.cfg","dirs","tdincoming");'`
process=`perl -MFDN::Common::Config -e 'print Config_Key("adsl/global.cfg","dirs","tdprocess");'`
done=`perl -MFDN::Common::Config -e 'print Config_Key("adsl/global.cfg","dirs","tdindone");'`

check_dir "$dir" dirs tdincoming
check_dir "$process" dirs tdindone
check_dir "$done" dirs tdprocess

dir9=`perl -MFDN::Common::Config -e 'print Config_Key("adsl/global.cfg","dirs","9tincoming");'`
process9=`perl -MFDN::Common::Config -e 'print Config_Key("adsl/global.cfg","dirs","9tprocess");'`
done9=`perl -MFDN::Common::Config -e 'print Config_Key("adsl/global.cfg","dirs","9tindone");'`

check_dir "$dir9" dirs 9tincoming
check_dir "$process9" dirs 9tindone
check_dir "$done9" dirs 9tprocess

#echo Taking files from $dir
#echo Moving them to $done
cd $dir
for i in `find . -type f`; do
	echo Traitement de $i
	mv $i $process
	cd $process
	/usr/lib/fdn/adsl/automate.pl $i
	mv $i $done
	cd $dir
done

cd $dir9
for i in `find . -type f`; do
	case $i in
	EASY* )
		mv $i $done9
		;;
	* )
		echo Traitement de $i
		mv $i $process9
		cd $process9
		/usr/lib/fdn/adsl/automate-9t.pl $i
		mv $i $done9
		cd $dir9
		;;
	esac
done




