#!/usr/bin/perl 

# Debian dependencies : 
# Depends: perl-api, libnet-perl, libgnupg-perl
# Conflicts: placenet

use strict;
use Net::FTP;
use FDN::Common::Config;
use FDN::Common::Logger;

# FTP Account properties to connect to Cegetel Server : 
my $ftp_server = Config_Key('adsl/tdftp.cfg','ftp9','server');
my $ftp_login  = Config_Key('adsl/tdftp.cfg','ftp9','login');
my $ftp_pass   = Config_Key('adsl/tdftp.cfg','ftp9','passwd');
# Directory on the remote server : 
my $ftp_dir_ar  = Config_Key('adsl/tdftp.cfg','ftp9','indir_ar');
my $ftp_dir_cr  = Config_Key('adsl/tdftp.cfg','ftp9','indir_cr');
my $ftp_dir_crf = Config_Key('adsl/tdftp.cfg','ftp9','indir_crf');
my $ftp_dir_no  = Config_Key('adsl/tdftp.cfg','ftp9','indir_no');

# Local directories : 
# - incoming = where we store crypted files from ftp
# - spool = where we move decrypted files to be processed by another daemon. 
my $dir_incoming = Config_Key('adsl/global.cfg','dirs','tdin');
my $dir_spool    = Config_Key('adsl/global.cfg','dirs','tdincoming');

##########################################################
# Private and globals
my @flist; # Remote or Local File List 
my $k;

my $ftp = Net::FTP->new($ftp_server,'Passive' => 1)
    or die "FATAL: Cannot connect to the FTP server: $@";

$ftp->login($ftp_login,$ftp_pass)
    or die "FATAL: Cannot login ", $ftp->message;

$ftp->binary()
    or die "FATAL: Cannot change to binary mode ", $ftp->message;

sub list_dir($$) {
  my ( $ftp, $dir ) = @_;
  $ftp->cwd('/'.$dir)
    or die "FATAL: Cannot change working directory ", $ftp->message;

  @flist = $ftp->ls();

  print "Found ".(scalar @flist)." files in $dir.\n";
  foreach $k (@flist) {
	next if ( $k eq '.' );
	next if ( $k eq '..' );
	print "Un fichier $k!\n";
  }
}

# List the files
list_dir($ftp,$ftp_dir_ar);
list_dir($ftp,$ftp_dir_crf);
#list_dir($ftp,$ftp_dir_cr);
list_dir($ftp,$ftp_dir_no);

list_dir($ftp,'backups/'.$ftp_dir_ar);
list_dir($ftp,'backups/'.$ftp_dir_crf);
#list_dir($ftp,'backups/'.$ftp_dir_cr);
list_dir($ftp,'backups/'.$ftp_dir_no);

$ftp->quit;


