#!/usr/bin/perl 

# Debian dependencies : 
# Depends: perl-api, libnet-perl, libgnupg-perl
# Conflicts: placenet

use strict;
use Net::FTP;
use FDN::Common::Config;
use FDN::Common::Logger;


# FTP Account properties to connect to Cegetel Server : 
my $ftp_server = Config_Key('adsl/tdftp.cfg','ftp9','server');
my $ftp_login  = Config_Key('adsl/tdftp.cfg','ftp9','login');
my $ftp_pass   = Config_Key('adsl/tdftp.cfg','ftp9','passwd');
# Directory on the remote server : 
my $ftp_dir    = Config_Key('adsl/tdftp.cfg','ftp9','outdir');

# Local directories : 
# - incoming = where we take unencrypted file that will be sent to cegetel.
# - archive = where we store unencrypted files after the upload.
my $dir_incoming = Config_Key('adsl/global.cfg','dirs','9tout');
my $dir_archive  = Config_Key('adsl/global.cfg','dirs','9toutdone');

##########################################################
# Private and globals
my @flist; # Remote or Local File List 
my $k;


# We walk through the files in $dir_incoming
opendir(DIR,$dir_incoming) or die "FATAL: Can't open the incoming directory\n";
@flist = readdir(DIR) or die "FATAL : unable to read incoming directory\n";

# Now connect to the ftp server:
my $ftp = Net::FTP->new($ftp_server, 'Passive' => 1 )
    or die "FATAL: Cannot connect to the FTP server: $@";

$ftp->login($ftp_login,$ftp_pass)
    or die "FATAL: Cannot login ", $ftp->message;

$ftp->cwd($ftp_dir)
    or die "FATAL: Cannot change working directory ", $ftp->message;

$ftp->binary()
    or die "FATAL: Cannot change to binary mode ", $ftp->message;

# Upload the local files : 
foreach $k (@flist) {
	next if ( ! -f $dir_incoming."/".$k );
	print "J'upload le fichier ".$dir_incoming."/".$k." sous le nom $k\n";
	my $res = $ftp->put($dir_incoming."/".$k,$k);
	if ( ! $res ) {
		error "Failed uploading $k";
		print STDERR "Failed uploading $k";
	} else {
		info "Successfuly uploaded $k";
	}
	rename($dir_incoming."/".$k,    $dir_archive."/".$k);  # move it to archive.
#	rename($dir_temp."/".$k.'.pgp', $dir_store."/".$k.'.pgp');
	#unlink($dir_temp."/".$k.'.pgp');
}

$ftp->quit;


