drop table if exists SEQ;
create table SEQ (
	SEQ_NAME varchar(20) UNIQUE NOT NULL default ''      ,
	SEQ_VALUE int(11) NOT NULL default '0'               ,
	SEQ_MINVALUE int(11) NOT NULL default '0'            ,
	SEQ_MAXVALUE int(11) NOT NULL default '0'            ,
	SEQ_INC int(11) NOT NULL default '0'                 ,
	SEQ_CYCLE ENUM('-1','0','1') NOT NULL default '-1'   ,
	primary key  (SEQ_NAME)
) ;

drop table if exists LIGNE;
create table LIGNE (
	LIGNE_ID int(11) UNIQUE NOT NULL default '0',
	DEBIT_ID int(11) NOT NULL default '0',
	PRIX_ID int(11),
	CLIENT_ID int(11),
	ADRESSE_ID int(11),
	LIGNE_TEL varchar(20) UNIQUE NOT NULL default '',
	LIGNE_OPT ENUM('option1','option3') NOT NULL default 'option1',
	LIGNE_STATE ENUM('new','building','ok','del') default 'new',
	LIGNE_IDLD varchar(20) NOT NULL default '',
	LIGNE_DTMOD timestamp(14),
	LIGNE_DTIN timestamp(14),
	LIGNE_DTFAC timestamp(14),
	LIGNE_DTOK timestamp(14),
	LIGNE_DTOUT timestamp(14),
	primary key (LIGNE_ID)
);

replace into SEQ values('LIGNE_ID',0,0,99999999,1,'0');

drop table if exists ADRESSE;
create table ADRESSE (
	ADRESSE_ID int(11) UNIQUE NOT NULL default '0',
	ADRESSE_NOM varchar(70),
	ADRESSE_ADR text,
	ADRESSE_CP  varchar(10),
	ADRESSE_VILLE varchar(70),
	ADRESSE_MAIL varchar(70),
	ADRESSE_TEL varchar(80),
	ADRESSE_FAX varchar(80),
	primary key(ADRESSE_ID)
);

replace into ADRESSE values(1, "Neuronexion", "57, route de Paris", "80000", "Amiens", "nnx@nnx.com", '', '');
replace into ADRESSE values(2, "Metaconsult SARL", "221, rue Lafayette", "75010", "Paris", "", '', '' );
replace into ADRESSE values(3, "GlobeNet", "", "", "Paris", "", '', '');

-- Les 200 premiers identifiants sont reserves pour les
-- adresses des gens qu'on cree a la main
replace into SEQ values('ADRESSE_ID',200,0,99999999,1,'0');

drop table if exists PRIX;
create table PRIX (
	PRIX_ID int(11) UNIQUE NOT NULL default '0',
	PRIX_NOM varchar(255),
	PRIX_FASHT int(11),
	PRIX_ABOHT int(11),
	PRIX_FASTTC int(11),
	PRIX_ABOTTC int(11),
	PRIX_TVA ENUM('196','55','0'),
	primary key (PRIX_ID)
);
--                             Nom                         FAS HT   ABO HT   FAS TTC   ABO TTC   TVA     
replace into PRIX values (  1, 'Particuliers 128k Opt1'   , 7525   , 1589   , 9000    , 1900    , '196' );
replace into PRIX values (  2, 'Particuliers 512k Opt1'   , 7525   , 2090   , 9000    , 2500    , '196' );
replace into PRIX values (  3, 'Particuliers 1M-2M Opt1'  , 7525   , 2592   , 9000    , 3100    , '196' );
replace into PRIX values (  4, 'Particuliers 3M-7M Opt1'  , 7525   , 3261   , 9000    , 3900    , '196' );
replace into PRIX values (  5, 'Particuliers 8M-20M Opt1' , 7525   , 3679   , 9000    , 4400    , '196' );
replace into PRIX values ( 11, 'Particuliers 128k Opt3'   , 7107   , 2090   , 8500    , 2500    , '196' );
replace into PRIX values ( 12, 'Particuliers 512k Opt3'   , 7107   , 2926   , 8500    , 3500    , '196' );
replace into PRIX values ( 13, 'Particuliers 1M-2M Opt3'  , 7107   , 3930   , 8500    , 4700    , '196' );
replace into PRIX values ( 14, 'Particuliers 3M-7M Opt3'  , 7107   , 5100   , 8500    , 6100    , '196' );

replace into PRIX values ( 21, 'Etudiants 128k Opt1'      , 5686   , 1463   , 6800    , 1750    , '196' );
replace into PRIX values ( 22, 'Etudiants 512k Opt1'      , 5686   , 1965   , 6800    , 2350    , '196' );
replace into PRIX values ( 23, 'Etudiants 1M-2M Opt1'     , 5686   , 2383   , 6800    , 2850    , '196' );
replace into PRIX values ( 24, 'Etudiants 3M-7M Opt1'     , 5686   , 3052   , 6800    , 3650    , '196' );
replace into PRIX values ( 25, 'Etudiants 8M-20M Opt1'    , 5686   , 3428   , 6800    , 4100    , '196' );
replace into PRIX values ( 31, 'Etudiants 128k Opt3'      , 5435   , 1923   , 6500    , 2300    , '196' );
replace into PRIX values ( 32, 'Etudiants 512k Opt3'      , 5435   , 2759   , 6500    , 3300    , '196' );
replace into PRIX values ( 33, 'Etudiants 1M-2M Opt3'     , 5435   , 3595   , 6500    , 4300    , '196' );
replace into PRIX values ( 34, 'Etudiants 3M-7M Opt3'     , 5435   , 4766   , 6500    , 5700    , '196' );

replace into PRIX values ( 41, 'Associations 128k Opt1'   , 8361   , 1839   , 10000   , 2200    , '196' );
replace into PRIX values ( 42, 'Associations 512k Opt1'   , 8361   , 2341   , 10000   , 2800    , '196' );
replace into PRIX values ( 43, 'Associations 1M-2M Opt1'  , 8361   , 2759   , 10000   , 3300    , '196' );
replace into PRIX values ( 44, 'Associations 3M-7M Opt1'  , 8361   , 3512   , 10000   , 4200    , '196' );
replace into PRIX values ( 45, 'Associations 8M-20M Opt3' , 8361   , 4013   , 10000   , 4800    , '196' );
replace into PRIX values ( 51, 'Associations 128k Opt3'   , 8361   , 2258   , 10000   , 2700    , '196' );
replace into PRIX values ( 52, 'Associations 512k Opt3'   , 8361   , 3177   , 10000   , 3800    , '196' );
replace into PRIX values ( 53, 'Associations 1M-2M Opt3'  , 8361   , 4181   , 10000   , 5000    , '196' );
replace into PRIX values ( 54, 'Associations 3M-7M Opt3'  , 8361   , 5518   , 10000   , 6600    , '196' );

replace into PRIX values ( 61, 'Entreprises 128k Opt1'    , 9000   , 1900   , 10764   , 2272    , '196' );
replace into PRIX values ( 62, 'Entreprises 512k Opt1'    , 9000   , 2500   , 10764   , 2990    , '196' );
replace into PRIX values ( 63, 'Entreprises 1M-2M Opt1'   , 9000   , 3100   , 10764   , 3708    , '196' );
replace into PRIX values ( 64, 'Entreprises 3M-7M Opt1'   , 9000   , 3900   , 10764   , 4664    , '196' );
replace into PRIX values ( 65, 'Entreprises 8M-20M Opt1'  , 9000   , 4400   , 10764   , 5262    , '196' );
replace into PRIX values ( 71, 'Entreprises 128k Opt3'    , 8500   , 2500   , 10166   , 2990    , '196' );
replace into PRIX values ( 72, 'Entreprises 512k Opt3'    , 8500   , 3500   , 10166   , 4186    , '196' );
replace into PRIX values ( 73, 'Entreprises 1M-2M Opt3'   , 8500   , 4700   , 10166   , 5621    , '196' );
replace into PRIX values ( 74, 'Entreprises 3M-7M Opt3'   , 8500   , 6100   , 10166   , 7296    , '196' );

replace into PRIX values ( 81, 'Adhsion'                 , 1524   , 1524   , 1524    , 1524    , '0'   );
replace into PRIX values ( 82, 'Adhsion ADSL'            , -1524  , 1524   , -1524   , 1524    , '0'   );
replace into PRIX values ( 83, 'Adhsion tudiant'        , 152    , 152    , 152     , 152     , '0'   );
replace into PRIX values ( 84, 'Adhsion ADSL tudiant'   , -152   , 152    , -152    , 152     , '0'   );

replace into PRIX values ( 91, 'Etudiants RTC'            , 0      ,  309   , 0       ,  370    , '196' );
replace into PRIX values ( 92, 'Particuliers RTC'         , 0      ,  385   , 0       ,  460    , '196' );
replace into PRIX values ( 93, 'Associations RTC'         , 0      , 1274   , 0       , 1524    , '196' );
replace into PRIX values ( 94, 'Entreprises RTC'          , 0      , 3186   , 0       , 3811    , '196' );

replace into PRIX values (101, 'Entreprises Hebergement'  , 0      , 2549   , 0       , 3049    , '196' );
replace into PRIX values (102, 'Remise abonnes Cegetel'   , -5300  , -1300  , -6339   , -1555   , '196' );

replace into PRIX values (111, 'Rejet prlvement'        , 511    , 0      , 612     , 0       , '196' );
replace into PRIX values (112, 'Chgmt interface opt3'     , 34300  , 0      , 41023   , 0       , '196' );
replace into PRIX values (113, 'Demenagemt opt3'          , 5300   , 0      , 6339    , 0       , '196' );
replace into PRIX values (114, 'Modif ping opt3'          , 2090   , 109    , 2500    , 130     , '196' );
replace into PRIX values (115, 'Annulation cde opt3'      , 5300   , 0      , 6339    , 0       , '196' );
replace into PRIX values (116, 'Demenagemt opt1'          , 5500   , 0      , 6578    , 0       , '196' );
replace into PRIX values (117, 'Resiliation acces opt1'   , 3500   , 0      , 4186    , 0       , '196' );
replace into PRIX values (118, 'Chgmt interface opt1'     , 5300   , 0      , 6339    , 0       , '196' );
replace into PRIX values (119, 'Commande a tort opt1'     , 4100   , 0      , 4904    , 0       , '196' );
replace into PRIX values (120, 'Intervention a tort opt1' , 12277  , 0      , 14683   , 0       , '196' );

replace into PRIX values (201, 'Particuliers Opt0'        , 7525   , 1923   , 9000    , 2300    , '196' );
replace into PRIX values (202, 'Particuliers 512k Opt1'   , 7525   , 2090   , 9000    , 2500    , '196' );
replace into PRIX values (203, 'Particuliers ADSL Opt1'   , 7525   , 2425   , 9000    , 2900    , '196' );
replace into PRIX values (204, 'Particuliers ADSL Opt3'   , 6689   , 3428   , 8000    , 4100    , '196' );
replace into PRIX values (205, 'Particuliers ADSL 2+ Opt3', 6689   , 3428   , 8000    , 4100    , '196' );
replace into PRIX values (206, 'Particuliers ADSL Opt5'   , 6689   , 3428   , 8000    , 4100    , '196' );
replace into PRIX values (207, 'Particuliers ADSL 2+ Opt5', 6689   , 3428   , 8000    , 4100    , '196' );
replace into PRIX values (208, 'Particuliers ADSL DT'     , 7525   , 3512   , 9000    , 4200    , '196' );

replace into PRIX values (211, 'Etudiants Opt0'           , 5686   , 1672   , 6800    , 2000    , '196' );
replace into PRIX values (212, 'Etudiants 512k Opt1'      , 5686   , 1965   , 6800    , 2350    , '196' );
replace into PRIX values (213, 'Etudiants ADSL Opt1'      , 5686   , 2258   , 6800    , 2700    , '196' );
replace into PRIX values (214, 'Etudiants ADSL Opt3'      , 5351   , 3010   , 6400    , 3600    , '196' );
replace into PRIX values (215, 'Etudiants ADSL 2+ Opt3'   , 5351   , 3010   , 6400    , 3600    , '196' );
replace into PRIX values (216, 'Etudiants ADSL Opt5'      , 5351   , 3010   , 6400    , 3600    , '196' );
replace into PRIX values (217, 'Etudiants ADSL 2+ Opt5'   , 5351   , 3010   , 6400    , 3600    , '196' );
replace into PRIX values (218, 'Etudiants ADSL DT'        , 5686   , 2508   , 6800    , 3000    , '196' );

replace into PRIX values (221, 'Associations Opt0'        , 7860   , 2007   , 9400    , 2400    , '196' );
replace into PRIX values (222, 'Associations 512k Opt1'   , 7860   , 2341   , 9400    , 2800    , '196' );
replace into PRIX values (223, 'Associations ADSL Opt1'   , 7860   , 2759   , 9400    , 3300    , '196' );
replace into PRIX values (224, 'Associations ADSL Opt3'   , 7191   , 3512   , 8600    , 4200    , '196' );
replace into PRIX values (225, 'Associations ADSL 2+ Opt3', 7191   , 3512   , 8600    , 4200    , '196' );
replace into PRIX values (226, 'Associations ADSL Opt5'   , 7191   , 3512   , 8600    , 4200    , '196' );
replace into PRIX values (227, 'Associations ADSL 2+ Opt5', 7191   , 5100   , 8600    , 6100    , '196' );
replace into PRIX values (228, 'Associations ADSL DT'     , 7860   , 3512   , 9400    , 4200    , '196' );

replace into PRIX values (231, 'Entreprises Opt0'         , 9000   , 2300   , 10764   , 2751    , '196' );
replace into PRIX values (232, 'Entreprises 512k Opt1'    , 9000   , 2500   , 10764   , 2990    , '196' );
replace into PRIX values (233, 'Entreprises ADSL Opt1'    , 9000   , 2900   , 10764   , 3468    , '196' );
replace into PRIX values (234, 'Entreprises ADSL Opt3'    , 8000   , 4100   , 9568    , 4904    , '196' );
replace into PRIX values (235, 'Entreprises ADSL 2+ Opt3' , 8000   , 4100   , 9568    , 4904    , '196' );
replace into PRIX values (236, 'Entreprises ADSL Opt5'    , 8000   , 4100   , 9568    , 4904    , '196' );
replace into PRIX values (237, 'Entreprises ADSL 2+ Opt5' , 8000   , 4100   , 9568    , 4904    , '196' );
replace into PRIX values (238, 'Entreprises ADSL DT'      , 9000   , 4200   , 10764   , 5023    , '196' );



-- Offre marque blanche
replace into PRIX values (241, 'Blanche Opt1'             , 7000   , 2150   , 8372    , 2571    , '196' );
replace into PRIX values (242, 'Blanche Opt3'             , 6500   , 2950   , 7774    , 3528    , '196' );

replace into PRIX values (251, 'Collecte Opt1'            , 7000   , 1850   , 8372    , 2213    , '196' );
replace into PRIX values (254, 'Collecte Opt3'            , 6500   , 2650   , 7774    , 3169    , '196' );

replace into PRIX values (301, 'Reste Opt1'               , 0      , 1800   , 0       , 2153    , '196' );
replace into PRIX values (302, 'Reste Opt3'               , 0      , 2600   , 0       , 3110    , '196' );
replace into PRIX values (303, 'Dmnagement 1'           , 6271   , 0      , 7500    , 0       , '196' );
replace into PRIX values (304, 'Dmnagement 1/3'         , 2090   , 0      , 2500    , 0       , '196' );

replace into PRIX values (401, 'Transit mensuel 1Mb/s'    , 3000   , 0      , 3588    , 0       , '196' );
replace into PRIX values (402, 'Transit mensuel 2Mb/s'    , 6000   , 0      , 7176    , 0       , '196' );
replace into PRIX values (403, 'Transit mensuel 3Mb/s'    , 9000   , 0      , 10764   , 0       , '196' );
replace into PRIX values (404, 'Transit mensuel 4Mb/s'    , 12000  , 0      , 14352   , 0       , '196' );
replace into PRIX values (405, 'Transit mensuel 5Mb/s'    , 15000  , 0      , 17940   , 0       , '196' );
replace into PRIX values (406, 'Transit mensuel 6Mb/s'    , 18000  , 0      , 21528   , 0       , '196' );
replace into PRIX values (407, 'Transit mensuel 7Mb/s'    , 21000  , 0      , 25116   , 0       , '196' );
replace into PRIX values (408, 'Transit mensuel 8Mb/s'    , 24000  , 0      , 28704   , 0       , '196' );
replace into PRIX values (409, 'Transit mensuel 9Mb/s'    , 27000  , 0      , 32292   , 0       , '196' );
replace into PRIX values (410, 'Transit mensuel 10Mb/s'   , 30000  , 0      , 35880   , 0       , '196' );
replace into PRIX values (411, 'Transit mensuel 11Mb/s'   , 33000  , 0      , 39468   , 0       , '196' );



replace into SEQ values('PRIX_ID',420,0,99999999,1,'0');

drop table if exists DEBIT;
create table DEBIT (
	DEBIT_ID int(11) UNIQUE NOT NULL default '0',
	DEBIT_NOM varchar(70),
	DEBIT_DEBIT ENUM('128k','512k','512RE','1M','2M','3M','4M','5M','6M','7M','8M','10M','14M','18M', '20M'),
	primary key (DEBIT_ID)
);

replace into DEBIT values( 1, '128k/64k', '128k');
replace into DEBIT values( 2, '512k/128k','512k');
replace into DEBIT values( 3, '1M/256k' , '1M');
replace into DEBIT values( 4, '2M/256k' , '2M');
replace into DEBIT values( 5, '3M/256k' , '3M');
replace into DEBIT values( 6, '4M/256k' , '4M');
replace into DEBIT values( 7, '5M/512k' , '5M');
replace into DEBIT values( 8, '6M/512k' , '6M');
replace into DEBIT values( 9, '7M/512k' , '7M');
replace into DEBIT values(10, '8M/860k' , '8M');
replace into DEBIT values(11, '10M/860k', '10M');
replace into DEBIT values(12, '14M/860k', '14M');
replace into DEBIT values(13, '18M/860k', '18M');
replace into DEBIT values(14, '20M/860k', '20M');
replace into DEBIT values(15, '512k/128kRE', '512RE');

replace into SEQ values('DEBIT_ID',20,0,99999999,1,'0');

drop table if exists PRIXDEBIT;
create table PRIXDEBIT (
	PRIX_ID int(11) NOT NULL default '0',
	DEBIT_ID int(11) NOT NULL default '0',
	PRIXDEBIT_TYPE enum('particulier','etudiant','association','entreprise','fai'),
	PRIXDEBIT_OPTION enum('option0','option1','option3','option5'),
	index (PRIX_ID),
	index (DEBIT_ID),
	index (PRIX_ID,DEBIT_ID)
);



-- ajout des tarifs pour le 512k RE - applique le 27/10/2009 sur la base de prod

delete from PRIXDEBIT;
-- Les prix des 128k
-- Les prix des 512k
insert into PRIXDEBIT values (202, 2, 'particulier', 'option1');
insert into PRIXDEBIT values (212, 2, 'etudiant'   , 'option1');
insert into PRIXDEBIT values (222, 2, 'association', 'option1');
insert into PRIXDEBIT values (232, 2, 'entreprise' , 'option1');
insert into PRIXDEBIT values (241, 2, 'blanche'    , 'option1');
insert into PRIXDEBIT values (251, 2, 'collecte'   , 'option1');
insert into PRIXDEBIT values (204, 2, 'particulier', 'option3');
insert into PRIXDEBIT values (214, 2, 'etudiant'   , 'option3');
insert into PRIXDEBIT values (224, 2, 'association', 'option3');
insert into PRIXDEBIT values (234, 2, 'entreprise' , 'option3');
insert into PRIXDEBIT values (242, 2, 'blanche'    , 'option3');
insert into PRIXDEBIT values (252, 2, 'collecte'   , 'option3');
insert into PRIXDEBIT values (204, 2, 'particulier', 'option5');
insert into PRIXDEBIT values (214, 2, 'etudiant'   , 'option5');
insert into PRIXDEBIT values (224, 2, 'association', 'option5');
insert into PRIXDEBIT values (234, 2, 'entreprise' , 'option5');
insert into PRIXDEBIT values (242, 2, 'blanche'    , 'option5');
insert into PRIXDEBIT values (252, 2, 'collecte'   , 'option5');
-- Les prix des 512kRE
insert into PRIXDEBIT values (204, 15, 'particulier', 'option5');
insert into PRIXDEBIT values (214, 15, 'etudiant'   , 'option5');
insert into PRIXDEBIT values (224, 15, 'association', 'option5');
insert into PRIXDEBIT values (234, 15, 'entreprise' , 'option5');
insert into PRIXDEBIT values (242, 15, 'blanche'    , 'option5');
insert into PRIXDEBIT values (252, 15, 'collecte'   , 'option5');
-- Les prix des 1M
insert into PRIXDEBIT values (203, 3, 'particulier', 'option1');
insert into PRIXDEBIT values (213, 3, 'etudiant'   , 'option1');
insert into PRIXDEBIT values (223, 3, 'association', 'option1');
insert into PRIXDEBIT values (233, 3, 'entreprise' , 'option1');
insert into PRIXDEBIT values (241, 3, 'blanche'    , 'option1');
insert into PRIXDEBIT values (251, 3, 'collecte'   , 'option1');
insert into PRIXDEBIT values (204, 3, 'particulier', 'option3');
insert into PRIXDEBIT values (214, 3, 'etudiant'   , 'option3');
insert into PRIXDEBIT values (224, 3, 'association', 'option3');
insert into PRIXDEBIT values (234, 3, 'entreprise' , 'option3');
insert into PRIXDEBIT values (242, 3, 'blanche'    , 'option3');
insert into PRIXDEBIT values (252, 3, 'collecte'   , 'option3');
insert into PRIXDEBIT values (204, 3, 'particulier', 'option5');
insert into PRIXDEBIT values (214, 3, 'etudiant'   , 'option5');
insert into PRIXDEBIT values (224, 3, 'association', 'option5');
insert into PRIXDEBIT values (234, 3, 'entreprise' , 'option5');
insert into PRIXDEBIT values (242, 3, 'blanche'    , 'option5');
insert into PRIXDEBIT values (252, 3, 'collecte'   , 'option5');
-- Les prix des 2M
insert into PRIXDEBIT values (203, 4, 'particulier', 'option1');
insert into PRIXDEBIT values (204, 4, 'particulier', 'option3');
insert into PRIXDEBIT values (213, 4, 'etudiant'   , 'option1');
insert into PRIXDEBIT values (214, 4, 'etudiant'   , 'option3');
insert into PRIXDEBIT values (223, 4, 'association', 'option1');
insert into PRIXDEBIT values (224, 4, 'association', 'option3');
insert into PRIXDEBIT values (233, 4, 'entreprise' , 'option1');
insert into PRIXDEBIT values (234, 4, 'entreprise' , 'option3');
insert into PRIXDEBIT values (241, 4, 'blanche'    , 'option1');
insert into PRIXDEBIT values (251, 4, 'collecte'   , 'option1');
insert into PRIXDEBIT values (242, 4, 'blanche'    , 'option3');
insert into PRIXDEBIT values (252, 4, 'collecte'   , 'option3');
-- Les prix des 3M
insert into PRIXDEBIT values (204, 5, 'particulier', 'option3');
insert into PRIXDEBIT values (214, 5, 'etudiant'   , 'option3');
insert into PRIXDEBIT values (224, 5, 'association', 'option3');
insert into PRIXDEBIT values (234, 5, 'entreprise' , 'option3');
insert into PRIXDEBIT values (242, 5, 'blanche'    , 'option3');
insert into PRIXDEBIT values (252, 5, 'collecte'   , 'option3');
-- Les prix des 4M
insert into PRIXDEBIT values (204, 6, 'particulier', 'option3');
insert into PRIXDEBIT values (214, 6, 'etudiant'   , 'option3');
insert into PRIXDEBIT values (224, 6, 'association', 'option3');
insert into PRIXDEBIT values (234, 6, 'entreprise' , 'option3');
insert into PRIXDEBIT values (242, 6, 'blanche'    , 'option3');
insert into PRIXDEBIT values (252, 6, 'collecte'   , 'option3');
-- Les prix des 5M
insert into PRIXDEBIT values (204, 7, 'particulier', 'option3');
insert into PRIXDEBIT values (214, 7, 'etudiant'   , 'option3');
insert into PRIXDEBIT values (224, 7, 'association', 'option3');
insert into PRIXDEBIT values (234, 7, 'entreprise' , 'option3');
insert into PRIXDEBIT values (242, 7, 'blanche'    , 'option3');
insert into PRIXDEBIT values (252, 7, 'collecte'   , 'option3');
-- Les prix des 6M
insert into PRIXDEBIT values (204, 8, 'particulier', 'option3');
insert into PRIXDEBIT values (214, 8, 'etudiant'   , 'option3');
insert into PRIXDEBIT values (224, 8, 'association', 'option3');
insert into PRIXDEBIT values (234, 8, 'entreprise' , 'option3');
insert into PRIXDEBIT values (242, 8, 'blanche'    , 'option3');
insert into PRIXDEBIT values (242, 8, 'collecte'   , 'option3');
-- Les prix des 7M
-- Les prix des 8M
insert into PRIXDEBIT values (203, 10, 'particulier', 'option1');
insert into PRIXDEBIT values (213, 10, 'etudiant'   , 'option1');
insert into PRIXDEBIT values (223, 10, 'association', 'option1');
insert into PRIXDEBIT values (233, 10, 'entreprise' , 'option1');
insert into PRIXDEBIT values (241, 10, 'blanche'    , 'option1');
insert into PRIXDEBIT values (251, 10, 'collecte'   , 'option1');
-- Les prix des 10M
-- Les prix des 14M
-- Les prix des 18M
insert into PRIXDEBIT values (203, 13, 'particulier', 'option1');
insert into PRIXDEBIT values (213, 13, 'etudiant'   , 'option1');
insert into PRIXDEBIT values (223, 13, 'association', 'option1');
insert into PRIXDEBIT values (233, 13, 'entreprise' , 'option1');
insert into PRIXDEBIT values (241, 13, 'blanche'    , 'option1');
insert into PRIXDEBIT values (251, 13, 'collecte'   , 'option1');
insert into PRIXDEBIT values (207, 13, 'particulier', 'option5');
insert into PRIXDEBIT values (217, 13, 'etudiant'   , 'option5');
insert into PRIXDEBIT values (227, 13, 'association', 'option5');
insert into PRIXDEBIT values (237, 13, 'entreprise' , 'option5');
insert into PRIXDEBIT values (242, 13, 'blanche'    , 'option5');
insert into PRIXDEBIT values (252, 13, 'collecte'   , 'option5');
insert into PRIXDEBIT values (201, 13, 'particulier', 'option0');
insert into PRIXDEBIT values (211, 13, 'etudiant'   , 'option0');
insert into PRIXDEBIT values (221, 13, 'association', 'option0');
insert into PRIXDEBIT values (231, 13, 'entreprise' , 'option0');
-- Les prix des 20M

drop table if exists LIGNEPRIX;

drop table if exists TARIF;

drop table if exists CLIENT;
create table CLIENT (
	CLIENT_ID int(11) NOT NULL default '0',
	PRELEVEMT_ID int(11) NOT NULL default '-1',
	ADRESSE_ID int(11) NOT NULL default '-1',
	CLIENT_NOM varchar(70),
	CLIENT_NUMADH int(11) NOT NULL default '-1',
	CLIENT_TYPE ENUM('particulier','etudiant','association','entreprise','blanche','collecte'),
	CLIENT_ETAT ENUM('actif','resilie') NOT NULL default 'actif',
	primary key (CLIENT_ID),
	index(ADRESSE_ID),
	index(PRELEVEMT_ID),
	index(CLIENT_NOM),
	index(CLIENT_NUMADH)
);

replace into CLIENT values(1, -1, 1, 'Neuronexion', -1, 'blanche', 'actif');
replace into CLIENT values(2, -1, 2, 'Metaconsult', -1, 'blanche', 'actif');

-- Les 200 premiers identifiants sont reserves pour les gens qu'on
-- cree a la main, type Neuronexion ou anciens adherents.
replace into SEQ values('CLIENT_ID',200,0,99999999,1,'0');
replace into SEQ values('adh',409,0,99999999,1,'0');
replace into SEQ values('fix-task',0,0,99999999,1,'0');

drop table if exists ADHACCESS;
create table ADHACCESS (
	ADHACCESS_ID int(11) NOT NULL default '0',
	ADHACCESS_LOGIN varchar(20) NOT NULL default '',
	ADHACCESS_PASSWD varchar(20) NOT NULL default '',
	CLIENT_ID int(11) NOT NULL default '-1',
	primary key(ADHACCESS_ID),
	index(ADHACCESS_LOGIN),
	index(CLIENT_ID)
);

replace into SEQ values('ADHACCESS_ID',0,0,99999999,1,'0');

drop table if exists CLIENTLIGNE;

drop table if exists DEPLOIEMENT;
create table DEPLOIEMENT (
	DEPLOIEMENT_ID int(11) UNIQUE NOT NULL default '0',
	LIGNE_ID int(11) NOT NULL default '0',
	TASK_ID int(11) NOT NULL default '-1',
	DEPLOIEMENT_NUM varchar(15) UNIQUE NOT NULL,
	DEPLOIEMENT_DTMOD timestamp(14),
	DEPLOIEMENT_DTSTART timestamp(14),
	DEPLOIEMENT_DTFAS timestamp(14),
	DEPLOIEMENT_DTCDE timestamp(14),
	DEPLOIEMENT_DTRAD timestamp(14),
	DEPLOIEMENT_DTAR timestamp(14),
	DEPLOIEMENT_DTCR timestamp(14),
	DEPLOIEMENT_DTFIN timestamp(14),
	primary key (DEPLOIEMENT_ID),
	index(LIGNE_ID),
	index(DEPLOIEMENT_NUM)
);

replace into SEQ values('DEPLOIEMENT_ID',0,0,99999999,1,'0');

drop table if exists MANDAT;
create table MANDAT (
	MANDAT_ID int(11) UNIQUE NOT NULL default '0',
	MANDAT_DETENTEUR varchar(70) NOT NULL default 'fdn',
	MANDAT_NUMERO varchar(20) NOT NULL default 'invalid',
	MANDAT_FICHIER varchar(70) NOT NULL default 'invalid',
	MANDAT_IMAGE varchar(70) NOT NULL default 'invalid',
	DEPLOIEMENT_ID int(11) NOT NULL default '-1',
	primary key(MANDAT_ID),
	index(DEPLOIEMENT_ID),
	index(MANDAT_NUMERO)
);

replace into SEQ values('MANDAT_ID',0,0,99999999,1,'0');

drop table if exists ELIGIBILITE;
create table ELIGIBILITE (
	ELIGIBILITE_ID int(11) UNIQUE NOT NULL default '0',
	ELIGIBILITE_TEL varchar(70) default NULL,
	ELIGIBILITE_OFFRE varchar(20),
	ELIGIBILITE_REPONSE text,
	ELIGIBILITE_DTTEST timestamp(14) NOT NULL,
	PRIMARY KEY (ELIGIBILITE_ID)
);

replace into SEQ values('ELIGIBILITE_ID',0,0,99999999,1,'0');

drop table if exists CREANCE;
create table CREANCE (
	CREANCE_ID int(11) UNIQUE NOT NULL default '0',
	CLIENT_ID int(11) NOT NULL,
	FACTURE_ID int(11) NOT NULL default '-1',
	PRLLIG_ID int(11) NOT NULL default '-1',
	CLOTURE_ID int(11),
	CREANCE_HT int(11),
	CREANCE_TTC int(11),
	CREANCE_TVA ENUM('196','55','0'),
	CREANCE_LIBELLE text,
	CREANCE_ETAT enum('payee','facturee','due','annulee') NOT NULL default 'due',
	CREANCE_DTMOD timestamp(14),
	CREANCE_DATEDUE timestamp(14),
	CREANCE_DATEPAYEE timestamp(14),
	primary key(CREANCE_ID),
	index(CLIENT_ID),
	index(FACTURE_ID),
	index(CLOTURE_ID)
);

replace into SEQ values('CREANCE_ID',0,0,99999999,1,'0');

drop table if exists FACTURE;
create table FACTURE (
	FACTURE_ID int(11) UNIQUE NOT NULL default '0',
	CLIENT_ID int(11) NOT NULL,
	FACTURE_NUM varchar(70),
	FACTURE_ETAT enum('due','envoyee','payee') NOT NULL default 'due',
	FACTURE_DTMOD timestamp(14),
	FACTURE_DATE timestamp(14),
	FACTURE_PAYEE timestamp(14),
	primary key(FACTURE_ID),
	index(CLIENT_ID),
	index(FACTURE_ETAT)
);

replace into SEQ values('FACTURE_ID',0,0,99999999,1,'0');

drop table if exists PAIEMENT;
create table PAIEMENT (
	PAIEMENT_ID int(11) UNIQUE NOT NULL default '0',
	PAIEMENT_LIBELLE varchar(70),
	PAIEMENT_TYPE enum('cb','chq','liq') NOT NULL default 'chq',
	PAIEMENT_NUM varchar(100),
	PAIEMENT_DTMOD timestamp(14),
	PAIEMENT_DATE timestamp(14) default '0000-00-00 00:00:00',
	CLIENT_ID int(11) NOT NULL default '-1',
	PAIEMENT_TTC int(11),
	PAIEMENT_ETAT enum('ok','ko'),
	primary key(PAIEMENT_ID),
	index(CLIENT_ID),
	index(PAIEMENT_NUM)
);

replace into SEQ values('PAIEMENT_ID',0,0,99999999,1,'0');

drop table if exists CLOTURE;
create table CLOTURE (
	CLOTURE_ID int(11) UNIQUE NOT NULL default '0',
	CLOTURE_DATE varchar(10) UNIQUE NOT NULL default '200001',
	primary key(CLOTURE_ID),
	index(CLOTURE_DATE)
);

replace into CLOTURE values('1','200001');
replace into SEQ values('CLOTURE_ID',2,0,99999999,1,'0');

drop table if exists PRELEVEMT;
create table PRELEVEMT (
	PRELEVEMT_ID int(11) UNIQUE NOT NULL default '0',
	ADRESSE_ID int(11),
	PRELEVEMT_BANQUE varchar(10),
	PRELEVEMT_GUICHET varchar(10),
	PRELEVEMT_COMPTE varchar(15),
	PRELEVEMT_RIB varchar(2),
	PRELEVEMT_TITULAIRE varchar(24),
	PRELEVEMT_DOMICIL varchar(24),
	PRELEVEMT_ETAT enum ('ok','susp','del'),
	primary key (PRELEVEMT_ID)
);

-- Les 100 premiers prelevements sont reserves pour les anciens adherents.
replace into SEQ values('PRELEVEMT_ID',100,0,99999999,1,'0');

drop table if exists PRLBQ;
create table PRLBQ (
	PRLBQ_ID int(11) UNIQUE NOT NULL default '0',
	PRLBQ_NOM varchar(70),
	PRLBQ_DATE varchar(10),
	PRLBQ_FICHIER text,
	PRLBQ_ETAT enum('du','envoye','paye') NOT NULL default 'du',
	primary key(PRLBQ_ID)
);

replace into SEQ values('PRLBQ_ID',0,0,99999999,1,'0');

drop table if exists PRLLIG;
create table PRLLIG (
	PRLLIG_ID int(11) UNIQUE NOT NULL default '0',
	PRLBQ_ID int(11),
	CLIENT_ID int(11),
	PRLLIG_BANQUE varchar(10),
	PRLLIG_GUICHET varchar(10),
	PRLLIG_COMPTE varchar(20),
	PRLLIG_MONTANT int(11),
	PRLLIG_LIBELLE varchar(70) NOT NULL default '',
	PRLLIG_TITULAIRE varchar(24) NOT NULL default '',
	PRLLIG_DOMICIL varchar(24) NOT NULL default '',
	PRLLIG_ETAT enum ('ok','rejet','paye'),
	primary key(PRLLIG_ID),
	index(PRLBQ_ID),
	index(CLIENT_ID)
);

replace into SEQ values('PRLLIG_ID',0,0,99999999,1,'0');

drop table if exists TVA;
create table TVA (
	TVA_ID int(11) UNIQUE NOT NULL default '0',
	TVA_MONTANT int(11) NOT NULL default '0',
	TVA_SOURCE varchar(70),
	TVA_ETAT enum('due','envoyee','payee'),
	primary key (TVA_ID)
);

replace into SEQ values('TVA_ID',0,0,99999999,1,'0');

drop table if exists TVADCL;
create table TVADCL (
	TVADCL_ID int(11) UNIQUE NOT NULL default '0',
	TVADCL_MONTANT int(11) NOT NULL default '0',
	TVADCL_DATE timestamp(14) NOT NULL,
	primary key (TVADCL_ID)
);

replace into SEQ values('TVADCL_ID',0,0,99999999,1,'0');

drop table if exists INFO;
create table INFO (
	INFO_ID int(11) UNIQUE NOT NULL default '0',
	INFO_TYPE enum('inline','fichier') NOT NULL default 'inline',
	INFO_TITRE varchar(70),
	INFO_DTIN timestamp(14),
	INFO_VAL text,
	primary key (INFO_ID)
);

-- Les 100 premiers identifiants sont reserves pour les commentaires
-- sur les anciens adherents.
replace into SEQ values('INFO_ID',100,0,99999999,1,'0');

drop table if exists LIGNEINFO;
create table LIGNEINFO (
	LIGNE_ID int(11),
	INFO_ID int(11),
	index(LIGNE_ID),
	index(INFO_ID)
);

drop table if exists CLIENTINFO;
create table CLIENTINFO (
	CLIENT_ID int(11),
	INFO_ID int(11),
	index(CLIENT_ID),
	index(INFO_ID)
);

drop table if exists COMPTAINFO;
create table COMPTAINFO (
	COMPTA_ID int(11),
	INFO_ID int(11),
	index(COMPTA_ID),
	index(INFO_ID)
);

drop table if exists ORDRETD;
create table ORDRETD (
	ORDRETD_ID int(11) UNIQUE NOT NULL default '0',
	ORDRETD_ETAT enum('new','sent','ok','ko') NOT NULL default 'new',
	ORDRETD_LIGNE text,
	ORDRETD_FICHIER varchar(30),
	ORDRETD_DTMOD timestamp(14),
	ORDRETD_DTIN timestamp(14),
	primary key (ORDRETD_ID),
	index(ORDRETD_ETAT),
	index(ORDRETD_FICHIER)
);

replace into SEQ values('ORDRETD_ID',0,0,99999999,1,'0');

drop table if exists SCANNER;
delete from SEQ where SEQ_NAME = 'SCANNER_ID';

drop table if exists PAYANT;
create table PAYANT (
	PAYANT_ID int(11) UNIQUE NOT NULL default '0',
	PAYANT_LIBELLE varchar(80),
	PAYANT_TYPE varchar(50),
	PAYANT_DTMOD timestamp(14),
	PAYANT_DATE timestamp(14),
	PAYANT_DEBUT timestamp(14),
	PAYANT_FIN timestamp(14),
	PRIX_ID int(11),
	CLIENT_ID int(11),
	primary key (PAYANT_ID),
	index(CLIENT_ID)
);

-- Les 100 premiers identifiants sont reserves pour les adhesions
-- et les abonnements des anciens adherents.
replace into SEQ values('PAYANT_ID',100,0,99999999,1,'0');

drop table if exists RADUSER;
create table RADUSER (
	RADUSER_ID    int(11) UNIQUE NOT NULL default '0',
	RADUSER_LOGIN varchar(64),
	RADGROUP_ID    int(11) NOT NULL default '1',
	LIGNE_ID       int(11) NOT NULL default '-1',
	primary key(RADUSER_ID),
	index(RADUSER_LOGIN),
	index(LIGNE_ID)
);

replace into SEQ values('RADUSER_ID',0,0,99999999,1,'0');

drop table if exists RADGROUP;
create table RADGROUP (
	RADGROUP_ID  int(11) UNIQUE NOT NULL default '0',
	RADGROUP_NOM varchar(255),
	primary key(RADGROUP_ID),
	index(RADGROUP_NOM)
);

replace into RADGROUP values (1, 'ADSL IP fixe');
replace into RADGROUP values (2, 'RTC UUCP');

replace into SEQ values('RADGROUP_ID',2,0,99999999,1,'0');

drop table if exists UATTR;
create table UATTR (
	UATTR_ID    int(11) UNIQUE NOT NULL default '0',
	UATTR_ATTR  varchar(32) NOT NULL default '',
	UATTR_OP    char(2) NOT NULL default '==',
	UATTR_VALUE varchar(253) NOT NULL default '',
	UATTR_TYPE  varchar(10),
	RADUSER_ID  int(11),
	primary key(UATTR_ID),
	index(RADUSER_ID),
	index(UATTR_TYPE),
	index(RADUSER_ID,UATTR_TYPE)
);

replace into SEQ values('UATTR_ID',0,0,99999999,1,'0');

drop table if exists GATTR;
create table GATTR (
	GATTR_ID    int(11) UNIQUE NOT NULL default '0',
	GATTR_ATTR  varchar(32) NOT NULL default '',
	GATTR_OP    char(2) NOT NULL default '==',
	GATTR_VALUE varchar(253) NOT NULL default '',
	GATTR_TYPE  varchar(10),
	RADGROUP_ID int(11),
	primary key(GATTR_ID),
	index(RADGROUP_ID),
	index(GATTR_TYPE),
	index(RADGROUP_ID,GATTR_TYPE)
);

-- Le groupe 1: ADSL IP fixe
replace into GATTR values(1, 'Service-Type',      ':=', 'Framed-User'    , 'reply', 1);
replace into GATTR values(2, 'Framed-Protocol',   ':=', 'PPP'            , 'reply', 1);
replace into GATTR values(3, 'Framed-Routing',    ':=', 'None'           , 'reply', 1);

-- Le groupe 2: RTC UUCP
replace into GATTR values(11, 'Service-Type',     ':=', 'Login-User'     , 'reply', 2);
replace into GATTR values(12, 'Login-Host',       ':=', '80.67.169.12'   , 'reply', 2);
replace into GATTR values(13, 'Login-Service',    ':=', 'TCP-Clear'      , 'reply', 2);
replace into GATTR values(14, 'Login-TCP-Port',   ':=', '540'            , 'reply', 2);

replace into SEQ values('GATTR_ID',20,0,99999999,1,'0');

drop table if exists IPADDR;
create table IPADDR (
	IPADDR_ID    int(11) UNIQUE NOT NULL default '0',
	IPADDR_ADDR  varchar(64),
	IPADDR_MASK  varchar(64),
	IPADDR_TYPE  varchar(10),
	IPADDR_ETAT  varchar(10),
	RADUSER_ID   int(11) NOT NULL default '-1',
	primary key(IPADDR_ID),
	index(IPADDR_ETAT),
	index(IPADDR_TYPE),
	index(IPADDR_ETAT,IPADDR_TYPE),
	index(IPADDR_ADDR),
	index(RADUSER_ID)
);

replace into SEQ values('IPADDR_ID',0,0,99999999,1,'0');

drop table if exists COMPTA;
create table COMPTA (
	COMPTA_ID  int(11) UNIQUE NOT NULL default '0',
	COMPTA_NOM varchar(255),
	primary key(COMPTA_ID)
);

replace into SEQ values('COMPTA_ID',0,0,99999999,1,'0');




drop table if exists EVENT;
create table EVENT (
	EVENT_ID int(11) UNIQUE NOT NULL default '0',
	EVENT_EVENT varchar(90) UNIQUE NOT NULL default '',
	EVENT_DATE timestamp(14) NOT NULL,
	primary key  (EVENT_ID),
	index (EVENT_EVENT)
);

replace into SEQ values ('EVENT_ID',0,0,2147483647,1,'');

drop table if exists PROPEVENT;
create table PROPEVENT (
	PROPEVENT_ID int(11) UNIQUE NOT NULL default '0',
	EVENT_ID int(11) default NULL,
	PROPEVENT_NOM varchar(70) default NULL,
	PROPEVENT_VAL text,
	PROPEVENT_PAR int(11) default NULL,
	PROPEVENT_DTMOD timestamp(14) NOT NULL,
	PROPEVENT_DTIN timestamp(14) NOT NULL default '00000000000000',
	primary key  (PROPEVENT_ID),
	index(EVENT_ID)
);

replace into SEQ values ('PROPEVENT_ID',0,0,2147483647,1,'');

drop table if exists TASK;
create table TASK (
	TASK_ID int(11) UNIQUE NOT NULL default '0',
	TASK_TYPE varchar(20) NOT NULL default 'atomic',
	TASK_NAME varchar(20) NOT NULL default '',
	TASK_KEY varchar(80) UNIQUE NOT NULL default '',
	TASK_STATE enum('init','running','failed','done') default 'init',
	TASK_NBCHILD int(11) NOT NULL default '0',
	TASK_DTMOD timestamp(14) NOT NULL,
	TASK_DTIN timestamp(14) NOT NULL default '00000000000000',
	primary key  (TASK_ID),
	index (TASK_KEY)
);

replace into SEQ values ('TASK_ID',0,0,2147483647,1,'');

drop table if exists PROPTASK;
create table PROPTASK (
	PROPTASK_ID int(11) UNIQUE NOT NULL default '0',
	TASK_ID int(11) default NULL,
	PROPTASK_NOM varchar(70) default NULL,
	PROPTASK_VAL text,
	PROPTASK_PAR int(11) default NULL,
	PROPTASK_DTMOD timestamp(14) NOT NULL,
	PROPTASK_DTIN timestamp(14) NOT NULL default '00000000000000',
	primary key  (PROPTASK_ID),
	index (TASK_ID)
);

replace into SEQ values ('PROPTASK_ID',0,0,2147483647,1,'');

drop table if exists TASKSELF;
create table TASKSELF (
	TASK_ID int(11) NOT NULL default '0',
	SELF_ID int(11) NOT NULL default '0',
	TASKSELF_ORDER int(11) NOT NULL default '0',
	index (TASK_ID),
	index (SELF_ID),
	index (TASK_ID,SELF_ID)
);

drop table if exists RUN;
create table RUN (
	RUN_ID int(11) UNIQUE NOT NULL default '0',
	TASK_ID int(11) NOT NULL default '0',
	RUN_EVENT varchar(70) NOT NULL default '',
	RUN_DATE timestamp(14) NOT NULL,
	RUN_STATE enum('free','busy') NOT NULL default 'free',
	primary key  (RUN_ID),
	index(TASK_ID),
	index(RUN_EVENT)
);

replace into SEQ values ('RUN_ID',0,0,2147483647,1,'');

drop table if exists WAITING;
create table WAITING (
	WAITING_ID int(11) UNIQUE NOT NULL default '0',
	TASK_ID int(11) NOT NULL default '0',
	WAITING_EVENT varchar(70) NOT NULL default '',
	WAITING_DATE timestamp(14) NOT NULL,
	primary key  (WAITING_ID),
	index(TASK_ID),
	index(WAITING_EVENT)
);
replace into SEQ values ('WAITING_ID',0,0,2147483647,1,'');







drop table if exists PLUTAR;

create table PLUTAR (
	PLUTAR_ID	integer	not null	,
	PLUTAR_ACTION	varchar(128)		,
	PLUTAR_ETAT	enum('waiting','runing','done', 'failed', 'canceled'),
	
	PLUTAR_DTMOD	timestamp(14)			,
	PLUTAR_DTDO	timestamp(14)			,
	PLUTAR_DTWAIT	timestamp(14)			,
	PLUTAR_DTRUN	timestamp(14)			,
	PLUTAR_DTDONE	timestamp(14)			,
	PLUTAR_DTFAILED	timestamp(14)			,
	PLUTAR_CANCELED	timestamp(14)			,

	PLUTAR_NBRUN	integer	not null default 0	,
	
	PRIMARY KEY (PLUTAR_ID)	
);

replace into SEQ values ('PLUTAR_ID', 0, 0, 2147483647, 1, 0);

drop table if exists PROPPLUTAR;
create table PROPPLUTAR (
	PROPPLUTAR_ID int(11) NOT NULL default '0',
	PLUTAR_ID int(11) default NULL,
	PROPPLUTAR_NOM varchar(70) default NULL,
	PROPPLUTAR_VAL text,
	PROPPLUTAR_PAR int(11) default NULL,
	primary key(PROPPLUTAR_ID),
	index(PROPPLUTAR_NOM),
	index(PROPPLUTAR_VAL(100)),
	index(PROPPLUTAR_NOM,PROPPLUTAR_VAL(100)),
	index(PLUTAR_ID)
);


replace into SEQ values ('PROPPLUTAR_ID', 0, 0, 2147483647, 1, 0);

drop table if exists SITE;
create table SITE (
	SITE_ID int(11) NOT NULL default '0',
	SITE_SITE varchar(20),
	SITE_LOGIN varchar(20),
	SITE_PASSWD varchar(20),
	CLIENT_ID int(11) NOT NULL default '-1',
	primary key(SITE_ID),
	index(CLIENT_ID),
	index(SITE_LOGIN),
	index(SITE_SITE)
);

-- Les 100 premiers identifiants sont reserves pour les
-- anciens adherents. De toutes facons cette table n'est pas
-- bonne.
replace into SEQ values('SITE_ID', 100, 0, 2147483647, 1, 0);

drop table if exists DOMAINE;
create table DOMAINE (
	DOMAINE_ID int(11) NOT NULL default '0',
	DOMAINE_NOM varchar(128),
	DOMAINE_TYPE enum ('store','built'),
	DOMAINE_DNSPRI varchar(20),
	DOMAINE_FILE varchar(255),
	DOMAINE_ZONE text,
	CLIENT_ID int(11) NOT NULL default '-1',
	primary key(DOMAINE_ID),
	index(DOMAINE_NOM),
	index(CLIENT_ID)
);

replace into SEQ values('DOMAINE_ID',0,0,2147483647, 1, 0);


drop table if exists NOTIF;
create table NOTIF(
	NOTIF_ID int(11) NOT NULL default '0',
	NOTIF_TYPE varchar(20),
	NOTIF_ETAT enum('open','close'),
	LIGNE_ID int(11) NOT NULL default '-1',
	primary key(NOTIF_ID),
	index(LIGNE_ID)
);

replace into SEQ values('NOTIF_ID',0,0,2147483647,1,0);


-- Changement pour l'ajout des comptes UNIX

drop table if exists UNIXUSER;
create table UNIXUSER(
	UNIXUSER_ID int(11) NOT NULL default '0',
	UNIXUSER_NAME varchar(70),
	UNIXUSER_PASSWD varchar(70) default '',
	UNIXUSER_UID int(11),
	UNIXUSER_GID int(11),
	UNIXUSER_GECOS varchar(255),
	UNIXUSER_HOME varchar(255),
	UNIXUSER_SHELL varchar(255),
	UNIXUSER_STATE enum('ok','del'),
	UNIXUSER_LASTCHANGE int(11),
	UNIXUSER_MIN int(11) default '0',
	UNIXUSER_MAX int(11) default 2147483647,
	UNIXUSER_WARN int(11) default 2147483647,
	UNIXUSER_INACT int(11) default 2147483647,
	UNIXUSER_EXPIRE int(11) default -1,
	UNIXUSER_FLAG int(11) default 0,
	UNIXUSER_DTMOD timestamp(14),
	UNIXUSER_DTIN timestamp(14),
	UNIXUSER_DTOUT timestamp(14),
	CLIENT_ID int(11) NOT NULL default '-1',
	primary key(UNIXUSER_ID),
	index(UNIXUSER_NAME),
	index(UNIXUSER_UID),
	index(CLIENT_ID)
);

replace into SEQ values('UNIXUSER_ID',0,0,2147483647,1,0);

drop table if exists UNIXGROUP;
create table UNIXGROUP(
	UNIXGROUP_ID int(11) NOT NULL default '0',
	UNIXGROUP_NAME varchar(70),
	UNIXGROUP_PASSWD varchar(70) default '',
	UNIXGROUP_GID int(11),
	primary key(UNIXGROUP_ID),
	index(UNIXGROUP_NAME),
	index(UNIXGROUP_GID)
);

replace into SEQ values('UNIXGROUP_ID',0,0,2147483647,1,0);

drop table if exists UNIXUSERUNIXGROUP;
create table UNIXUSERUNIXGROUP(
	UNIXUSER_ID int(11),
	UNIXGROUP_ID int(11),
	index(UNIXUSER_ID),
	index(UNIXGROUP_ID)
);

drop table if exists VALIDATION;
create table VALIDATION (
	VALIDATION_ID int(11) NOT NULL default '0',
	VALIDATION_TYPE varchar(20) NOT NULL default '',
	VALIDATION_EVENT varchar(70) NOT NULL default '',
	VALIDATION_INFO varchar(70) NOT NULL default '',
	VALIDATION_ETAT enum('new','done') NOT NULL default 'new',
	LIGNE_ID int(11) NOT NULL default '-1',
	CLIENT_ID int(11) NOT NULL default '-1',
	primary key(VALIDATION_ID),
	index(VALIDATION_ETAT),
	index(LIGNE_ID),
	index(CLIENT_ID)
);

replace into SEQ values('VALIDATION_ID',0,0,2147483647,1,0);



