\ProvidesClass{enveloppe}[2006/05/26 v1.00 Enveloppe pour FDN]

\LoadClass{article}
\RequirePackage{graphicx,lmodern,url,vmargin}
\setmarginsrb{0in}{3mm}{0in}{0in}{0in}{0in}{0in}{0in}
\pagestyle{empty}

\parindent=0pt

\newlength{\env@height}
\newlength{\env@width}
\newlength{\adr@skipx}
\newlength{\adr@skipy}

\@namedef{envsize@1/3}{%
  \setlength{\env@height}{11cm}\relax
  \setlength{\env@width}{21cm}\relax
  \setlength{\adr@skipx}{5cm}\relax
  \setlength{\adr@skipy}{6cm}\relax
  \@namedef{env@angle}{-90}\relax
}

\@namedef{envsize@1/2}{%
  \setlength{\env@height}{16.2cm}\relax
  \setlength{\env@width}{22.9cm}\relax
  \setlength{\adr@skipx}{5.5cm}\relax
  \setlength{\adr@skipy}{9cm}\relax
  \@namedef{env@angle}{-90}\relax
}

\@namedef{envsize@1lscape}{%
  \setlength{\env@height}{20cm}\relax
  \setlength{\env@width}{28cm}\relax
  \setlength{\adr@skipx}{13cm}\relax
  \setlength{\adr@skipy}{14cm}\relax
  \@namedef{env@angle}{-90}\relax
}

\@namedef{envsize@1}{%
  \setlength{\env@height}{29.3cm}\relax
  \setlength{\env@width}{20cm}\relax
  \setlength{\adr@skipx}{5cm}\relax
  \setlength{\adr@skipy}{6cm}\relax
  \@namedef{env@angle}{0}\relax
}

\newbox\logo
\newbox\fdn
\newbox\adr
\newbox\env

\newenvironment{enveloppe}[1][1/3]{%
  \expandafter\ifx\csname envsize@#1\endcsname\relax
    \ClassError{enveloppe}{Taille '#1' non definie}{Mettre 1/2 ou 1/3}%
  \fi
  \@nameuse{envsize@#1}%
  \do@logo
  \do@fdn
  \begin{do@adr}
}{%
  \end{do@adr}
  \do@env
  \centering
  \rotatebox{\env@angle}{\copy\env}%
  \newpage
}

\newcommand\do@logo{%
  \setbox\logo\hbox to 5cm{%
    \hskip -6pt
    \includegraphics[width=5cm]{logoFDN}%
    \hfill
  }%
}

\newcommand\do@fdn{%
  \setbox\fdn\vbox to \env@height{%
    \hsize=5cm\relax
    \sffamily
    \vskip 3mm
    \copy\logo
    \textbf{French Data Network}\\
    Association loi 1901\\
    Inscrite \`a la pr\'efecture de\\
    police de Paris sous le num\'ero\\
    107563\par
    \vskip 5mm
    \textbf{Adresse:}\\
    French Data Network\\
    C/O Benjamin Bayart\\
    10, rue du Croissant\\
    75002 Paris\par
    \vskip 5mm
    \textbf{Internet:}\\
    \url{http://www.fdn.fr}\\
    \url{bureau@fdn.fr}\par
    \vfill
  }%
}

\newenvironment{do@adr}{%
  \global\setbox\adr\vbox to \env@height\bgroup
    \hsize=10cm\relax
    \sffamily\large
    \vskip \adr@skipy
}{%
    \vfill
    \egroup
}

\newcommand\do@env{%
  \setbox\env\hbox to \env@width{%
    \copy\fdn%
    \hskip \adr@skipx
    \copy\adr%
    \hfill
  }%
}

\endinput

\begin{document}
\parindent=0pt

\begin{enveloppe}
  %%NOM%%%
  \strut\newline
  %%ADRESSE%%%
  \strut\newline
  %%CP%% %%VILLE%%%
  \par
\end{enveloppe}


\end{document}
