\documentclass{article}

\usepackage[T1]{fontenc}
\usepackage[latin1]{inputenc}
\usepackage[frenchb]{babel}
\usepackage{textcomp,vmargin,multicol,fdnforms,lmodern}
\def\E{\texteuro}

\setmargnohfrb{.5in}{.5in}{.5in}{.5in}
\lefthyphenmin=1

%%IF-etudiant-%%
\def\fdnchoice#1#2#3#4{#2}
%%-etudiant-EIF%%
%%IF-association-%%
\def\fdnchoice#1#2#3#4{#3}
%%-association-EIF%%
%%IF-entreprise-%%
\def\fdnchoice#1#2#3#4{#4}
%%-entreprise-EIF%%
%%IF-particulier-%%
\def\fdnchoice#1#2#3#4{#1}
%%-particulier-EIF%%


\begin{document}
\let\rmdefault\sfdefault
\sffamily

\begin{center}
\hbox to \linewidth{%
\strut
\rlap{\includegraphics[width=1in]{logoFDN}}\hfill
\LARGE Bulletin d'abonnement au service ADSL de FDN%
\hfill\llap{\includegraphics[width=1in]{logoFDN}}%
}

Version du 13 juillet 2009
\end{center}

\begin{multicols}{2}

\subsubsection*{Dfinitions}

\begin{description}
\item[Abonn] L'abonn est l'adhrent  l'association ayant souscrit
  un abonnement au service ADSL. L'abonnement n'est ouvert qu'aux
  adhrents de l'association.
\item[Titulaire] Le titulaire de la ligne est l'abonn aux services
  tlphoniques auprs de France Telecom.
\item[RTC] Rseau Tlphonique Commut: rseau tlphonique \emph{classique}.
\item[VoIP] \emph{Voice Over Internet Protocol} (Voix sur le protocole Internet):
  rseau tlphonique alternatif bas sur des technologies issues d'Internet.
\end{description}

\subsubsection*{Description du service}

FDN fournit une connexion  son rseau  via la technologie ADSL reposant
sur l'offre de collecte d'un oprateur
tiers. Ces accs sont, selon les cas, obtenus par dgroupage partiel de la ligne
tlphonique. FDN ne fournit pas d'accs ADSL en dgroupage total: l'abonn
\emph{doit} rester abonn aux services de France Telecom sur sa ligne.

FDN fournit, sur cette connexion  son rseau, une ou plusieurs adresses IP
publiques, fixes (sauf demande explicite de l'abonn), et assure le routage
vers Internet.

En plus de cet accs vers Internet, l'association fournit des services, au choix
de l'abonn, parmis ceux-ci:
\begin{itemize}
\item accs au courrier lectronique, sur une adresse dans le domaine \texttt{fdn.fr}
  ou dans le domaine \texttt{fdn.org}, sur un sous-domaines de ceux-l rserv 
  l'abonn, ou sur tout domaine dont l'abonn est propritaire;
\item hbergement du ou des noms de domaines de l'abonn, que ce soit en DNS primaire
  ou en DNS secondaire;
\item hbergement d'un ou plusieurs sites web sur la plateforme d'hbergement de
  l'association;
\item fourniture d'un accs aux nouvelles (news), soit directement au serveur NNTP,
  soit sous forme d'un feed direct (via newsfeed, ou de prfrence UUCP);
\item de manire gnrale tout service en lien avec Internet et Usenet que l'association
  met usuellement  disposition de ses adhrents.
\end{itemize}

L'association fonctione par le bnvolat de ses membres adhrents: d'autres services
peuvent tre mis  disposition s'il se trouve des adhrents prts  mettre en place
et administrer ces services.

Le rglement intrieur de l'association s'applique aux activits de l'abonn sur sa
ligne ADSL, comme pour tous les autres services fournis par FDN. Conformment aux
status de l'association, ce rglement  valeur statutaire. Son non-respect peut
entrainer une radiation de l'association.

\subsubsection*{Conditions d'accs}

La fourniture de l'accs ADSL est soumis au paiement initial de frais d'accs au
service couvrant les frais de la construction de la ligne par l'association, et au
paiement rgulier d'un abonnement.

Le montant de l'abonnement est succeptible d'tre modifi,  la hausse ou  la baisse,
en fonction des tarifs des fournisseurs de l'association. Si le tarif est rvis 
la hausse, et au-del du tarif qui tait en vigueur lors de la souscription de
l'abonnement, l'abonn en sera inform dans les meilleurs dlais par l'association et
aura la possibilit de rsilier son abonnement dans les conditions prvues.

Le paiement de l'abonnement se fait par prlvement bancaire, sauf exception accepte
par l'association. Un courrier lectronique est envoy quelques jours avant le prlvement
indiquant la date du prlvement, le montant prlev, ainsi que la liste des lments
ayant servi au calcul de ce montant. Pour les adhrents qui le demandent, une facture
au format PDF est mise  disposition en ligne sur un site Web au moment de l'envoi du
courrier lectronique. Pour les adhrents qui en font la demande, une facture papier
leur est envoye par voie postale, cet envoi est factur 1~\E~TTC par facture envoye
pour couvrir les frais engendrs.

Pour les adhrents n'ayant pas donn d'adresse lectronique de contact, le courrier
lectronique annonant les prlvements n'est pas envoy.

\subsubsection*{Dure d'accs}

L'abonnement n'est pas soumis  une dure d'engagement. L'abonn est libre de rsilier
son accs  tout moment.

La rsiliation d'une ligne ADSL entrane pour l'association des frais qui sont rpercuts
au centime prt  l'adhrent souhaitant rsilier son accs, y compris si cette dcision
fait suite  une hausse des tarifs. L'association se rserve le droit de ne pas rpercuter
ces frais sur l'abonn (par exemple sur critre de ressources de l'adhrent, ou si les
finances de l'association permettent d'absorber cette charge).

La rsiliation se fait par courrier postal simple, dat et sign, envoy  l'association
au moins deux semaines  l'avance.

La modification du dbit souscrit, dans certaines limites prcises, est gratuite. Ces
limites sont publies sur le site web de l'association et refltent les contraintes
imposes par les fournisseurs de l'association. Ces limites sont indiques aussi prcisment
que FDN les connait.

\subsubsection*{Limites}

L'accs ADSL fourni par FDN ne couvre pas certains lments. En particulier:
\begin{itemize}
\item l'obtention d'un modem ADSL est  la charge de l'abonn, une liste de modems
  connus comme tant compatibles avec certains dbits levs est publie par
  l'association, cette liste n'est pas exhaustive;
\item l'abonnement France Tlcom pour la ligne concerne reste obligatoire et 
  la charge de l'abonn: FDN n'intervient en rien dans les relations commerciales qui
  lient l'abonn  France Tlcom;
\item FDN ne fournit pas de service de tlphonie, ni en RTC, ni en VoIP;
\item FDN ne fournit pas d'assistance technique pour l'installation et la configuration
  de l'accs ADSL, la seule assistance fournie est la recherche et la rsolution des
  pannes techniques qui peuvent empcher l'accs  Internet de l'abonn, cette
  assistance est fournie bnvolement par des membres de l'associations et ne fait
  donc l'objet d'aucune garantie, l'abonn est invit  fournir lui-mme, si ses
  comptences le permettent, de l'assistance aux autres membres de l'association.
\end{itemize}

\subsubsection*{Tarifs en vigueur}

L'association FDN pratique des tarifs diffrents selon la nature des abonns
et leur situation sociale. A priori l'association distingue 4 catgories
d'abonns auxquels des tarifs diffrents sont appliqus. L'association se rserve
le droit d'effectuer des drogations  ces rgles, que ce soit  la hausse ou
 la baisse. Ces drogations seront toujours annonces sur le site Web de l'association
ainsi qu'en Assemble Gnrale, ainsi que les motifs qui ont amen  ces
drogations (adhrent sur-consommateur de bande passante, conditions de ressources
particulirement faibles, etc).

Les 4 catgories sont les suivantes:
\begin{description}
\item[Particulier] correspond  la catgorie la plus usuelle d'un adhrent qui
  s'abonne au service ADSL  titre individuel pour son usage priv.
\item[Prfrentiel] correspond  la catgorie des adhrents ayant des faibles
  moyens et qui s'abonnent au service ADSL  titre individuel pour leur usage
  priv. Cette catgorie est rserve aux tudiants, allocataires des minima
  sociaux, titulaires de CES (Contrats Emplois Solidarit), ou similaires. Cette
  catgorie n'est accessible que sur prsentation de justificatifs.
\item[Association] correspond  la catgorie des adhrents qui sont des personnes
  morales sans but lucratif, tel que dfinit par le Code Gnral des Impts, quelle
  que soit leur forme juridique. En particulier sont concernes les associations rgies
  par la loi de 1901 sans but lucratif, qu'elles soient dclars en prfecture ou non.
  C'est par exemple de cette catgorie que relve un groupe d'habitants se cotisant
  pour financer un abonnement ADSL partag entre plusieurs logements (cas d'une
  association de fait).
\item[Entreprise] correspond  la catgorie des adhrents qui sont des personnes
  morales  but lucratif. En particulier sont concernes toutes les entreprises commerciales
  qui souscrivent  un abonnement ADSL pour leur usage propre, quelle que soit leur forme
  juridique exacte (indpendants, artisans, SARL, etc.).
\end{description}

Le prsent bulletin d'abonnement concerne la catgorie \og\textbf{%
\fdnchoice{Particulier}{Prfrentiel}{Association}{Entreprise}}\fg.

Pour mmoire, les tarifs en vigueur en juillet 2009 pour cette catgorie sont les suivants:

\begin{center}
\begin{tabular}{|llll|} \hline
\multicolumn{2}{|c}{\textbf{Dbit}} &	&                \\
\fdnchoice{%Particulier
\textbf{download} & \textbf{(upload)}
			& FAS TTC	& Abo. TTC \\ \hline
}{%Etudiants
\textbf{download} & \textbf{(upload)}
			& FAS TTC	& Abo. TTC \\ \hline
}{%Associations
\textbf{download} & \textbf{(upload)}
			& FAS TTC	& Abo. TTC \\ \hline
}{%Entreprises
\textbf{download} & \textbf{(upload)}
			& FAS HT	& Abo. HT \\ \hline
}
\multicolumn{4}{|l|}{\textbf{Dgroup}}				\\ \hline
\fdnchoice{%Particulier
512~kb/s	& (128~kb/s)	& 90,00~\E	& 25,00~\E/mois \\
1-4~Mb/s	& (256~kb/s)	& 90,00~\E	& 28,00~\E/mois \\
5-7~Mb/s	& (512~kb/s)	& 90,00~\E	& 28,00~\E/mois \\
8-18~Mb/s	& (860~kb/s)	& 90,00~\E	& 28,00~\E/mois \\
\hline
}{%Etudiants
512~kb/s	& (128~kb/s)	& 70,00~\E	& 23,50~\E/mois \\
1-4~Mb/s	& (256~kb/s)	& 70,00~\E	& 27,00~\E/mois \\
5-7~Mb/s	& (512~kb/s)	& 70,00~\E	& 27,00~\E/mois \\
8-18~Mb/s	& (860~kb/s)	& 70,00~\E	& 27,00~\E/mois \\
\hline
}{%Associations
512~kb/s	& (128~kb/s)	& 94,00~\E	& 28,00~\E/mois \\
1-4~Mb/s	& (256~kb/s)	& 94,00~\E	& 31,00~\E/mois \\
5-7~Mb/s	& (512~kb/s)	& 94,00~\E	& 31,00~\E/mois \\
8-18~Mb/s	& (860~kb/s)	& 94,00~\E	& 31,00~\E/mois \\ \hline
}{%Entreprises
512~kb/s	& (128~kb/s)	& 90,00~\E	& 25,00~\E/mois \\
1-4~Mb/s	& (256~kb/s)	& 90,00~\E	& 28,00~\E/mois \\
5-7~Mb/s	& (512~kb/s)	& 90,00~\E	& 28,00~\E/mois \\
8-18~Mb/s	& (860~kb/s)	& 90,00~\E	& 28,00~\E/mois \\ \hline
}
\multicolumn{4}{|l|}{\textbf{Non-dgroup}}		        \\ \hline
\fdnchoice{%Particulier
512~kb/s	& (128~kb/s)	& 80,00~\E	& 41,00~\E/mois \\
1-7~Mb/s	& (256~kb/s)	& 80,00~\E	& 41,00~\E/mois \\
8-18~Mb/s	& (860~kb/s)	& 80,00~\E	& 59,00~\E/mois \\ \hline
}{%Etudiants
512~kb/s	& (128~kb/s)	& 64,00~\E	& 36,00~\E/mois \\
1-7~Mb/s	& (256~kb/s)	& 64,00~\E	& 36,00~\E/mois \\
8-18~Mb/s	& (860~kb/s)	& 64,00~\E	& 53,00~\E/mois \\ \hline
}{%Associations
512~kb/s	& (128~kb/s)	& 86,00~\E	& 42,00~\E/mois \\
1-7~Mb/s	& (256~kb/s)	& 86,00~\E	& 42,00~\E/mois \\
8-18~Mb/s	& (860~kb/s)	& 86,00~\E	& 61,00~\E/mois \\ \hline
}{%Entreprises
512~kb/s	& (128~kb/s)	& 80,00~\E	& 41,00~\E/mois \\
1-7~Mb/s	& (256~kb/s)	& 80,00~\E	& 41,00~\E/mois \\
8-18~Mb/s	& (860~kb/s)	& 80,00~\E	& 59,00~\E/mois \\ \hline
}
\end{tabular}
\end{center}

\subsubsection*{Offre souscrite}


Ligne concerne: %%TEL%%

Dbit souscrit: %%DEBIT%%

\def\nerim{option0}
\def\degr{option1}
\def\nodeg{option3}
\def\pureft{option5}
\def\opt{%%OPTION%%%
}

\ifx\opt\degr
Dgroupage: partiel via SFR
\else
  \ifx\opt\nodeg
  Dgroupage: non (option 3 via SFR)
  \else
    \ifx\opt\nerim
    Dgroupage: partiel via Nerim
    \else
      \ifx\opt\pureft
      Dgorupage: non (pur FT)
      \fi
    \fi
  \fi
\fi

\subsubsection*{Signature}

Le prsent bulletin d'abonnement doit tre retourn  FDN paraph  chaque
page, et sign sur la dernire page.

\fdnchoice{}{%
Il doit tre accompagn des justificatifs ncessaires ouvrant droit au
tarif prfrentiel.}{}{}

\end{multicols}

Je soussign:\newline
\textegris{}{5cm}{%%NOM%%%
}\newline
demeurant au:\newline
\textegris{}{5cm}{%%ADRESSE%%%
}\newline
\monotextegris{}{5}{%%CP%%%
} \textegris{}{5cm}{%%VILLE%%%
}\newline
demande par la prsente a tre abonn au service ADSL de FDN tel que
dfini dans le prsent document.

Fait  \topalign{\textegris{Ville}{5cm}{}},

\vskip 5mm

le \topalign{\textegris{Date}{3cm}{}}

\vskip 5mm

Signature \grayrule{1cm}{3cm}


\end{document}

