package FDN::Adsl::Basic;

use strict;
use Exporter;
use FDN::Sql::Basic;
use FDN::Adsl::DBC;

our @ISA = ( 'Exporter' ) ;
our @EXPORT = qw (
		new_ligne
		del_ligne
		ligne_par_id
		ligne_par_tel
		ligne_par_state
		ligne_par_client_id
		toutes_lignes
		set_ligne_tel
		set_ligne_prix
		set_ligne_debit
		set_ligne_dtfac
		set_ligne_dtok
		set_ligne_dtout
		set_ligne_dtin
		set_ligne_state
		set_ligne_idld
		set_ligne_option
		set_ligne_adresse
		set_ligne_client

		new_adresse
		del_adresse
		adresse_par_id
		set_adresse_nom
		set_adresse_adr
		set_adresse_cp
		set_adresse_ville
		set_adresse_mail
		set_adresse_tel
		set_adresse_fax

		new_deploiement
		del_deploiement
		deploiement_par_id
		deploiement_par_ligne_id
		deploiement_par_num
		set_deploiement_task
		set_deploiement_start
		set_deploiement_fas
		set_deploiement_cde
		set_deploiement_rad
		set_deploiement_ar
		set_deploiement_cr
		set_deploiement_fin

		new_mandat
		mandat_par_id
		mandat_par_numero
		mandat_par_deploiement_id
		set_mandat_deploiement_id
		set_mandat_detenteur
		set_mandat_numero
		set_mandat_fichier
		set_mandat_image
		
		new_prix
		prix_par_id
		prix_par_nom
		tous_prix
		set_prix_nom
		set_prix_fasht
		set_prix_fasttc
		set_prix_aboht
		set_prix_abottc
		set_prix_tva

		new_client
		del_client
		client_par_id
		client_par_numadh
		client_par_adresse_id
		client_par_prelevemt_id
		client_par_nom
		set_client_nom
		set_client_numadh
		set_client_prelevemt
		set_client_adresse
		set_client_type
		set_client_etat
		tous_clients
		tous_clients_facture
		tous_clients_prelevement
		tous_clients_actifs
		tous_clients_resilies

		tous_debits
		debit_par_id
		debit_par_debit
		debit_par_nom
		debit_id_par_debit
		prixdebit_par_debit_id
		prixdebit_par_debit_id_type_option
		prix_id_par_debit_id_type_option

		new_eligibilite
		set_eligibilite_reponse
		set_eligibilite_dttest
		eligibilite_par_tel
		eligibilite_par_id

		new_prelevemt
		del_prelevemt
		prelevemt_par_id
		set_prelevemt_banque
		set_prelevemt_guichet
		set_prelevemt_compte
		set_prelevemt_rib
		set_prelevemt_titulaire
		set_prelevemt_etat
		set_prelevemt_adresse
		set_prelevemt_domicil

		new_creance
		creance_par_id
		creance_par_etat
		creance_par_client_id
		creance_par_client_id_etat
		creance_par_cloture_id
		creance_par_facture_id
		creance_par_prllig_id
		set_creance_ht
		set_creance_ttc
		set_creance_tva
		set_creance_client
		set_creance_libelle
		set_creance_facture
		set_creance_prllig
		set_creance_cloture
		set_creance_etat
		set_creance_datedue
		set_creance_datepayee

		new_facture
		facture_par_id
		facture_par_etat
		facture_par_client_id
		toutes_factures
		set_facture_etat
		set_facture_payee

		new_prlbq
		prlbq_par_id
		prlbq_par_etat
		tous_prlbqs
		set_prlbq_fichier
		set_prlbq_etat
		set_prlbq_nom

		new_prllig
		prllig_par_id
		prllig_par_prlbq_id
		prllig_par_client_id
		set_prllig_etat

		new_paiement
		paiement_par_id
		paiement_par_num
		paiement_par_client_id
		set_paiement_libelle
		set_paiement_type
		set_paiement_num
		set_paiement_date
		set_paiement_client_id
		set_paiement_ttc
		set_paiement_etat

		new_tva
		tva_par_id
		tva_par_etat
		set_tva_etat

		new_tvadcl
		tvadcl_par_id
		tous_tvadcl

		new_cloture
		del_cloture
		toutes_clotures
		cloture_par_id
		cloture_par_date

		new_info
		set_info_val
		set_info_type
		set_info_titre
		info_par_id
		new_ligneinfo
		new_clientinfo
		new_comptainfo
		ligneinfo_par_ligne_id
		clientinfo_par_client_id
		comptainfo_par_compta_id

		new_ordretd
		set_ordretd_ligne
		set_ordretd_etat
		set_ordretd_fichier
		ordretd_par_id
		ordretd_par_etat
		ordretd_par_fichier
		
		new_payant
		new_payant_unique
		new_payant_mensuel
		new_payant_annuel
		payant_par_id
		payant_par_client_id
		set_payant_libelle
		set_payant_type
		set_payant_client_id
		set_payant_prix_id
		set_payant_date
		set_payant_debut
		set_payant_fin

		new_raduser
		del_raduser
		raduser_par_id
		raduser_par_login
		raduser_par_radgroup_id
		raduser_par_ligne_id
		set_raduser_radgroup_id
		set_raduser_ligne_id
		set_raduser_login

		radgroup_par_id
		radgroup_par_nom

		new_uattr
		uattr_par_id
		uattr_par_raduser_id
		uattr_par_raduser_id_type
		set_uattr_attr
		set_uattr_op
		set_uattr_value
		set_uattr_type
		set_uattr_raduser_id

		new_gattr
		gattr_par_id
		gattr_par_radgroup_id
		gattr_par_radgroup_id_type
		set_gattr_attr
		set_gattr_op
		set_gattr_value
		set_gattr_type
		set_gattr_radgroup_id

		new_ipaddr
		toutes_ips
		ipaddr_par_id
		ipaddr_par_raduser_id
		ipaddr_par_addr
		ipaddr_par_etat_type
		set_ipaddr_etat
		set_ipaddr_raduser_id

		lock_radius
		unlock_radius
		lock_ip
		unlock_ip
		array_has_no_rows

		new_compta
		compta_par_id
		tous_comptas
		set_compta_nom

		new_adhaccess
		adhaccess_par_id
		adhaccess_par_login
		adhaccess_par_client_id
		set_adhaccess_login
		set_adhaccess_passwd
		set_adhaccess_client_id

		new_site
		site_par_id
		site_par_site
		site_par_login
		site_par_client_id
		set_site_login
		set_site_site
		set_site_passwd
		set_site_client_id

		new_domaine
		domaine_par_id
		domaine_par_nom
		domaine_par_client_id
		set_domaine_nom
		set_domaine_type
		set_domaine_zone
		set_domaine_client_id
		set_domaine_dnspri
		set_domaine_file

		new_notif
		notif_par_id
		notif_par_etat
		notif_par_type
		notif_par_ligne_id
		set_notif_type
		set_notif_etat
		set_notif_ligne_id

		new_unixuser
		unixuser_par_id
		unixuser_par_uid
		unixuser_par_name
		unixuser_par_client_id
		set_unixuser_passwd
		set_unixuser_state
		set_unixuser_dtout
		set_unixuser_client_id

		new_unixgroup
		tous_unixgroup
		unixgroup_par_id
		unixgroup_par_gid
		unixgroup_par_name

		new_unixuserunixgroup
		del_unixuserunixgroup
		unixuserunixgroup_par_unixuser_id
		unixuserunixgroup_par_unixgroup_id

		new_validation
		tous_validations
		validation_par_id
		validation_par_client_id
		validation_par_ligne_id
		validation_par_etat
		validation_par_type
		validation_par_type_etat
		set_validation_etat
		);
our @EXPORT_OK = qw ();

use constant PRIX_MENS => 'mois';
use constant PRIX_AN => 'an';
use constant PRIX_FAS => 'unique';

#############################################################
##                                                         ##
## LIGNE                                                   ##
##                                                         ##
#############################################################


sub new_ligne($$$$$$) { # Test
	my ( $tel, $debit, $option, $prix, $client, $adresse ) = @_;
	return __new($dbh,'LIGNE',
		'DEBIT_ID='.$debit,
		'PRIX_ID='.$prix,
		'CLIENT_ID='.$client,
		'ADRESSE_ID='.$adresse,
		'LIGNE_TEL='.dochar($tel),
		'LIGNE_OPT='.dochar($option),
		'LIGNE_STATE='.dochar('new'),
		'LIGNE_DTIN='.dodate('now')
		);
}

sub del_ligne($) { # Test
	my ( $lid ) = @_;
	return __del($dbh,'LIGNE',$lid);
}

sub ligne_par_id($) { # Test
	return __par_id($dbh,'LIGNE',$_[0]);
}

sub ligne_par_tel($) { # Test
	return __par_clef($dbh,'LIGNE',$_[0],'LIGNE_TEL');
}

sub toutes_lignes() { # Test
	return __tous($dbh,'LIGNE');
}

sub ligne_par_client_id($) { # Test
	return __par_clef($dbh,'LIGNE',$_[0],'CLIENT_ID');
}

sub ligne_par_state($) { # Test
	return __par_clef($dbh,'LIGNE',$_[0],'LIGNE_STATE');
}

sub set_ligne_tel($$) { # Test
	my ( $lid, $tel ) = @_;
	return __set_tbl_val($dbh,'LIGNE','LIGNE_TEL',$lid,dochar($tel));
}

sub set_ligne_prix($$) { # Test
	my ( $lid, $pid ) = @_;
	return __set_tbl_val($dbh,'LIGNE','PRIX_ID',$lid,$pid);
}

sub set_ligne_debit($$) { # Test
	my ( $lid, $did ) = @_;
	return __set_tbl_val($dbh,'LIGNE','DEBIT_ID',$lid,$did);
}

sub set_ligne_client($$) { # Test
	my ( $lid, $cid ) = @_;
	return __set_tbl_val($dbh,'LIGNE','CLIENT_ID',$lid,$cid);
}

sub set_ligne_option($$) { # Test
	my ( $lid, $opt ) = @_;
	return __set_tbl_val($dbh,'LIGNE','LIGNE_OPT',$lid,dochar($opt));
}

sub set_ligne_adresse($$) { # Test
	my ( $lid, $aid ) = @_;
	return __set_tbl_val($dbh,'LIGNE','ADRESSE_ID',$lid,$aid);
}

sub set_ligne_dtfac($;$) {
	my ( $lid, $date ) = @_;
	if ( ! defined $date ) {
		$date = 'now';
	}
	return __set_tbl_val($dbh,'LIGNE','LIGNE_DTFAC',$lid,dodate($date));
}

sub set_ligne_dtok($;$) { # Test
	my ( $lid, $date ) = @_;
	if ( ! defined $date ) {
		$date = 'now';
	}
	return __set_tbl_val($dbh,'LIGNE','LIGNE_DTOK',$lid,dodate($date));
}

sub set_ligne_state($$) { # Test
	my ( $lid, $state ) = @_;
	return __set_tbl_val($dbh,'LIGNE','LIGNE_STATE',$lid,dochar($state));
}

sub set_ligne_idld($$) { # Test
	my ( $lid, $idld ) = @_;
	return __set_tbl_val($dbh,'LIGNE','LIGNE_IDLD',$lid,dochar($idld));
}

sub set_ligne_dtout($;$) { # Test
	my ( $lid, $date ) = @_;
	if ( ! defined $date ) {
		$date = 'now';
	}
	return __set_tbl_val($dbh,'LIGNE','LIGNE_DTOUT',$lid,dodate($date));
}

sub set_ligne_dtin($;$) { # Test
	my ( $lid, $date ) = @_;
	if ( ! defined $date ) {
		$date = 'now';
	}
	return __set_tbl_val($dbh,'LIGNE','LIGNE_DTIN',$lid,dodate($date));
}

#############################################################
##                                                         ##
## ADRESSE                                                 ##
##                                                         ##
#############################################################

sub new_adresse($$$$) { # Test
	my ( $nom, $adr, $cp, $ville ) = @_;
	return __new($dbh,'ADRESSE',
		'ADRESSE_NOM='.dochar($nom),
		'ADRESSE_ADR='.dochar($adr),
		'ADRESSE_CP='.dochar($cp),
		'ADRESSE_VILLE='.dochar($ville)
		);
}

sub del_adresse($) { # Test
	my ( $aid ) = @_;
	return __del($dbh, 'ADRESSE', $aid);
}

sub adresse_par_id($) { # Test
	return __par_id($dbh,'ADRESSE',$_[0]);
}

sub set_adresse_nom($$) { # Test
	my ( $aid, $nom ) = @_;
	return __set_tbl_val($dbh,'ADRESSE','ADRESSE_NOM',$aid,dochar($nom));
}

sub set_adresse_adr($$) { # Test
	my ( $aid, $adr ) = @_;
	return __set_tbl_val($dbh,'ADRESSE','ADRESSE_ADR',$aid,dochar($adr));
}

sub set_adresse_cp($$) { # Test
	my ( $aid, $cp ) = @_;
	return __set_tbl_val($dbh,'ADRESSE','ADRESSE_CP',$aid,dochar($cp));
}

sub set_adresse_ville($$) { # Test
	my ( $aid, $ville ) = @_;
	return __set_tbl_val($dbh,'ADRESSE','ADRESSE_VILLE',$aid,dochar($ville));
}

sub set_adresse_mail($$) { # Test
	my ( $aid, $mail ) = @_;
	return __set_tbl_val($dbh,'ADRESSE','ADRESSE_MAIL',$aid,dochar($mail));
}

sub set_adresse_tel($$) { # Test
	my ( $aid, $tel ) = @_;
	return __set_tbl_val($dbh,'ADRESSE','ADRESSE_TEL',$aid,dochar($tel));
}

sub set_adresse_fax($$) { # Test
	my ( $aid, $fax ) = @_;
	return __set_tbl_val($dbh,'ADRESSE','ADRESSE_FAX',$aid,dochar($fax));
}


#############################################################
##                                                         ##
## DEPLOIEMENT                                             ##
##                                                         ##
#############################################################


sub new_deploiement($$) { # Test
	my ( $lid, $num ) = @_;
	return __new($dbh,'DEPLOIEMENT',
		'LIGNE_ID='.$lid,
		'DEPLOIEMENT_NUM='.dochar($num)
		);
}

sub del_deploiement($) { # Test
	my ( $did ) = @_;
	return __del($dbh, 'DEPLOIEMENT', $did);
}

sub deploiement_par_id($) { # Test
	return __par_id($dbh,'DEPLOIEMENT',$_[0]);
}

sub deploiement_par_ligne_id($) { # Test
	return __par_clef($dbh,'DEPLOIEMENT',$_[0],'LIGNE_ID');
}

sub deploiement_par_num($) { # Test
	return __par_clef($dbh,'DEPLOIEMENT',$_[0],'DEPLOIEMENT_NUM');
}

sub set_deploiement_task($$) { # Test
	my ( $did, $tid ) = @_;
	return __set_tbl_val($dbh,'DEPLOIEMENT','TASK_ID',$did,$tid);
}

sub __set_dpl_date($$) { # Test
	my ( $date, $did ) = @_;
	return __set_tbl_val($dbh,'DEPLOIEMENT','DEPLOIEMENT_DT'.$date,$did,dodate('now'));
}

sub set_deploiement_start($) { # Test
	return __set_dpl_date('START',$_[0]);
}

sub set_deploiement_fas($) { # Test
	return __set_dpl_date('FAS',$_[0]);
}

sub set_deploiement_cde($) { # Test
	return __set_dpl_date('CDE',$_[0]);
}

sub set_deploiement_rad($) { # Test
	return __set_dpl_date('RAD',$_[0]);
}

sub set_deploiement_ar($) { # Test
	return __set_dpl_date('AR',$_[0]);
}

sub set_deploiement_cr($) { # Test
	return __set_dpl_date('CR',$_[0]);
}

sub set_deploiement_fin($) { # Test
	return __set_dpl_date('FIN',$_[0]);
}

#############################################################
##                                                         ##
## MANDAT                                                  ##
##                                                         ##
#############################################################


sub new_mandat($$) { # Test
	my ( $dplid, $detenteur ) = @_;
	return __new($dbh,'MANDAT',
		'DEPLOIEMENT_ID='.$dplid,
		'MANDAT_DETENTEUR='.dochar($detenteur));
}

sub mandat_par_id($) { # Test
	return __par_id($dbh,'MANDAT',$_[0]);
}

sub mandat_par_deploiement_id($) { # Test
	return __par_clef($dbh,'MANDAT',$_[0],'DEPLOIEMENT_ID');
}

sub mandat_par_numero($) { # Test
	return __par_clef($dbh,'MANDAT',$_[0],'MANDAT_NUMERO');
}

sub set_mandat_deploiement_id($$) { # Test
	my ( $mid, $did ) = @_;
	return __set_tbl_val($dbh,'MANDAT','DEPLOIEMENT_ID',$mid,$did);
}

sub set_mandat_detenteur($$) { # Test
	my ( $mid, $detenteur ) = @_;
	return __set_tbl_val($dbh,'MANDAT','MANDAT_DETENTEUR',$mid,dochar($detenteur));
}

sub set_mandat_numero($$) { # Test
	my ( $mid, $numero ) = @_;
	return __set_tbl_val($dbh,'MANDAT','MANDAT_NUMERO',$mid,dochar($numero));
}

sub set_mandat_fichier($$) { # Test
	my ( $mid, $fichier ) = @_;
	return __set_tbl_val($dbh,'MANDAT','MANDAT_FICHIER',$mid,dochar($fichier));
}

sub set_mandat_image($$) { # Test
	my ( $mid, $image ) = @_;
	return __set_tbl_val($dbh,'MANDAT','MANDAT_IMAGE',$mid,dochar($image));
}

#############################################################
##                                                         ##
## PRIX                                                    ##
##                                                         ##
#############################################################


sub new_prix($$$$$$) { # Test
	my ( $nom, $fasht, $aboht, $fasttc, $abottc, $tva ) = @_;
	return __new($dbh,'PRIX',
		'PRIX_FASHT='.$fasht,
		'PRIX_ABOHT='.$aboht,
		'PRIX_FASTTC='.$fasttc,
		'PRIX_ABOTTC='.$abottc,
		'PRIX_TVA='.dochar($tva),
		'PRIX_NOM='.dochar($nom)
		);
}

sub prix_par_id($) { # Test
	return __par_id($dbh,'PRIX',$_[0]);
}

sub prix_par_nom($) { # Test
	return __par_nom($dbh,'PRIX',$_[0]);
}

sub tous_prix() { # Test
	return __tous($dbh,'PRIX');
}

sub set_prix_nom($$) { # Test
	my ( $pid, $nom ) = @_;
	return __set_tbl_val($dbh,'PRIX','PRIX_NOM',$pid,dochar($nom));
}

sub set_prix_fasht($$) { # Test
	my ( $pid, $fas ) = @_;
	return __set_tbl_val($dbh,'PRIX','PRIX_FASHT',$pid,$fas );
}

sub set_prix_fasttc($$) { # Test
	my ( $pid, $fas ) = @_;
	return __set_tbl_val($dbh,'PRIX','PRIX_FASTTC',$pid,$fas );
}

sub set_prix_aboht($$) { # Test
	my ( $pid, $abo ) = @_;
	return __set_tbl_val($dbh,'PRIX','PRIX_ABOHT',$pid,$abo );
}

sub set_prix_abottc($$) { # Test
	my ( $pid, $abo ) = @_;
	return __set_tbl_val($dbh,'PRIX','PRIX_ABOTTC',$pid,$abo );
}

sub set_prix_tva($$) { # Test
	my ( $pid, $tva ) = @_;
	return __set_tbl_val($dbh,'PRIX','PRIX_TVA',$pid,dochar($tva) );
}

#############################################################
##                                                         ##
## CLIENT                                                  ##
##                                                         ##
#############################################################


sub new_client($$) { # Test
	my ( $nom, $type ) = @_;
	return __new($dbh,'CLIENT',
		'CLIENT_NOM='.dochar($nom),
		'CLIENT_TYPE='.dochar($type),
		'CLIENT_ETAT='.dochar('actif')
		);
}

sub del_client($) { # Test
	my ( $cid ) = @_;
	return __del($dbh, 'CLIENT', $cid);
}

sub tous_clients() { # Test
	return __tous($dbh,'CLIENT');
}

sub tous_clients_facture() { # Test
	return __par_champ_ext($dbh,'CLIENT',
		[ [ 'CLIENT.PRELEVEMT_ID', '=', '-1' ] ]);
}

sub tous_clients_prelevement() { # Test
	return __par_champ_ext($dbh,'CLIENT',
		[ [ 'CLIENT.PRELEVEMT_ID', '>', '0' ] ]);
}

sub tous_clients_actifs() { # Test
	return __par_clef($dbh,'CLIENT','actif','CLIENT_ETAT');
}

sub tous_clients_resilies() { # Test
	return __par_clef($dbh,'CLIENT','resilie','CLIENT_ETAT');
}

sub client_par_id($) { # Test
	return __par_id($dbh,'CLIENT',$_[0]);
}

sub client_par_numadh($) { # Test
	my ( $num ) = @_;
	return __par_clef($dbh,'CLIENT',$num,'CLIENT_NUMADH');
}

sub client_par_adresse_id($) { # Test
	return __par_clef($dbh,'CLIENT',$_[0],'ADRESSE_ID');
}

sub client_par_prelevemt_id($) { # Test
	return __par_clef($dbh,'CLIENT',$_[0],'PRELEVEMT_ID');
}

sub client_par_nom($) { # Test
	return __par_nom($dbh,'CLIENT',$_[0]);
}

sub set_client_nom($$) { # Test
	my ( $cid, $nom ) = @_;
	return __set_tbl_val($dbh,'CLIENT','CLIENT_NOM',$cid,dochar($nom));
}

sub set_client_prelevemt($$) { # Test
	my ( $cid, $pid ) = @_;
	return __set_tbl_val($dbh,'CLIENT','PRELEVEMT_ID',$cid,$pid);
}

sub set_client_adresse($$) { # Test
	my ( $cid, $aid ) = @_;
	return __set_tbl_val($dbh,'CLIENT','ADRESSE_ID',$cid,$aid);
}

sub set_client_type($$) { # Test
	my ( $cid, $type ) = @_;
	return __set_tbl_val($dbh,'CLIENT','CLIENT_TYPE',$cid,dochar($type));
}

sub set_client_numadh($$) { # Test
	my ( $cid, $num ) = @_;
	return __set_tbl_val($dbh,'CLIENT','CLIENT_NUMADH',$cid,$num);
}

sub set_client_etat($$) { # Test
	my ( $cid, $etat ) = @_;
	return __set_tbl_val($dbh,'CLIENT','CLIENT_ETAT',$cid,dochar($etat));
}

#############################################################
##                                                         ##
## DEBIT                                                   ##
##                                                         ##
#############################################################

sub tous_debits() { # Test
	return __tous($dbh,'DEBIT');
}

sub debit_par_id($) { # Test
	return __par_id($dbh,'DEBIT',$_[0]);
}

sub debit_par_debit($) { # Test
	my ( $debit ) = @_;
	return __par_champ_test($dbh,'DEBIT',dochar($debit),'DEBIT','=');
}

sub debit_par_nom($) { # Test
	my ( $nom ) = @_;
	return __par_nom($dbh,'DEBIT',$nom);
}

sub debit_id_par_debit($) {
	my ( $debit ) = @_;
	return __id_par_clef($dbh,'DEBIT',$debit,'DEBIT_DEBIT');
}

#############################################################
##                                                         ##
## PRIXDEBIT                                               ##
##                                                         ##
#############################################################


sub prixdebit_par_debit_id($) { # Test
	my ( $did ) = @_;
	return __get_relation($dbh,'PRIX','DEBIT','DEBIT',$did);
}

sub prixdebit_par_debit_id_type_option($$$) { # Test
	my ( $did, $type, $option ) = @_;
	return __get_relation($dbh,'PRIX','DEBIT','DEBIT',$did,
		'TYPE='.dochar($type),
		'OPTION='.dochar($option));
}

sub prix_id_par_debit_id_type_option($$$) {
	my ( $did, $type, $option ) = @_;
	my $res = __par_champ_ext($dbh,'PRIXDEBIT.PRIX_ID',
			[ [ 'PRIXDEBIT.DEBIT_ID', '=', $did ],
			  [ 'PRIXDEBIT.PRIXDEBIT_OPTION', '=', dochar($option) ],
			  [ 'PRIXDEBIT.PRIXDEBIT_TYPE',   '=', dochar($type) ] ] );
	return $res->{'PRIX_ID'};
}

#############################################################
##                                                         ##
## ELIGIBILITE                                             ##
##                                                         ##
#############################################################


sub new_eligibilite($$) { # Test
	my ( $tel, $offre ) = @_;
	return __new($dbh,'ELIGIBILITE',
		'ELIGIBILITE_TEL='.dochar($tel),
		'ELIGIBILITE_OFFRE='.dochar($offre),
		'ELIGIBILITE_DTTEST='.dodate('0000-00-00 00:00:00')
		);
}

sub eligibilite_par_id($) { # Test
	return __par_id($dbh,'ELIGIBILITE',$_[0]);
}

sub set_eligibilite_reponse($$) { # Test
	my ( $eid, $rep ) = @_;
	return __set_tbl_val($dbh,'ELIGIBILITE','ELIGIBILITE_REPONSE',$eid,dochar($rep));
}

sub set_eligibilite_dttest($;$) { # Test
	my ( $eid, $date ) = @_;
	$date = 'now' if ! defined $date;
	return __set_tbl_val($dbh,'ELIGIBILITE','ELIGIBILITE_DTTEST',$eid,dodate($date));
}

sub eligibilite_par_tel($) { # Test
	my ( $tel ) = @_;
	return __par_champ_test($dbh,'ELIGIBILITE',$tel,'TEL','=');
}

#############################################################
##                                                         ##
## PRELEVEMT                                               ##
##                                                         ##
#############################################################

sub new_prelevemt($$$$$$) { # Test
	my ( $banque, $guichet, $compte, $rib, $titulaire, $domicil ) = @_;
	return __new($dbh,'PRELEVEMT',
		'PRELEVEMT_BANQUE='.dochar($banque),
		'PRELEVEMT_GUICHET='.dochar($guichet),
		'PRELEVEMT_COMPTE='.dochar($compte),
		'PRELEVEMT_RIB='.dochar($rib),
		'PRELEVEMT_TITULAIRE='.dochar($titulaire),
		'PRELEVEMT_DOMICIL='.dochar($domicil),
		'PRELEVEMT_ETAT='.dochar('ok')
		);
}

sub del_prelevemt($) { # Test
	my ( $pid ) = @_;
	return __del($dbh, 'PRELEVEMT', $pid);
}

sub prelevemt_par_id($) { # Test
	return __par_id($dbh,'PRELEVEMT',$_[0]);
}

sub set_prelevemt_banque($$) { # Test
	my ( $pid, $banque ) = @_;
	return __set_tbl_val($dbh,'PRELEVEMT','PRELEVEMT_BANQUE',$pid,dochar($banque));
}

sub set_prelevemt_guichet($$) { # Test
	my ( $pid, $guichet ) = @_;
	return __set_tbl_val($dbh,'PRELEVEMT','PRELEVEMT_GUICHET',$pid,dochar($guichet));
}

sub set_prelevemt_compte($$) { # Test
	my ( $pid, $compte ) = @_;
	return __set_tbl_val($dbh,'PRELEVEMT','PRELEVEMT_COMPTE',$pid,dochar($compte));
}

sub set_prelevemt_rib($$) { # Test
	my ( $pid, $rib ) = @_;
	return __set_tbl_val($dbh,'PRELEVEMT','PRELEVEMT_RIB',$pid,dochar($rib));
}

sub set_prelevemt_titulaire($$) { # Test
	my ( $pid, $titulaire ) = @_;
	return __set_tbl_val($dbh,'PRELEVEMT','PRELEVEMT_TITULAIRE',$pid,dochar($titulaire));
}

sub set_prelevemt_etat($$) { # Test
	my ( $pid, $etat ) = @_;
	return __set_tbl_val($dbh,'PRELEVEMT','PRELEVEMT_ETAT',$pid,dochar($etat));
}

sub set_prelevemt_domicil($$) { #Test
	my ( $pid, $domicil ) = @_;
	return __set_tbl_val($dbh,'PRELEVEMT','PRELEVEMT_DOMICIL',$pid,dochar($domicil));
}

sub set_prelevemt_adresse($$) { # Test
	my ( $pid, $aid ) = @_;
	return __set_tbl_val($dbh,'PRELEVEMT','ADRESSE_ID',$pid, $aid);
}

#############################################################
##                                                         ##
## CREANCE                                                 ##
##                                                         ##
#############################################################


sub new_creance($$$$$$) { # Test
	my ( $cid, $clid, $ht, $ttc, $tva, $libelle ) = @_;
	return __new($dbh,'CREANCE',
		'CLIENT_ID='.$cid,
		'CLOTURE_ID='.$clid,
		'CREANCE_HT='.$ht,
		'CREANCE_TTC='.$ttc,
		'CREANCE_TVA='.dochar($tva),
		'CREANCE_LIBELLE='.dochar($libelle),
		'CREANCE_ETAT='.dochar('due'),
		'CREANCE_DATEDUE='.dodate('now')
		);
}

sub creance_par_id($) { # Test
	return __par_id($dbh,'CREANCE',$_[0]);
}

sub creance_par_etat($) { # Test
	my ( $etat ) = @_;
	return __par_clef($dbh,'CREANCE',$etat,'CREANCE_ETAT');
}

sub creance_par_client_id($) { # Test
	my ( $cid ) = @_;
	return __par_clef($dbh,'CREANCE',$cid,'CLIENT_ID');
}

sub creance_par_cloture_id($) { # Test
	my ( $clid ) = @_;
	return __par_clef($dbh,'CREANCE',$clid,'CLOTURE_ID');
}

sub creance_par_facture_id($) { # Test
	my ( $fid ) = @_;
	return __par_clef($dbh,'CREANCE',$fid,'FACTURE_ID');
}

sub creance_par_prllig_id($) { # Test
	my ( $pid ) = @_;
	return __par_clef($dbh,'CREANCE',$pid,'PRLLIG_ID');
}

sub creance_par_client_id_etat($$) { # Test
	my ( $cid, $etat ) = @_;
	return __par_champ_ext($dbh,'CREANCE',
		[ [ 'ETAT',              '=', dochar($etat) ],
		  [ 'CREANCE.CLIENT_ID', '=', $cid  ] ]);
}

sub set_creance_ht($$) { # Test
	my ( $crid, $ht ) = @_;
	return __set_tbl_val($dbh,'CREANCE','CREANCE_HT',$crid,$ht);
}

sub set_creance_ttc($$) { # Test
	my ( $crid, $ttc ) = @_;
	return __set_tbl_val($dbh,'CREANCE','CREANCE_TTC',$crid,$ttc);
}

sub set_creance_tva($$) { # Test
	my ( $crid, $tva ) = @_;
	return __set_tbl_val($dbh,'CREANCE','CREANCE_TVA',$crid,dochar($tva));
}

sub set_creance_client($$) { # Test
	my ( $crid, $cid ) = @_;
	return __set_tbl_val($dbh,'CREANCE','CLIENT_ID',$crid,$cid);
}

sub set_creance_libelle($$) { # Test
	my ( $crid, $libelle ) = @_;
	return __set_tbl_val($dbh,'CREANCE','CREANCE_LIBELLE',$crid,dochar($libelle));
}

sub set_creance_facture($$) { # Test
	my ( $crid, $fid ) = @_;
	return __set_tbl_val($dbh,'CREANCE','FACTURE_ID',$crid,$fid);
}

sub set_creance_prllig($$) { # Test
	my ( $crid, $pid ) = @_;
	return __set_tbl_val($dbh,'CREANCE','PRLLIG_ID',$crid,$pid);
}

sub set_creance_cloture($$) { # Test
	my ( $crid, $clid ) = @_;
	return __set_tbl_val($dbh,'CREANCE','CLOTURE_ID',$crid,$clid);
}

sub set_creance_etat($$) { # Test
	my ( $crid, $etat ) = @_;
	return __set_tbl_val($dbh,'CREANCE','CREANCE_ETAT',$crid,dochar($etat));
}

sub set_creance_datedue($$) { # Test
	my ( $crid, $date ) = @_;
	return __set_tbl_val($dbh,'CREANCE','CREANCE_DATEDUE',$crid,dodate($date));
}

sub set_creance_datepayee($$) { # Test
	my ( $crid, $date ) = @_;
	return __set_tbl_val($dbh,'CREANCE','CREANCE_DATEPAYEE',$crid,dodate($date));
}

#############################################################
##                                                         ##
## FACTURE                                                 ##
##                                                         ##
#############################################################


sub new_facture($$) { # Test
	my ( $cid, $num ) = @_;
	return __new($dbh,'FACTURE',
		'CLIENT_ID='.$cid,
		'FACTURE_NUM='.dochar($num),
		'FACTURE_ETAT='.dochar('due'),
		'FACTURE_DATE='.dodate('now')
		);
}

sub set_facture_etat($$) { # Test
	my ( $fid, $etat ) = @_;
	return __set_tbl_val($dbh,'FACTURE','FACTURE_ETAT',$fid,dochar($etat));
}

sub set_facture_payee($$) { # Test
	my ( $fid, $date ) = @_;
	return __set_tbl_val($dbh,'FACTURE','FACTURE_PAYEE',$fid,dodate($date));
}

sub facture_par_id($) { # Test
	return __par_id($dbh,'FACTURE',$_[0]);
}

sub facture_par_etat($) { # Test
	my ( $etat ) = @_;
	return __par_clef($dbh,'FACTURE',$etat,'FACTURE_ETAT');
}

sub facture_par_client_id($) { # Test
	my ( $cid ) = @_;
	return __par_clef($dbh,'FACTURE',$cid,'CLIENT_ID');
}

sub toutes_factures() { # Test
	return __tous($dbh,'FACTURE');
}

#############################################################
##                                                         ##
## PRLBQ                                                   ##
##                                                         ##
#############################################################


sub new_prlbq($$$) { # Test
	my ( $nom, $fichier, $date ) = @_;
	return __new($dbh,'PRLBQ',
		'PRLBQ_NOM='.dochar($nom),
		'PRLBQ_FICHIER='.dochar($fichier),
		'PRLBQ_DATE='.dochar($date),
		'PRLBQ_ETAT='.dochar('du')
		);
}

sub prlbq_par_id($) { # Test
	return __par_id($dbh,'PRLBQ',$_[0]);
}

sub prlbq_par_etat($) { # Test
	my ( $etat ) = @_;
	return __par_clef($dbh,'PRLBQ',$etat,'PRLBQ_ETAT');
}

sub tous_prlbqs() { # Test
	return __tous($dbh,'PRLBQ');
}

sub set_prlbq_nom($$) { # Test
	my ( $pid, $nom ) = @_;
	return __set_tbl_val($dbh,'PRLBQ','PRLBQ_NOM',$pid,dochar($nom));
}

sub set_prlbq_fichier($$) { # Test
	my ( $pid, $fichier ) = @_;
	return __set_tbl_val($dbh,'PRLBQ','PRLBQ_FICHIER',$pid,dochar($fichier));
}

sub set_prlbq_etat($$) { # Test
	my ( $pid, $etat ) = @_;
	return __set_tbl_val($dbh,'PRLBQ','PRLBQ_ETAT',$pid,dochar($etat));
}

#############################################################
##                                                         ##
## PRLLIG                                                  ##
##                                                         ##
#############################################################

sub new_prllig($$$$$$$$$) { # Test
	my ( $prid, $clid, $banque, $guichet, $compte, $domicil, $titulaire, $montant, $libelle ) = @_;
	return __new($dbh,'PRLLIG',
		'PRLLIG_BANQUE='.dochar($banque),
		'PRLLIG_GUICHET='.dochar($guichet),
		'PRLLIG_COMPTE='.dochar($compte),
		'PRLLIG_MONTANT='.dochar($montant),
		'PRLLIG_LIBELLE='.dochar($libelle),
		'PRLLIG_TITULAIRE='.dochar($titulaire),
		'PRLLIG_DOMICIL='.dochar($domicil),
		'PRLBQ_ID='.$prid,
		'CLIENT_ID='.$clid,
		'PRLLIG_ETAT='.dochar('ok')
		);
}

sub prllig_par_id($) { # Test
	return __par_id($dbh,'PRLLIG',$_[0]);
}

sub prllig_par_prlbq_id($) { # Test
	my ( $prid ) = @_;
	return __par_clef($dbh,'PRLLIG',$prid,'PRLBQ_ID');
}

sub prllig_par_client_id($) { # Test
	my ( $clid ) = @_;
	return __par_clef($dbh,'PRLLIG',$clid,'CLIENT_ID');
}

sub set_prllig_etat($$) { # Test
	my ( $pid, $etat ) = @_;
	return __set_tbl_val($dbh,'PRLLIG','PRLLIG_ETAT',$pid,dochar($etat));
}

#############################################################
##                                                         ##
## PAIEMENT                                                ##
##                                                         ##
#############################################################


sub new_paiement($$$$$) { # Test
	my ( $cid, $libelle, $type, $num, $ttc ) = @_;
	return __new($dbh,'PAIEMENT',
		'CLIENT_ID='.$cid,
		'PAIEMENT_LIBELLE='.dochar($libelle),
		'PAIEMENT_TYPE='.dochar($type),
		'PAIEMENT_NUM='.dochar($num),
		'PAIEMENT_TTC='.$ttc,
		'PAIEMENT_DATE='.dodate('now'),
		'PAIEMENT_ETAT='.dochar('ok'));
}

sub paiement_par_id($) { # Test
	return __par_id($dbh,'PAIEMENT',$_[0]);
}

sub paiement_par_num($) { # Test
	return __par_clef($dbh,'PAIEMENT',$_[0],'PAIEMENT_NUM');
}

sub paiement_par_client_id($) { # Test
	return __par_clef($dbh,'PAIEMENT',$_[0],'CLIENT_ID');
}

sub set_paiement_libelle($$) { # Test
	my ( $pid, $lib ) = @_;
	return __set_tbl_val($dbh,'PAIEMENT','PAIEMENT_LIBELLE',$pid,dochar($lib));
}

sub set_paiement_type($$) { # Test
	my ( $pid, $type ) = @_;
	return __set_tbl_val($dbh,'PAIEMENT','PAIEMENT_TYPE',$pid,dochar($type));
}

sub set_paiement_etat($$) { # Test
	my ( $pid, $etat ) = @_;
	return __set_tbl_val($dbh,'PAIEMENT','PAIEMENT_ETAT',$pid,dochar($etat));
}

sub set_paiement_num($$) { # Test
	my ( $pid, $num ) = @_;
	return __set_tbl_val($dbh,'PAIEMENT','PAIEMENT_NUM',$pid,dochar($num));
}

sub set_paiement_date($$) { # Test
	my ( $pid, $date ) = @_;
	return __set_tbl_val($dbh,'PAIEMENT','PAIEMENT_DATE',$pid,dodate($date));
}

sub set_paiement_ttc($$) { # Test
	my ( $pid, $ttc ) = @_;
	return __set_tbl_val($dbh,'PAIEMENT','PAIEMENT_TTC',$pid,$ttc);
}

sub set_paiement_client_id($$) { # Test
	my ( $pid, $cid ) = @_;
	return __set_tbl_val($dbh,'PAIEMENT','CLIENT_ID',$pid,$cid);
}


#############################################################
##                                                         ##
## TVA                                                     ##
##                                                         ##
#############################################################

sub new_tva($$) { # Test
	my ( $montant, $source ) = @_;
	return __new($dbh,'TVA',
		'TVA_MONTANT='.$montant,
		'TVA_SOURCE='.dochar($source),
		'TVA_ETAT='.dochar('due')
		);
}

sub tva_par_id($) { # Test
	return __par_id($dbh,'TVA',$_[0]);
}

sub tva_par_etat($) { # Test
	my ( $etat ) = @_;
	return __par_clef($dbh,'TVA',$etat,'TVA_ETAT');
}

sub set_tva_etat($$) { # Test
	my ( $tid, $etat ) = @_;
	return __set_tbl_val($dbh,'TVA','TVA_ETAT',$tid,dochar($etat));
}

#############################################################
##                                                         ##
## TVADCL                                                  ##
##                                                         ##
#############################################################

sub new_tvadcl($) {
	my ( $montant ) = @_;
	return __new($dbh,'TVADCL',
		'TVADCL_MONTANT='.$montant,
		'TVADCL_DATE='.dodate('now'));
}

sub tvadcl_par_id($) {
	return __par_id($dbh,'TVADCL',$_[0]);
}

sub tous_tvadcl() {
	return __tous($dbh,'TVADCL');
}

#############################################################
##                                                         ##
## CLOTURE                                                 ##
##                                                         ##
#############################################################


sub new_cloture($) { # Test
	my ( $date ) = @_;
	return __new($dbh,'CLOTURE',
		'CLOTURE_DATE='.dochar($date));
}

sub del_cloture($) { # Test
	my ( $clid ) = @_;
	return __del($dbh,'CLOTURE',$clid);
}

sub toutes_clotures() { # Test
	return __tous($dbh,'CLOTURE');
}

sub cloture_par_id($) { # Test
	return __par_id($dbh,'CLOTURE',$_[0]);
}

sub cloture_par_date($) { # Test
	my ( $date ) = @_;
	return __par_clef($dbh,'CLOTURE',$date,'CLOTURE_DATE');
}

#############################################################
##                                                         ##
## INFO                                                    ##
##                                                         ##
#############################################################


sub new_info($$$) { # Test
	my ( $type, $titre, $valeur ) = @_;
	return __new($dbh, 'INFO',
		'INFO_TYPE='.dochar($type),
		'INFO_VAL='.dochar($valeur),
		'INFO_TITRE='.dochar($titre),
		'INFO_DTIN='.dodate('now')
		);
}

sub set_info_titre($$) { # Test
	my ( $iid, $titre ) = @_;
	return __set_tbl_val($dbh,'INFO','INFO_TITRE',$iid,dochar($titre));
}

sub set_info_type($$) { # Test
	my ( $iid, $type ) = @_;
	return __set_tbl_val($dbh,'INFO','INFO_TYPE',$iid,dochar($type));
}

sub set_info_val($$) { # Test
	my ( $iid, $val ) = @_;
	return __set_tbl_val($dbh,'INFO','INFO_VAL',$iid,dochar($val));
}

sub info_par_id($) { # Test
	return __par_id($dbh,'INFO',$_[0]);
}

sub new_ligneinfo($$) { # Test
	my ( $lid, $iid ) = @_;
	return __set_relation($dbh,'LIGNE','INFO',$lid, $iid);
}

sub new_clientinfo($$) { # Test
	my ( $cid, $iid ) = @_;
	return __set_relation($dbh,'CLIENT','INFO',$cid,$iid);
}

sub new_comptainfo($$) { # Test
	my ( $cid, $iid ) = @_;
	return __set_relation($dbh,'COMPTA','INFO',$cid,$iid);
}

sub ligneinfo_par_ligne_id($) { # Test
	my ( $lid ) = @_;
	return __get_relation($dbh,'LIGNE','INFO','LIGNE',$lid);
}

sub clientinfo_par_client_id($) { # Test
	my ( $cid ) = @_;
	return __get_relation($dbh,'CLIENT','INFO','CLIENT',$cid);
}

sub comptainfo_par_compta_id($) { # Test
	my ( $cid ) = @_;
	return __get_relation($dbh,'COMPTA','INFO','COMPTA',$cid);
}

#############################################################
##                                                         ##
## ORDRETD                                                 ##
##                                                         ##
#############################################################


sub new_ordretd() { # Test
	return __new($dbh,'ORDRETD',
		'ORDRETD_DTIN='.dodate('now'));
}

sub set_ordretd_ligne($$) { # Test
	my ( $oid, $ligne ) = @_;
	return __set_tbl_val($dbh,'ORDRETD','ORDRETD_LIGNE',$oid,dochar($ligne));
}

sub set_ordretd_etat($$) { # Test
	my ( $oid, $etat ) = @_;
	return __set_tbl_val($dbh,'ORDRETD','ORDRETD_ETAT',$oid,dochar($etat));
}

sub set_ordretd_fichier($$) { # Test
	my ( $oid, $fichier ) = @_;
	return __set_tbl_val($dbh,'ORDRETD','ORDRETD_FICHIER',$oid,dochar($fichier));
}

sub ordretd_par_id($) { # Test
	return __par_id($dbh,'ORDRETD',$_[0]);
}

sub ordretd_par_etat($) { # Test
	my ( $etat ) = @_;
	return __par_clef($dbh,'ORDRETD',$etat,'ORDRETD_ETAT');
}

sub ordretd_par_fichier($) { # Test
	my ( $fichier ) = @_;
	return __par_clef($dbh,'ORDRETD',$fichier,'ORDRETD_FICHIER');
}



#############################################################
##                                                         ##
## PAYANT                                                  ##
##                                                         ##
#############################################################

sub new_payant($$$$$$$) {
	my ( $type, $libelle, $date, $debut, $fin, $prid, $clid ) = @_;
	return __new($dbh,'PAYANT',
		'PAYANT_TYPE='.dochar($type),
		'PAYANT_LIBELLE='.dochar($libelle),
		'PAYANT_DATE='.dodate($date),
		'PAYANT_DEBUT='.dodate($debut),
		'PAYANT_FIN='.dodate($fin),
		'PRIX_ID='.$prid,
		'CLIENT_ID='.$clid);
}

sub new_payant_unique($$$$) { # Test
	my ( $libelle, $date, $prid, $clid ) = @_;
	return __new($dbh,'PAYANT',
		'PAYANT_LIBELLE='.dochar($libelle),
		'PAYANT_TYPE='.dochar('unique'),
		'PAYANT_DATE='.dodate($date),
		'PAYANT_DEBUT='.dodate($date),
		'PAYANT_FIN='.dodate($date),
		'PRIX_ID='.$prid,
		'CLIENT_ID='.$clid);
}

sub new_payant_mensuel($$$$$$) { # Test
	my ( $libelle, $date, $debut, $fin, $prid, $clid ) = @_;
	return __new($dbh,'PAYANT',
		'PAYANT_LIBELLE='.dochar($libelle),
		'PAYANT_TYPE='.dochar('mensuel'),
		'PAYANT_DATE='.dodate($date),
		'PAYANT_DEBUT='.dodate($debut),
		'PAYANT_FIN='.dodate($fin),
		'PRIX_ID='.$prid,
		'CLIENT_ID='.$clid);
}

sub new_payant_annuel($$$$$$) { # Test
	my ( $libelle, $date, $debut, $fin, $prid, $clid ) = @_;
	return __new($dbh,'PAYANT',
		'PAYANT_LIBELLE='.dochar($libelle),
		'PAYANT_TYPE='.dochar('annuel'),
		'PAYANT_DATE='.dodate($date),
		'PAYANT_DEBUT='.dodate($debut),
		'PAYANT_FIN='.dodate($fin),
		'PRIX_ID='.$prid,
		'CLIENT_ID='.$clid);
}

sub payant_par_id($) { # Test
	return __par_id($dbh,'PAYANT',$_[0]);
}

sub payant_par_client_id($) { # Test
	return __par_clef($dbh,'PAYANT',$_[0],'CLIENT_ID');
}

sub set_payant_date($$) { # Test
	my ( $pid, $date ) = @_;
	return __set_tbl_val($dbh,'PAYANT','PAYANT_DATE',$pid,dodate($date));
}

sub set_payant_libelle($$) { # Test
	my ( $pid, $lib ) = @_;
	return __set_tbl_val($dbh,'PAYANT','PAYANT_LIBELLE',$pid,dochar($lib));
}

sub set_payant_type($$) { # Test
	my ( $pid, $type ) = @_;
	return __set_tbl_val($dbh,'PAYANT','PAYANT_TYPE',$pid,dochar($type));
}

sub set_payant_client_id($$) { # Test
	my ( $pid, $cid ) = @_;
	return __set_tbl_val($dbh,'PAYANT','CLIENT_ID',$pid,$cid);
}

sub set_payant_prix_id($$) { # Test
	my ( $paid, $pid ) = @_;
	return __set_tbl_val($dbh,'PAYANT','PRIX_ID',$paid,$pid);
}

sub set_payant_debut($$) { # Test
	my ( $pid, $date ) = @_;
	return __set_tbl_val($dbh,'PAYANT','PAYANT_DEBUT',$pid,dodate($date));
}

sub set_payant_fin($$) { # Test
	my ( $pid, $date ) = @_;
	return __set_tbl_val($dbh,'PAYANT','PAYANT_FIN',$pid,dodate($date));
}

#############################################################
##                                                         ##
## RADIUS                                                  ##
##                                                         ##
#############################################################

sub new_raduser($$) { # Test
	my ( $login, $gid ) = @_;
	return __new($dbh,'RADUSER',
		'RADUSER_LOGIN='.dochar($login),
		'RADGROUP_ID='.$gid);
}

sub del_raduser($) { # Test
	return __del($dbh,'RADUSER',$_[0]);
}

sub raduser_par_id($) { # Test
	return __par_id($dbh,'RADUSER',$_[0]);
}

sub raduser_par_login($) { # Test
	return __par_clef($dbh,'RADUSER',$_[0],'RADUSER_LOGIN');
}

sub raduser_par_radgroup_id($) { # Test
	return __par_clef($dbh,'RADUSER',$_[0],'RADGROUP_ID');
}

sub raduser_par_ligne_id($) { # Test
	return __par_clef($dbh,'RADUSER',$_[0],'LIGNE_ID');
}

sub set_raduser_login($$) { # Test
	my ( $uid, $login ) = @_;
	return __set_tbl_val($dbh,'RADUSER','RADUSER_LOGIN',$uid,dochar($login));
}

sub set_raduser_radgroup_id($$) { # Test
	my ( $uid, $gid ) = @_;
	return __set_tbl_val($dbh,'RADUSER','RADGROUP_ID',$uid,$gid);
}

sub set_raduser_ligne_id($$) { # Test
	my ( $uid, $lid ) = @_;
	return __set_tbl_val($dbh,'RADUSER','LIGNE_ID',$uid,$lid);
}

sub radgroup_par_id($) { # Test
	return __par_id($dbh,'RADGROUP',$_[0]);
}

sub radgroup_par_nom($) { # Test
	return __par_nom($dbh,'RADGROUP',$_[0],'RADGROUP_NOM');
}

sub lock_radius() { # Test
	return lock_soft($dbh,'radius');
}

sub unlock_radius() { # Test
	return unlock_soft($dbh,'radius');
}

#############################################################
##                                                         ##
## UATTR                                                   ##
##                                                         ##
#############################################################

sub new_uattr($$$$$) { # Test
	my ( $uid, $type, $attr, $op, $val ) = @_;
	return __new($dbh,'UATTR',
		'RADUSER_ID='.$uid,
		'UATTR_TYPE='.dochar($type),
		'UATTR_ATTR='.dochar($attr),
		'UATTR_OP='.dochar($op),
		'UATTR_VALUE='.dochar($val));
}

sub uattr_par_id($) { # Test
	return __par_id($dbh,'UATTR',$_[0]);
}

sub uattr_par_raduser_id($) { # Test
	return __par_clef($dbh,'UATTR',$_[0],'RADUSER_ID');
}

sub uattr_par_raduser_id_type($$) { # Test
	my ( $uid, $type ) = @_;
	return __par_champ_ext($dbh,'UATTR',
		[ [ 'UATTR.RADUSER_ID', '=', $uid          ],
		  [ 'UATTR_TYPE',       '=', dochar($type) ] ]);
}

sub set_uattr_attr($$) { # Test
	my ( $uid, $attr ) = @_;
	return __set_tbl_val($dbh,'UATTR','UATTR_ATTR',$uid,dochar($attr));
}

sub set_uattr_op($$) { # Test
	my ( $uid, $op ) = @_;
	return __set_tbl_val($dbh,'UATTR','UATTR_OP',$uid,dochar($op));
}

sub set_uattr_value($$) { # Test
	my ( $uid, $val ) = @_;
	return __set_tbl_val($dbh,'UATTR','UATTR_VALUE',$uid,dochar($val));
}

sub set_uattr_type($$) { # Test
	my ( $uid, $val ) = @_;
	return __set_tbl_val($dbh,'UATTR','UATTR_TYPE',$uid,dochar($val));
}

sub set_uattr_raduser_id($$) { # Test
	my ( $uid, $rid ) = @_;
	return __set_tbl_val($dbh,'UATTR','RADUSER_ID',$uid,$rid);
}

#############################################################
##                                                         ##
## GATTR                                                   ##
##                                                         ##
#############################################################

sub new_gattr($$$$$) { # Test
	my ( $gid, $type, $attr, $op, $val ) = @_;
	return __new($dbh,'GATTR',
		'RADGROUP_ID='.$gid,
		'GATTR_TYPE='.dochar($type),
		'GATTR_ATTR='.dochar($attr),
		'GATTR_OP='.dochar($op),
		'GATTR_VALUE='.dochar($val));
}

sub set_gattr_attr($$) { # Test
	my ( $gid, $attr ) = @_;
	return __set_tbl_val($dbh,'GATTR','GATTR_ATTR',$gid,dochar($attr));
}

sub set_gattr_op($$) { # Test
	my ( $gid, $op ) = @_;
	return __set_tbl_val($dbh,'GATTR','GATTR_OP',$gid,dochar($op));
}

sub set_gattr_value($$) { # Test
	my ( $gid, $val ) = @_;
	return __set_tbl_val($dbh,'GATTR','GATTR_VALUE',$gid,dochar($val));
}

sub set_gattr_type($$) { # Test
	my ( $gid, $val ) = @_;
	return __set_tbl_val($dbh,'GATTR','GATTR_TYPE',$gid,dochar($val));
}

sub set_gattr_radgroup_id($$) { # Test
	my ( $gid, $rid ) = @_;
	return __set_tbl_val($dbh,'GATTR','RADGROUP_ID',$gid,$rid);
}

sub gattr_par_id($) { # Test
	return __par_id($dbh,'GATTR',$_[0]);
}

sub gattr_par_radgroup_id($) { # Test
	return __par_clef($dbh,'GATTR',$_[0],'RADGROUP_ID');
}

sub gattr_par_radgroup_id_type($$) { # Test
	my ( $gid, $type ) = @_;
	return __par_champ_ext($dbh,'GATTR',
		[ [ 'GATTR.RADGROUP_ID', '=', $gid ],
		  [ 'GATTR_TYPE',        '=', dochar($type) ] ]);
}

#############################################################
##                                                         ##
## IPADDR                                                  ##
##                                                         ##
#############################################################

sub new_ipaddr($$$) { # Test
	my ( $ip, $mask, $type ) = @_;
	return __new($dbh,'IPADDR',
		'IPADDR_ADDR='.dochar($ip),
		'IPADDR_MASK='.dochar($mask),
		'IPADDR_TYPE='.dochar($type),
		'IPADDR_ETAT='.dochar('free'),
		'RADUSER_ID=-1');
}

sub ipaddr_par_id($) { # Test
	return __par_id($dbh,'IPADDR',$_[0]);
}

sub toutes_ips() { # Test
	return __tous($dbh,'IPADDR');
}

sub ipaddr_par_etat_type($$) { # Test
	my ( $etat, $type ) = @_;
	return __par_champ_ext($dbh,'IPADDR',
		[ [ 'IPADDR_ETAT', '=', dochar($etat) ],
		  [ 'IPADDR_TYPE', '=', dochar($type) ] ],
		{ 'range' => '+10' }); # limit 10
}

sub ipaddr_par_raduser_id($) { # Test
	return __par_clef($dbh,'IPADDR',$_[0],'RADUSER_ID');
}

sub ipaddr_par_addr($) { # Test
	return __par_clef($dbh,'IPADDR',$_[0],'IPADDR_ADDR');
}

sub set_ipaddr_etat($$) { # Test
	my ( $ipid, $etat ) = @_;
	return __set_tbl_val($dbh,'IPADDR','IPADDR_ETAT',$ipid,dochar($etat));
}

sub set_ipaddr_raduser_id($$) { # Test
	my ( $ipid, $uid ) = @_;
	return __set_tbl_val($dbh,'IPADDR','RADUSER_ID',$ipid,$uid);
}

sub lock_ip() {
	return lock_soft($dbh,'ip');
}

sub unlock_ip() {
	return unlock_soft($dbh,'ip');
}

#############################################################
##                                                         ##
## COMPTA                                                  ##
##                                                         ##
#############################################################

sub new_compta($) { # Test
	my ( $nom ) = @_;
	return __new($dbh,'COMPTA','COMPTA_NOM='.dochar($nom));
}

sub compta_par_id($) { # Test
	return __par_id($dbh,'COMPTA',$_[0]);
}

sub tous_comptas() { # Test
	return __tous($dbh,'COMPTA');
}

sub set_compta_nom($$) { # Test
	my ( $id, $nom ) = @_;
	return __set_tbl_val($dbh,'COMPTA','COMPTA_NOM',$id,dochar($nom));
}

#############################################################
##                                                         ##
## ADHACCESS                                               ##
##                                                         ##
#############################################################

sub new_adhaccess($$$) { # Test
	my ( $cid, $login, $passwd ) = @_;
	return __new($dbh,'ADHACCESS',
		'ADHACCESS_LOGIN='.dochar($login),
		'ADHACCESS_PASSWD='.dochar($passwd),
		'CLIENT_ID='.$cid);
}

sub adhaccess_par_id($) { # Test
	return __par_id($dbh,'ADHACCESS',$_[0]);
}

sub adhaccess_par_login($) { # Test
	return __par_clef($dbh,'ADHACCESS',$_[0],'ADHACCESS_LOGIN');
}

sub adhaccess_par_client_id($) { # Test
	return __par_clef($dbh,'ADHACCESS',$_[0],'CLIENT_ID');
}

sub set_adhaccess_login($$) { # Test
	my ( $aid, $login ) = @_;
	return __set_tbl_val($dbh,'ADHACCESS','ADHACCESS_LOGIN',$aid,dochar($login));
}

sub set_adhaccess_passwd($$) { # Test
	my ( $aid, $passwd ) = @_;
	return __set_tbl_val($dbh,'ADHACCESS','ADHACCESS_PASSWD',$aid,dochar($passwd));
}

sub set_adhaccess_client_id($$) { # Test
	my ( $aid, $cid ) = @_;
	return __set_tbl_val($dbh,'ADHACCESS','CLIENT_ID',$aid,$cid);
}

#############################################################
##                                                         ##
## SITE                                                    ##
##                                                         ##
#############################################################

sub new_site($$$) { # Tests
	my ( $site, $login, $passwd ) = @_;
	return __new($dbh,'SITE',
		'SITE_SITE='.dochar($site),
		'SITE_LOGIN='.dochar($login),
		'SITE_PASSWD='.dochar($passwd));
}

sub site_par_id($) { # Tests
	return __par_id($dbh,'SITE',$_[0]);
}

sub site_par_site($) { # Tests
	return __par_clef($dbh,'SITE',$_[0],'SITE_SITE');
}

sub site_par_login($) { # Tests
	return __par_clef($dbh,'SITE',$_[0],'SITE_LOGIN');
}

sub site_par_client_id($) { # Tests
	return __par_clef($dbh,'SITE',$_[0],'CLIENT_ID');
}

sub set_site_login($$) { # Tests
	my ( $sid, $login ) = @_;
	return __set_tbl_val($dbh,'SITE','SITE_LOGIN',$sid,dochar($login));
}

sub set_site_site($$) { # Tests
	my ( $sid, $site ) = @_;
	return __set_tbl_val($dbh,'SITE','SITE_SITE',$sid,dochar($site));
}

sub set_site_passwd($$) { # Tests
	my ( $sid, $passwd ) = @_;
	return __set_tbl_val($dbh,'SITE','SITE_PASSWD',$sid,dochar($passwd));
}

sub set_site_client_id($$) { # Tests
	my ( $sid, $cid ) = @_;
	return __set_tbl_val($dbh,'SITE','CLIENT_ID',$sid,$cid);
}


#############################################################
##                                                         ##
## DOMAINE                                                 ##
##                                                         ##
#############################################################

sub new_domaine($$) { # Tests
	my ( $nom, $type ) = @_;
	return __new ( $dbh, 'DOMAINE',
		'DOMAINE_NOM='.dochar($nom),
		'DOMAINE_TYPE='.dochar($type)
		);
}

sub domaine_par_id($) { # Tests
	return __par_id($dbh,'DOMAINE',$_[0]);
}

sub domaine_par_nom($) { # Tests
	return __par_clef($dbh,'DOMAINE',$_[0],'DOMAINE_NOM');
}

sub domaine_par_client_id($) { # Tests
	return __par_clef($dbh,'DOMAINE',$_[0],'CLIENT_ID');
}

sub set_domaine_nom($$) { # Tests
	my ( $did, $nom ) = @_;
	return __set_tbl_val($dbh,'DOMAINE','DOMAINE_NOM',$did,dochar($nom));
}

sub set_domaine_type($$) { # Tests
	my ( $did, $type ) = @_;
	return __set_tbl_val($dbh,'DOMAINE','DOMAINE_TYPE',$did,dochar($type));
}

sub set_domaine_zone($$) { # Tests
	my ( $did, $zone ) = @_;
	return __set_tbl_val($dbh,'DOMAINE','DOMAINE_ZONE',$did,dochar($zone));
}

sub set_domaine_client_id($$) { # Tests
	my ( $did, $cid ) = @_;
	return __set_tbl_val($dbh,'DOMAINE','CLIENT_ID',$did,$cid);
}

sub set_domaine_dnspri($$) { # Tests
	my ( $did, $dns ) = @_;
	return __set_tbl_val($dbh,'DOMAINE','DOMAINE_DNSPRI',$did,dochar($dns));
}

sub set_domaine_file($$) { # Tests
	my ( $did, $file ) = @_;
	return __set_tbl_val($dbh,'DOMAINE','DOMAINE_FILE',$did,dochar($file));
}

#############################################################
##                                                         ##
## NOTIF                                                   ##
##                                                         ##
#############################################################

sub new_notif($$) { # Tests
	my ( $cid, $type ) = @_;
	return __new($dbh, 'NOTIF',
		'NOTIF_TYPE='.dochar($type),
		'NOTIF_ETAT='.dochar('open'),
		'LIGNE_ID='.$cid
		);
}

sub notif_par_id($) { # Tests
	return __par_id($dbh,'NOTIF',$_[0]);
}

sub notif_par_etat($) { # Tests
	return __par_clef($dbh,'NOTIF',$_[0],'NOTIF_ETAT');
}

sub notif_par_type($) {
	return __par_clef($dbh,'NOTIF',$_[0],'NOTIF_TYPE');
}

sub notif_par_ligne_id($) {
	return __par_clef($dbh,'NOTIF',$_[0],'LIGNE_ID');
}

sub set_notif_type($$) {
	my ( $nid, $type ) = @_;
	return __set_tbl_val($dbh,'NOTIF','NOTIF_TYPE',$nid,dochar($type));
}

sub set_notif_etat($$) {
	my ( $nid, $etat ) = @_;
	return __set_tbl_val($dbh,'NOTIF','NOTIF_ETAT',$nid,dochar($etat));
}

sub set_notif_ligne_id($$) {
	my ( $nid, $cid ) = @_;
	return __set_tbl_val($dbh,'NOTIF','LIGNE_ID',$nid,$cid);
}

#############################################################
##                                                         ##
## UNIXUSER                                                ##
##                                                         ##
#############################################################

sub new_unixuser($$$$$$$) { # Test
	my ( $name, $passwd, $uid, $gid, $home, $shell, $gecos ) = @_;
	return __new($dbh, 'UNIXUSER',
		'UNIXUSER_NAME='.dochar($name),
		'UNIXUSER_PASSWD='.dochar($passwd),
		'UNIXUSER_UID='.dochar($uid),
		'UNIXUSER_GID='.dochar($gid),
		'UNIXUSER_HOME='.dochar($home),
		'UNIXUSER_SHELL='.dochar($shell),
		'UNIXUSER_GECOS='.dochar($gecos),
		'UNIXUSER_DTIN='.dodate('now'),
		'UNIXUSER_STATE='.dochar('ok')
	);
}

sub unixuser_par_id($) { # Test
	my ( $id ) = @_;
	return __par_id($dbh,'UNIXUSER',$id);
}

sub unixuser_par_uid($) { # Test
	my ( $id ) = @_;
	return __par_clef($dbh,'UNIXUSER',$id,'UNIXUSER_UID');
}

sub unixuser_par_name($) { # Test
	my ( $name ) = @_;
	return __par_nom($dbh,'UNIXUSER',$name,'UNIXUSER_NAME');
}

sub unixuser_par_client_id($) { # Test
	my ( $cid ) = @_;
	return __par_clef($dbh,'UNIXUSER',$cid,'CLIENT_ID');
}

sub set_unixuser_passwd($$) { # Test
	my ( $id, $passwd ) = @_;
	return __set_tbl_val($dbh,'UNIXUSER','UNIXUSER_PASSWD',$id,dochar($passwd));
}

sub set_unixuser_state($$) { # Test
	my ( $id, $state ) = @_;
	return __set_tbl_val($dbh,'UNIXUSER','UNIXUSER_STATE',$id,dochar($state));
}

sub set_unixuser_dtout($$) { # Test
	my ( $id, $dtout ) = @_;
	return __set_tbl_val($dbh,'UNIXUSER','UNIXUSER_DTOUT',$id,dodate($dtout));
}

sub set_unixuser_client_id($$) { # Test
	my ( $id, $cid ) = @_;
	return __set_tbl_val($dbh,'UNIXUSER','CLIENT_ID',$id,$cid);
}

#############################################################
##                                                         ##
## UNIXGROUP                                               ##
##                                                         ##
#############################################################

sub new_unixgroup($$) { # Test
	my ( $gid, $name ) = @_;
	return __new($dbh, 'UNIXGROUP',
		'UNIXGROUP_NAME='.dochar($name),
		'UNIXGROUP_GID='.dochar($gid));
}

sub tous_unixgroup() { # Test
	return __tous($dbh,'UNIXGROUP');
}

sub unixgroup_par_id($) { # Test
	my ( $id ) = @_;
	return __par_id($dbh,'UNIXGROUP',$id);
}

sub unixgroup_par_gid($) { # Test
	my ( $gid ) = @_;
	return __par_clef($dbh,'UNIXGROUP',$gid,'UNIXGROUP_GID');
}

sub unixgroup_par_name($) { # Test
	my ( $name ) = @_;
	return __par_nom($dbh,'UNIXGROUP',$name,'UNIXGROUP_NAME');
}

#############################################################
##                                                         ##
## UNIXUSERUNIXGROUP                                       ##
##                                                         ##
#############################################################

sub new_unixuserunixgroup($$) { # Test
	my ( $uuid, $ugid ) = @_;
	return __set_relation($dbh,'UNIXUSER','UNIXGROUP',$uuid,$ugid);
}

sub del_unixuserunixgroup($$) { # Test
	my ( $uuid, $ugid ) = @_;
	return __del_relation($dbh,'UNIXUSER','UNIXGROUP',$uuid,$ugid);
}

sub unixuserunixgroup_par_unixgroup_id($) { # Test
	my ( $ugid ) = @_;
	return __get_relation($dbh,'UNIXUSER','UNIXGROUP','UNIXGROUP',$ugid);
}

sub unixuserunixgroup_par_unixuser_id($) { # Test
	my ( $uuid ) = @_;
	return __get_relation($dbh,'UNIXUSER','UNIXGROUP','UNIXUSER',$uuid);
}

#############################################################
##                                                         ##
## VALIDATION                                              ##
##                                                         ##
#############################################################

sub new_validation($$$$$) { # Tests
	my ( $type, $event, $info, $lid, $cid ) = @_;
	return __new ( $dbh, 'VALIDATION',
		'VALIDATION_TYPE='.dochar($type),
		'VALIDATION_EVENT='.dochar($event),
		'VALIDATION_INFO='.dochar($info),
		'VALIDATION_ETAT='.dochar('new'),
		'LIGNE_ID='.$lid,
		'CLIENT_ID='.$cid);
}

sub tous_validations() { # Tests
	return __tous($dbh, 'VALIDATION');
}

sub validation_par_id($) { # Tests
	my ( $id ) = @_;
	return __par_id($dbh, 'VALIDATION', $id );
}

sub validation_par_client_id($) { # Tests
	my ( $cid ) = @_;
	return __par_clef($dbh, 'VALIDATION', $cid, 'CLIENT_ID' );
}

sub validation_par_ligne_id($) { # Tests
	my ( $lid ) = @_;
	return __par_clef($dbh, 'VALIDATION', $lid, 'LIGNE_ID' );
}

sub validation_par_etat($) { # Tests
	my ( $etat ) = @_;
	return __par_clef($dbh, 'VALIDATION', $etat, 'VALIDATION_ETAT' );
}

sub validation_par_type($) { # Tests
	my ( $type ) = @_;
	return __par_clef($dbh, 'VALIDATION', $type, 'VALIDATION_TYPE' );
}

sub validation_par_type_etat($$) { # Test
	my ( $type, $etat ) = @_;
	return __par_champ_ext($dbh,'VALIDATION',
		[ [ 'ETAT', '=', dochar($etat) ],
		  [ 'TYPE', '=', dochar($type)  ] ]);
}

sub set_validation_etat($$) { # Tests
	my ( $vid, $etat ) = @_;
	return __set_tbl_val($dbh, 'VALIDATION', 'VALIDATION_ETAT', $vid, dochar($etat) );
}


1;




