package FDN::Adsl::Infos;

use strict;
use Exporter ;

our @ISA = ( 'Exporter' ) ;
our @EXPORT = qw (
		toutes_infos_client
		toutes_infos_ligne
		toutes_infos_compta
		new_info_client
		new_info_ligne
		new_info_compta
                );
our @EXPORT_OK = qw ();

use FDN::Common::Logger;
use FDN::Adsl::Basic;

our $debug = 0;
sub __debug($) {
	return if ! $debug;
	debug $_[0];
}

sub toutes_infos_ligne($) { # Test
	my ( $lid ) = @_;
	my @lis = ligneinfo_par_ligne_id($lid);
	__debug "Infos pour le ligne $lid.";
	return __toutes_infos(@lis);
}

sub toutes_infos_client($) { # Test
	my ( $cid ) = @_;
	my @cis = clientinfo_par_client_id($cid);
	__debug "Infos pour le client $cid.";
	return __toutes_infos(@cis);
}

sub toutes_infos_compta($) { # Test
	my ( $cid ) = @_;
	my @cis = comptainfo_par_compta_id($cid);
	__debug "Infos pour le compta $cid.";
	return __toutes_infos(@cis);
}

sub __toutes_infos(@) { # Test
	my @infos = @_;
	my @res;
	my $info;
	for my $i ( @infos ) {
		$info = info_par_id($i->{'INFO_ID'});
		if ( defined $info ) {
			__debug "Ajout infos ".$i->{'INFO_ID'}.".";
			push @res, $info;
		}
	}
	return @res;
}


sub new_info_client($$$$) { # Test
	my ( $cid, $type,$titre, $info ) = @_;
	my $iid = new_info($type,$titre, $info);
	__debug "Creation de l'info $iid pour le client $cid.";
	new_clientinfo($cid,$iid);
	return $iid;
}

sub new_info_ligne($$$$) { # Test
	my ( $lid, $type, $titre, $info ) = @_;
	my $iid = new_info($type, $titre, $info);
	__debug "Creation de l'info $iid pour la ligne $lid.";
	new_ligneinfo($lid,$iid);
	return $iid;
}

sub new_info_compta($$$$) { # Test
	my ( $cid, $type, $titre, $info ) = @_;
	my $iid = new_info($type, $titre, $info);
	__debug "Creation de l'info $iid pour le compta $iid.";
	new_comptainfo($cid,$iid);
	return $iid;
}

1;

