package FDN::Adsl::Mandat;

use strict;
use Exporter;

our @ISA = ( 'Exporter' ) ;
our @EXPORT = qw (
		create_mandat
		clone_mandat
		);
our @EXPORT_OK = qw ();

use FDN::TeX::TeX;
use FDN::Web::TemplateParse;
use FDN::Adsl::Basic;

sub create_mandat($$$$$;$) {
	my ( $tel, $nom, $adr, $cp, $ville, $detenteur ) = @_;
	if ( ! defined $detenteur ) {
		$detenteur = 'fdn';
	}
	my $mid = new_mandat(-1,$detenteur);
	my $num = 'Y'. ('0' x (7-length($mid))) . $mid;
	set_mandat_numero($mid,$num);
	
	my $hash = {
		'NOM'     => $nom,
		'ADRESSE' => $adr,
		'CP'      => $cp,
		'VILLE'   => $ville,
		'TEL'     => $tel,
		'MANDAT'  => $num
	};
	set_tex_config('adsl/tex.cfg');
	my $file = make_pdf_file('mandat',$mid,$hash);
	if ( defined $file ) {
		set_mandat_fichier($mid,$file);
		return $mid;
	} else {
		return undef;
	}
}

sub clone_mandat($) {
	my ( $mid ) = @_;
	my $m = mandat_par_id($mid);
	if ( ! defined $m ) {
		return undef;
	}
	my $nmid = new_mandat(-1,$m->{'MANDAT_DETENTEUR'});
	if ( ! defined $nmid || $nmid < 0 ) {
		return undef;
	}
	set_mandat_numero($nmid, $m->{'MANDAT_NUMERO'});
	set_mandat_fichier($nmid, $m->{'MANDAT_FICHIER'});
	set_mandat_image($nmid,$m->{'MANDAT_IMAGE'});
	return $nmid;
}

1;
