package FDN::Adsl::Plutar;

use strict;
use Exporter;
our @ISA = ( 'Exporter' ) ;
our @EXPORT = qw (
	test_eligibilite
);
our @EXPORT_OK = qw ();
our %EXPORT_TAGS = ();

use strict;
use FDN::Common::Modules;
use FDN::Common::Logger;
use FDN::Sql::DBC;
use FDN::Sql::Plutar::Constantes;
use FDN::Adsl::Basic;
use FDN::Adsl::SelN;

our $dbh;
our $notify_str = '';

BEGIN {
	$dbh = do_connect('adsl');
}

sub get_dbh() {
	return $dbh;
}

sub get_notify() {
	return $notify_str;
}

sub test_eligibilite($) {
	my ( $args ) = @_;
#	conduse('FDN::Adsl::Sel9');
	conduse('FDN::Adsl::SelN');
	conduse('FDN::Sql::Workflow::Run');
	workflow_select_db('adsl');
	my $offre = $args->{'offre'};
	$offre =~ s/option/opt/;
	my $tel   = $args->{'tel'};
	my $cp    = $args->{'cp'};
	my $eid   = $args->{'eid'};
	debug "J'interroge le serveur d'eligibilite sur l'offre $offre pour la ligne $tel";
	my $res = eligibilite($tel,$cp,[$offre]);
	if ( ! defined $args->{'resultats' } ) {
		$args->{'resultats'} = [];
	}
	if ( ! defined $res->{'body'} ) {
		$res->{'body'} = '<UNDEF>';
	}
	if ( $res->{'etat'} == 1 ) {
		# Serveur indisponible
		push @{$args->{'resultats'}}, "Retour etat 1 (serveur FT ou TD indispo). Retry.";
		return PLUTAR_RETRY;
	}
	if ( $res->{'etat'} == 2 ) {
		# Erreur chez FDN
		push @{$args->{'resultats'}}, "Retour etat 2. Bug FDN. A creuser.";
		set_eligibilite_reponse($eid,$res->{'body'});
		set_eligibilite_dttest($eid);
		send_event_elig($eid,0);
		return PLUTAR_FAILED;
	}
	if ( $res->{'etat'} == 3 ) {
		# Probleme sur le numero de telephone
		push @{$args->{'resultats'}}, "Retour etat 3. Numero de telephone invalide.";
		set_eligibilite_reponse($eid,$res->{'body'});
		set_eligibilite_dttest($eid);
		send_event_elig($eid,0);
		return PLUTAR_FAILED;
	}
	if ( $res->{'etat'} ) {
		# Etat impossible.
		push @{$args->{'resultats'}}, "Retour etat inconnu. Regarder la reponse dans la base.";
		set_eligibilite_reponse($eid,$res->{'body'});
		set_eligibilite_dttest($eid);
		send_event_elig($eid,0);
		return PLUTAR_FAILED;
	}
	if ( ! defined $res->{'offres'} ||
	     ! defined $res->{'offres'}->{$offre} ||
	     ! defined $res->{'offres'}->{$offre}->{'faisable'} ) {
	     	push @{$args->{'resultats'}}, "Reponse du module FDN::Adsl::SelN invalide.";
		set_eligibilite_reponse($eid,$res->{'body'});
		set_eligibilite_dttest($eid);
		send_event_elig($eid,0);
		return PLUTAR_FAILED;
	}
	set_eligibilite_reponse($eid,$res->{'body'});
	set_eligibilite_dttest($eid);
	if ( $res->{'offres'}->{$offre}->{'faisable'} ) {
		send_event_elig($eid,1);
		# send_event faisable
	} else {
		# send_event pas faisable
		send_event_elig($eid,0);
	}
	return PLUTAR_SUCCESS;
}

sub send_event_elig($$) {
	my ( $eid, $faisable ) = @_;
	send_event('ELIG-'.$eid,{'faisable'=>$faisable});
}


1;
