package FDN::Adsl::Wf;

use strict;
use Exporter ;

our @ISA = ( 'Exporter' ) ;
our @EXPORT = qw (
	faire_clef_telephone
	faire_clef_td
	faire_clef_fix


	deployer_ligne_adsl
	deployer_ligne_adsl_9t
	deployer_ligne_adsl_nerim

	test_eligibilite_ligne
	test_eligibilite_ligneN
	attends_paiement_fas
	attend_ok_nerim
	prepare_commande_td
	prepare_commande_9t
	prepare_commande_nerim
	cree_login_radius
	attend_ar_td
	attend_cr_td

	resilier_ligne_adsl
	perte_ligne_adsl
	
	prepare_resil_td
	resiliation_radius
	free_ip
	stop_factu_ligne

	changer_ligne_adsl_9t
	changer_ligne_adsl_nerim


	mail_bureau
	notif_change_num
	notif_perte_ligne
	
	clean_old_events
	);
our @EXPORT_ID = qw (
	);
our @EXPORT_OK;
our %EXPORT_TAG;

use FDN::Common::Config;
use FDN::Common::Logger;
use FDN::Common::Modules;
use FDN::Sql::Basic;
use FDN::Adsl::DBC;
use FDN::Adsl::Basic;
use FDN::Adsl::Radius;
use FDN::Adsl::Utils;
use FDN::Adsl::Infos;
use FDN::Sql::Workflow::Run;
use FDN::Sql::Workflow::Basic;
use FDN::Web::TemplateParse;
use Data::Dumper;
use Mail::Sendmail;
use POSIX qw(strftime);

BEGIN {
	$FDN::Sql::Workflow::Run::debug=1;
}

sub __envoie_mail($$$$);
sub __ligne_ordre(%);
sub __prt_euro($);
sub x_error($);
sub x_info($);

our @mails;

my $rejets_td = {
	'F03'  => "Valeur du champ 'Ordre de la demande' non reference en base",
	'F04'  => "Champ 'Nom du client' trop long",
	'F05'  => "Champ 'Prenom du client' trop long",
	'F07'  => "Champ 'Numero de contact du client' trop long",
	'F09'  => "Champ 'Numero de chrono operateur' trop long",
	'F10'  => "Valeur du champ 'Contrat' non referencee en base",
	'F12'  => "(option 3) Valeur du champ 'Numero de support' invalide", # Quid?
	'F13'  => "Champ 'Commentaire operateur' trop long",
	'F14'  => "Valeur du champ 'Code offre' non reference en base",
	'F16'  => "Valeur du champ 'Code postal' invalide",
	'F20'  => "Champ 'Ordre' non specifie",
	'F22'  => "Champ 'Contrat' non specifie",
	'F23'  => "Champ 'Identifiant de la commande pour l emetteur' non specifie",
	'F26'  => "(option 1) Champ 'adresse du client' trop long",
	'F27'  => "(option 1) Champ 'Prenom et nom d un contact' invalide",
	'F29'  => "Champ 'Numero de telephone de contact' invalide",
	'F37'  => "(impossible) Champ 'Regime de SAV' non specifie",
	'F38'  => "(impossible) Valeur du champ 'Regime de SAV' non reference en base",
	'F40'  => "(option 1) Champ 'Identifiant de la ligne' non specifie",
	'F41'  => "(option 1) Format du champ 'Identifiant de la ligne' invalide",
	'F44'  => "(impossible) Champ 'Adresse d installation' non specifie ou trop long",
	'F57'  => "Couple Ordre/CodeOffre impossible (demande de debit non-degroupe sur acces degroupe ou le contraire)",
	'F58'  => "(option 1) Valeur du champ 'Type de ligne' invalide",
	'F59'  => "(option 1) Champ 'Commune' invalide",
	'F60'  => "(option 1) Numero de mandat invalide",
	'F61'  => "(option 1) Champ 'Statut' invalide",
	'F84'  => "Champ 'Numero de Chrono Operateur' non specifie",
	'F121' => "Valeur du champ 'mandat' invalide (pour une migration)",
	'F123' => "Valeur du champ 'offre de l ancien titulaire' invalide (pour une migration)",
	'F126' => "(impossible) Offre non ouverte sur ce protocole",
	'HA08' => "(option 3) Une autre demande est en cours d'acquisition pour la ligne demandee",
	'HA09' => "(option 3) Une autre demande est en attente d'execution pour la ligne ou l'adresse demandee",
	'HA11' => "La demande de modification ou de suppression ne concerne pas une ligne existante et detenue par l'operateur",
	'HA13' => "Annulation rejetee: aucune demande correspondante en cours de traitement",
	'HA14' => "(option 1) La demande de modification ne concerne pas une ligne totalement degroupee, au profit du meme operateur",
	'HA15' => "La ligne supporte une offre Option 1, au profit du meme operateur. Le message en cas de CR de rejet est plus clair: La demande de creation concerne une ligne deja degroupee (de meme type) au profit du meme operateur",
	'HA20' => "(option 3) La contrat specifie dans la demande n'est pas habilite sur le CCL demande", #Quid?
	'HA21' => "(option 3) Il n'y a plus de disponibilite dans le CCL",
	'HA23' => "La ligne supporte une offre Option 3, au profit du meme operateur", #Quid?
	'HA28' => "(option 3) La demande de modification ne porte pas sur une offre autorisee dans le protocole d'echange",
	'HA29' => "(option 3) La demande de suppression ne correspond ni a une offre ni a un operateur existant",
	'HA36' => "La ligne devant etre migree ne porte pas sur l'offre specifiee",
	'HA37' => "La ligne devant etre migree n'est pas detenue par l'operateur specifie",
	'HA38' => "(option 3) Une autre demande est en cours sur le meme CCL et le meme VC",
	'HC01' => "Le contrat specifie dans la demande n'est pas detenu par l'operateur",
	'HC02' => "Le contrat specifie dans la demande n'est pas actif",
	'HC03' => "Le contrat specifie dans la demande n'est pas habilite pour l'ofrre demandee ou l'ordre INFORMATION",
	'HC04' => "Le contrat specifie dans la demande est habilite pour l'offre objet de la demande, mais pas pour l'ordre associe",
	'RC01' => "(option 1) Valeur du champ 'Nom' non specifie",
	'RC02' => "(option 1) Valeur du champ 'Prenom' non specifie",
	'RC03' => "(option 1) Valeur du champ 'Adresse' invalide",
	'RC04' => "(option 1) Valeur du champ 'Code postal installation' invalide",
	'RC05' => "(option 1) Valeur du champ 'Commune installation' invalide",
	'RC06' => "(option 1) Valeur du champ 'Complement d adresse' trop long",
	'RC07' => "(option 1) Valeur du champ 'Fax du contact' de longueur invalide",
	'RC08' => "(option 1) Valeur du champ 'Fax du contact' invalide",
	'RC09' => "(option 1) Valeur du champ 'Vpi, carte ou nb de lignes' de longueur invalide",
	'RC10' => "(option 1) Valeur du champ 'Vpi, carte ou nb de lignes' invalide",
	'RC11' => "(option 1) Valeur du champ 'Vci, port ou carte' de longueur invalide",
	'RC12' => "(option 1) Valeur du champ 'Vci, port ou carte' invalide",
	'RC13' => "(option 1) Valeur du champ 'Point de livraison operateur client' de longueur invalide",
	'RC14' => "(option 1) Valeur du champ 'Desserte interne' doit etre 'O' ou 'N'",
	'RC15' => "(option 1) Valeur du champ 'Longueur desserte' invalide",
	'RC16' => "(option 1) Valeur du champ 'Date de MAD des locaux UF' invalide",
	'RC17' => "(option 1) Valeur du champ 'Date souhaitee de MAD du service' invalide",
	'RC18' => "(option 1) Valeur du champ 'Libelle OSM' invalide",
	'RC19' => "(option 1) Valeur du champ 'Interface de l extremite cote UF' invalide",
	'RC20' => "(option 1) Le contrat specifie dans la demande n'est pas habilite sur le Point de livraison demande",
	'SU01' => "(option 1) Commande en surcharge par le meme operateur",
	'SU02' => "(option 1) Commande en surcharge par un autre operateur",
	'RH01' => "Annulation rejetee: delai contractuel depasse",
	'NOK_DATE' => "Desaccord sur la date de migration proposee par l'operateur",
	'R0' => "Erreur applicative, code rejet indetermine",
};

my $rejets_9t = {
	'AIM' => 'Annulation impossible',
	'ANE' => 'Ligne ou utilisateur non ligible',
	'ANN' => "Rejet suite  une commande d'annulation",
	'ARE' => "Commande rejete",
	'CNA' => "Contrat non actif",
	'CND' => "Contrat non dtenu par le client",
	'DBL' => "Rejet pour cause de bouclon de commande",
	'DHC' => "Ordre de la commande hors contrat",
	'E01' => "Champ invalide 1 (entete/\@code_client)",
	'E02' => "Champ invalide 2 (commande/\@date_commande)",
	'E03' => "Champ invalide 3 (commande/\@code_echange)",
	'E04' => "Champ invalide 4 (commande/infos_generales/\@code_service)",
	'E05' => "Champ invalide 5 (commande/\@id_contrat)",
	'E06' => "Champ invalide 6 (commande/\@id_commande_client)",
	'E07' => "Champ invalide 7 (commande/infos_generales/\@reference_eligibilite)",
	'E08' => "Champ invalide 8 (commande/infos_generales/\@id_mandat)",
	'E09' => "Champ invalide 9 (commande/infos_utilisateur/\@nom_prenom_utilisateur)",
	'E10' => "Champ invalide 10 (commande/infos_utilisateur/\@adresse_utilisateur)",
	'E11' => "Champ invalide 11 (commande/infos_utilisateur/\@comp_adresse_utilisateur)",
	'E12' => "Champ invalide 12 (commande/infos_utilisateur/\@code_postal_utilisateur)",
	'E13' => "Champ invalide 13 (commande/infos_utilisateur/\@commune_utilisateur)",
	'E14' => "Champ invalide 14 (commande/infos_ligne/\@type_ligne)",
	'E15' => "Champ invalide 15 (commande/infos_ligne/\@statut_ligne)",
	'E16' => "Champ invalide 16 (commande/infos_ligne/\@identifiant_ligne)",
	'E17' => "Champ invalide 17 (commande/infos_techniques/\@type_degroupage)",
	'E18' => "Champ invalide 18 (commande/infos_techniques/\@portabilite)",
	'E19' => "Champ invalide 19 (commande/infos_techniques/\@regime_sav)",
	'E20' => "Champ invalide 20 (commande/infos_LL/\@adresse_LL)",
	'E21' => "Champ invalide 21 (commande/infos_LL/\@code_postal_LL)",
	'E22' => "Champ invalide 22 (commande/infos_LL/\@commune_LL)",
	'E23' => "Champ invalide 23 (commande/infos_contact/\@nom_prenom_contact)",
	'E24' => "Champ invalide 24 (commande/infos_contact/\@telephone_contact)",
	'E25' => "Champ invalide 25 (commande/commentaire_cmd/\@commentaire)",
	'E26' => "Champ invalide 26 (commande/\@type_modif)",
	'E27' => "Champ invalide 27 (commande/infos_techniques/\@mode_livraison)",
	'E28' => "Champ invalide 28 (commande/infos_techniques/\@conduit)",
	'E29' => "Champ invalide 29 (commande/infos_utilisateur/\@reference_utilisateur)",
	'E30' => "Champ invalide 30 (commande/infos_utilisateur/\@login_utilisateur)",
	'E31' => "Champ invalide 31 (commande/infos_cpe/\@achat_cpe)",
	'E32' => "Champ invalide 32 (commande/infos_cpe/\@location_cpe)",
	'E33' => "Champ invalide 33 (commande/infos_cpe/\@installation_cpe)",
	'E34' => "Champ invalide 34 (commande/infos_cpe/\@modem)",
	'E35' => "Champ invalide 35 (commande/infos_cpe/\@routeur)",
	'E36' => "Champ invalide 36 (commande/infos_contact/\@telephone2_contact)",
	'E37' => "Champ invalide 37 (commande/infos_contact/\@e-mail_contact)",
	'E38' => "Champ invalide 38 (commande/infos_utilisateur/\@code_siret)",
	'E39' => "Champ invalide 39 (commande/infos_techniques/\@option_mes)",
	'E40' => "Champ invalide 40 (commande/infos_techniques/\@longueur_desserte_interne)",
	'E41' => "Champ invalide 41 (commande/infos_techniques/\@option_VP)",
	'E42' => "Champ invalide 42 (commande/infos_cpe/\@interface)",
	'E43' => "Champ invalide 43 (commande/\@id_ldcom)",
	'E44' => "Champ invalide 44 (commande/\@type_operation)",
	'E45' => "Champ invalide 45 (CE CHAMP N'EXISTE PAS!)",
	'E46' => "Champ invalide 46 (commande/infos_generales/\@code_package_Services_voix)",
	'E47' => "Champ invalide 47 (entete/\@date_fichier)",
	'E48' => "Champ invalide 48 (commande/\@id_service_administratif)",
	'E49' => "Champ invalide 49 (commande/infos_cpe/\@numero_IP_8AB)",
	'E50' => "Champ invalide 50 (commande/infos_cpe/\@numero_IP_geo)",
	'E51' => "Champ invalide 51 (commande/infos_generales/\@type_numero)",
	'E52' => "Champ invalide 52 (entete/\@version)",
	'E53' => "Champ invalide 53 (commande/infos_utilisateur/\@mdp_utilisateur)",
	'E54' => "Champ invalide 54 (commande/infos_utilisateur/\@email_utilisateur)",
	'E55' => "Champ invalide 55 (commande/infos_techniques/\@infrastructure)",
	'E56' => "Champ invalide 56 (commande/infos_cpe/\@fqdn)",
	'E57' => "Champ invalide 57 (commande/infos_utilisateur/\@contrat)",
	'E58' => "Champ invalide 58 (commande/infos_utilisateur/\@id_facturation)",
	'E59' => "Champ invalide 59 (commande/infos_techniques/\@vpi_livraison)",
	'E60' => "Champ invalide 60 (commande/infos_techniques/\@vci_livraison)",
	'E61' => "Champ invalide 61 (commande/infos_techniques/\@lib_osm)",
	'ENU' => "Incohrence entre code INSEE et code ZNE",
	'ICC' => "Incompatibilit commerciale",
	'ICT' => "Incompatibilit technique",
	'LCN' => "Ligne objet de la commande dj en cours de traitement d'une notification",
	'LCT' => "Ligne objet de la commande dj en cours de traitement",
	'LDA' => "Ligne objet de la commande dj active",
	'LDO' => "Ligne objet de la commande dj active pour un autre oprateur",
	'LIX' => "ND ligne inconnu",
	'LNA' => "Ligne objet de la commande non active",
	'LNO' => "Ligne objet de la commande dj en cours de notificaton pour un autre oprateur",
	'LTO' => "Ligne objet de la commande dj en cours de traitement pour un autre oprateur",
	'MDI' => "Mandat incorrect",
	'MMG' => "Problme sur ancienne offre de migration",
	'OHC' => "Offre objet de la commande hors contrat",
	'RAU' => "Rejet automatique  la demande de l'oprateur",
	'RDO' => "Rejet manuel  la demande de l'oprateur",
	'REC' => "Rejet cause chec commande FT (sert au rejet d'une commande  la troisime NOA)",
	'RNI' => "Ligne numris active",
	'MR0' => "Annulation d'une commande de migration",
	'MAN' => "Mandat non prsent (pour le CR si le mandat a t rejet par FT)"
};

my $rejets_cr_td = {
	'ABO_TEMP'  => "(option 1) Abonnement temporaire",
	'ACC_EQUIP' => "(impossible) Impossible d'acceder aux equipements dans le delai operationnel",
	'ADR_PART'  => "(impossible) Adresse ne designant pas un immeuble collectif ou professionnel (adresse d'un particulier)",
	'ANNULE'    => "Commande annulee (provenant FT, ne devrait pas etre utilise)",
	'AR_INEX'   => "Acces Reseau Inexistant",
	'AUTRE_INC' => "(option 1) Autre incompatibilite (voir commentaire)",
	'CC_INEX'   => "(option 3) CC Inexistant", #Quid CC?
	'CDE_ANNUL' => "(option 1) Commande annulee (probablement provenant FT, ne devrait pas etre utilise)",
	'CDE_EC'    => "(option 3) Commande ADSL en cours [qu'est-ce que ca veut dire?]", #Quid?
	'COF_IMP'   => "(impossible) Pose d'un coffret impossible pour des raisons techniques",
	'CONT_CLI'  => "(impossible) Contacts avec le client infructueux au bout de 10 jours ouvres",
	'EQUIP_INC' => "(option 1) Equipements incompatibles sur la ligne", #Quid?
	'F03'  => "(option 3) Valeur du champ 'Ordre de la demande' non reference en base", #General sur AR, spec. Opt3 sur CR...
	'F04'  => "Champ 'Nom du client' trop long",
	'F05'  => "(option 3) Champ 'Prenom du client' trop long", #
	'F07'  => "(option 3) Champ 'Numero de contact du client' trop long", #
	'F09'  => "(option 3) Champ 'Numero de chrono operateur' trop long", #
	'F10'  => "Valeur du champ 'Contrat' non referencee en base",
	'F12'  => "Valeur du champ 'Numero de support' invalide", # Quid? + 3->G
	'F13'  => "(option 3) Champ 'Commentaire operateur' trop long", # G->3
	'F14'  => "Valeur du champ 'Code offre' non reference en base",
	'F15'  => "Valeur du champ 'Code plaque' invalide", # Ce champ n'existe pas. Ce rejet n'est pas dans les rej-AR
	'F16'  => "Valeur du champ 'Code postal' invalide",
	'F20'  => "(option 1) Champ 'Ordre' non specifie", # G->1
	'F21'  => "(option 1) Valeur du champ 'Ordre' invalide", # Ce rejet n'est pas dans les rej-AR
	'F22'  => "(option 1) Champ 'Contrat' non specifie", # G->1
	'F23'  => "(option 1) Champ 'Identifiant de la commande pour l emetteur' non specifie", # G->1
	'F24'  => "(option 1) Champ 'Identifiant de la commande pour l emetteur' trop long", # Ce rejet n'est pas dans les rej-AR
	'F26'  => "(option 1) Champ 'adresse du client' trop long",
	'F27'  => "(option 1) Champ 'Prenom et nom d un contact' invalide",
	'F29'  => "Champ 'Numero de telephone de contact' invalide",
	'F33'  => "(option 1) Format du champ 'Coordonnees du plot de renvoi' invalide", # Pas champ. Pas rej-AR.
	'F34'  => "(option 1) Champ 'Z0BPQ de renvoi' non specifie", # Idem
	'F35'  => "(option 1) Format du champ 'Z0BPQ de renvoi' invalide", #Idem
	'F36'  => "(impossible) Format du champ 'Numero alloue' invalide",
	'F37'  => "(impossible) Champ 'Regime de SAV' non specifie",
	'F38'  => "(impossible) Valeur du champ 'Regime de SAV' non reference en base",
	'F39'  => "(option 1) Champ 'Commentaire operateur' trop long", # Pas dans les rej-AR
	'F40'  => "(option 1) Champ 'Identifiant de la ligne' non specifie",
	'F41'  => "(impossible) Format du champ 'Identifiant de la ligne' invalide", # 1->I
	'F44'  => "(impossible) Champ 'Adresse d installation' non specifie ou trop long",
	'F45'  => "(option 1) Champ 'Identifiant de la ligne' ou 'Identifiant de la ligne delivre par FT' non specifie", # Pas champ. Pas rej-AR.
	'F46'  => "(option 1) Champ 'Identifiant de la ligne' ou 'Identifiant de la ligne delivre par FT' invalide", # Idem
	'F54'  => "(option 1) Valeur du champ 'code echange' invalide", # Pas champ. Pas rej-AR.
	'F57'  => "Couple Ordre/CodeOffre impossible (demande de debit non-degroupe sur acces degroupe ou le contraire)",
	'F58'  => "(option 1) Valeur du champ 'Type de ligne' invalide",
	'F59'  => "(option 1) Champ 'Commune' invalide",
	'F60'  => "(option 1) Numero de mandat invalide",
	'F61'  => "(option 1) Champ 'Statut' invalide",
	'F62'  => "(impossible) Identifiant de prestation invalide (LL)", # Pas rej-AR.
	'F66'  => "(option 3) Valeur du champ 'Code intervention' invalide", # Pas champ. Pas rej-AR.
	'F83'  => "(option 3) Valeur du champ 'Numero de CCL' invalide", # Pas champ. Pas rej-AR.
	'F84'  => "(option 3) Champ 'Numero de Chrono Operateur' non specifie", # G->3
	'F118' => "(impossible) Champ 'Complement d adresse' invalide", # Pas rej-AR
	'F119' => "(option 1) Champ 'Nombre ligne' invalide", # Pas champ. Pas rej-AR.
	'F121' => "Valeur du champ 'mandat' invalide (pour une migration)", # Difference avec F60?
	'F122' => "Valeur du champ 'contrat' ou 'Code operateur de l'ancien titulaire' invalide (dans le cadre d'une migration)", # Pas rej-AR
	'F123' => "Valeur du champ 'offre de l ancien titulaire' invalide (pour une migration)",
	'F124' => "Valeur du champ 'date de migration souhaitee' invalide", # Pas rej-AR
	'F125' => "Valeur du champ 'creneau horaire de migration' invalide", # Pas rej-AR
	'F126' => "Offre non ouverte sur ce protocole", # I->G
	'F127' => "(option 3) Valeur du champ 'numero de VC' invalide", # Pas champ. Pas rej-AR.
	'F128' => "(option 3) Valeur du champ 'type engagement' invalide", # Pas champ. Pas rej-AR.
	'FT01' => "Ligne non eligible (reponse FT), probleme de faisabilite",
	'FT02' => "Ligne non eligible (reponse FT), erreur dans le ND",
	'GEST_CAB' => "(option 1) FT n'est pas gestionnaire du cablage (sauf pour ND de routage)",
	'GRPT' => "(option 1) Liaison dans un groupement",
	'HA08' => "(option 3) Une autre demande est en cours d'acquisition pour la ligne demandee",
	'HA09' => "(option 3) Une autre demande est en attente d'execution pour la ligne ou l'adresse demandee",
	'HA11' => "La demande de modification ou de suppression ne concerne pas une ligne existante et detenue par l'operateur",
	'HA13' => "(option 3) Annulation rejetee: aucune demande correspondante en cours de traitement", # G->3
	'HA14' => "(option 1) La demande de modification ne concerne pas une ligne totalement degroupee, au profit du meme operateur",
	'HA15' => "(option 1) La demande de creation concerne une ligne deja degroupee (de meme type) au profit du meme operateur", # Quid?
	'HA20' => "(option 3) La contrat specifie dans la demande n'est pas habilite sur le CCL demande", #Quid?
	'HA21' => "(option 3) Il n'y a plus de disponibilite dans le CCL",
#	'HA23' => "La ligne supporte une offre Option 3, au profit du meme operateur", #Quid?
	'HA26' => "(option 3) La ligne supporte une offre ACA au profit du meme operateur", # Quid? Pas rej-AR.
	'HA28' => "(option 3) La demande de modification ne porte pas sur une offre autorisee dans le protocole d'echange",
	'HA29' => "(option 3) La demande de suppression ne correspond ni a une offre ni a un operateur existant",
	'HA36' => "La ligne devant etre migree ne porte pas sur l'offre specifiee",
	'HA37' => "La ligne devant etre migree n'est pas detenue par l'operateur specifie",
	'HA38' => "(option 3) Une autre demande est en cours sur le meme CCL et le meme VC",
	'HC00' => "La demande ne concerne pas un ZABPQ existant", # Pas rej-AR.
	'HC01' => "Le contrat specifie dans la demande n'est pas detenu par l'operateur",
	'HC02' => "Le contrat specifie dans la demande n'est pas actif",
	'HC03' => "Le contrat specifie dans la demande n'est pas habilite pour l'ofrre demandee",
	'HC04' => "Le contrat specifie dans la demande est habilite pour l'offre objet de la demande, mais pas pour l'ordre associe",
#	'RC01' => "(option 1) Valeur du champ 'Nom' non specifie",
#	'RC02' => "(option 1) Valeur du champ 'Prenom' non specifie",
#	'RC03' => "(option 1) Valeur du champ 'Adresse' invalide",
#	'RC04' => "(option 1) Valeur du champ 'Code postal installation' invalide",
#	'RC05' => "(option 1) Valeur du champ 'Commune installation' invalide",
#	'RC06' => "(option 1) Valeur du champ 'Complement d adresse' trop long",
#	'RC07' => "(option 1) Valeur du champ 'Fax du contact' de longueur invalide",
#	'RC08' => "(option 1) Valeur du champ 'Fax du contact' invalide",
#	'RC09' => "(option 1) Valeur du champ 'Vpi, carte ou nb de lignes' de longueur invalide",
#	'RC10' => "(option 1) Valeur du champ 'Vpi, carte ou nb de lignes' invalide",
#	'RC11' => "(option 1) Valeur du champ 'Vci, port ou carte' de longueur invalide",
#	'RC12' => "(option 1) Valeur du champ 'Vci, port ou carte' invalide",
#	'RC13' => "(option 1) Valeur du champ 'Point de livraison operateur client' de longueur invalide",
#	'RC14' => "(option 1) Valeur du champ 'Desserte interne' doit etre 'O' ou 'N'",
#	'RC15' => "(option 1) Valeur du champ 'Longueur desserte' invalide",
#	'RC16' => "(option 1) Valeur du champ 'Date de MAD des locaux UF' invalide",
#	'RC17' => "(option 1) Valeur du champ 'Date souhaitee de MAD du service' invalide",
#	'RC18' => "(option 1) Valeur du champ 'Libelle OSM' invalide",
#	'RC19' => "(option 1) Valeur du champ 'Interface de l extremite cote UF' invalide",
#	'RC20' => "(option 1) Le contrat specifie dans la demande n'est pas habilite sur le Point de livraison demande",
	'IC'         => "(option 3) Incompatibilite commerciale", # Pas rej-AR.
	'IT'         => "(option 3) Incompatibilite technique", # Pas rej-AR.
	'LIG_AS_ADR' => "(impossible) Erreur adresse pour ligne associee", # Pas rej-AR.
	'LIG_AS_CAR' => "(impossible) Erreur caracteristique pour ligne associee", # Pas rej-AR
	'LES'        => "(option 1) Ligne supplementaire exterieure (sauf pour ND de routage)", #Quid? Pas rej-AR.
	'M01'        => "(option 3) Le ND specifie n'a pas fait l'objet d'une etude prealable de migration",
	'M02'        => "(option 3) Le ND specifie n'est pas migrable",
	'MA00'       => "(impossible) Mandat orphelin",
	'MA01'       => "(option 1) Numero de support invalide sur le mandat",
	'MA02'       => "(impossible) Donnees client invalides ou incompletes sur le mandat",
	'MA03'       => "(impossible) Contrat non actif sur le mandat",
	'NO_RESS'    => "(option 1) Pas de ressource a l'adresse",
	'NUMERIS'    => "Ligne numeris",
	'OP_NON_COL' => "(option 1) Operateur non colocalise",
	'OP_NON_HAB' => "(option 1) Operateur non-habilite par le repartiteur",
	'PABX'       => "(option 1) Liaison de raccordement PABX (sauf pour ND de routage)",
	'PAS_CAP'    => "(option 1) Pas de capacite de renvoi disponible",
	'PAS_CAP_TD' => "(option 1) Pas de capacite disponible en transport ou distribution",
	'PB_CONT'    => "(impossible) Probleme de continuite metallique idem PAS_CAP_TD (desserte interne)",
	'PB_FILT'    => "(option 1) Probleme de disponibilite de filtre",
	'PBM_TIT'    => "(option 1) Probleme titulaire de ligne",
	'RA00'       => "(impossible) Commande orpheline",
	'RAC_IMP'    => "(impossible) Construction du lien de raccordement impossible",
	'REJ_OFF'    => "(option 3) Rejet FT",
	'SAT_DGP'    => "(impossible) Saturation degroupage",
	'SAT_DSLAM'  => "(option 3) Saturation DSLAM. L'operateur doit repasser une nouvelle commande sur un ".
	                "nouveau conduit de collecte (CCL) sur un autre DSLAM",
	'SER_PUB'    => "(option 1) Liaison de service publique (sauf pour ND de routage)",
	'SR_AUTO'    => "(option 1) Liaison en sous-repartition auto (sauf pour ND de routage)",
	'SRV_EXIST'  => "(option 3) Service deja existant",
	'SU01'       => "(option 1) Commande en surcharge par le meme operateur",
	'SU02'       => "(option 1) Commande en surcharge par un autre operateur",
	'TELEX'      => "Liaison telex",
	'TDC10'      => "(impossible) Commande d'information FT rejetee",
	'CVTURE1'    => "(option 3) La commande est eligible en 1 veuillez repasser la commande",
	'TDAL_OCC'   => "(option 1) Ressources, au point de livraison Operateur, occupees",
	'TDAL_INEX'  => "(option 1) Ressources, au point de livraison Operateur, inexistantes",
#	'RH01'       => "Annulation rejetee: delai contractuel depasse",
	'NOK_DATE'   => "Desaccord sur la date de migration proposee par l'operateur",
	'R0'         => "Erreur applicative, code rejet indetermine",
};

my $urlsuivi = Config_Key('adsl/global.cfg','web','urlsuivi');

sub faire_clef_telephone($$) { # Test
        my ( $task_name, $task_vars ) = @_;
	my $prefix = Config_Key('adsl/tables.cfg','task-prefix',$task_name);
	$prefix = 'XXX' if ! defined $prefix;
        return $prefix.'/'.$task_vars->{'telephone'};
}

sub faire_clef_td($$) { # Test
	my ( $task_name, $task_vars ) = @_;
	my $prefix = Config_Key('adsl/tables.cfg','task-prefix',$task_name);
	$prefix = 'XXX' if ! defined $prefix;
	return $prefix.'/'.$task_vars->{'ordretd-id'};
}

sub faire_clef_fix($$) { # Test
	my ( $task_name, $task_vars ) = @_;
	my $prefix = Config_Key('adsl/tables.cfg','task-prefix',$task_name);
	$prefix = 'XXX' if ! defined $prefix;
	my $id = get_next($dbh,'fix-task');
	return $prefix.'/'.$id;
}

sub __init_depl_ligne($) {
	my ( $props ) = @_;
	
	my $lid = $props->{'ligneid'};
	if ( !defined $lid ) {
		x_error 'Ce deploiement n\'est pas associe a une ligne.';
		return undef;
	}
		
	my $ligne = ligne_par_id($lid);
	if ( !defined $ligne ) {
		x_error 'La ligne numero '.$lid.' n\'existe pas en base.';
		return undef;
	}

	if ( ! defined $props->{'telephone'} ) {
		$props->{'telephone'} = $ligne->{'LIGNE_TEL'};
	}

	my $dplid = $props->{'deplid'};
	if ( !defined $dplid ) {
		x_error 'Ce deploiement n\'a pas de deplid.';
		return undef;
	}
		
	my $dpl = deploiement_par_id($dplid);
	if ( !defined $dpl ) {
		x_error 'Deploiement numero '.$dplid.' n\'existe pas.';
		return undef;
	}
		
	my $dplnum = $dpl->{'DEPLOIEMENT_NUM'};
	if ( !defined $dplnum ) {
		x_error 'Le deploiement numero '.$dplid.'n\'a pas de numero.';
		return undef;
	}
		
	$props->{'dplnum'} = $dplnum;

	if ( ! defined $props->{'type'} || $props->{'type'} ne 'nerim' ) {
		my $mandat = mandat_par_deploiement_id($dplid);
		if ( !defined $mandat ) {
			x_error 'Le deploiement numero '.$dplid.'n\'a pas de mandat';
			return undef;
		}

		my $mnum = $mandat->{'MANDAT_NUMERO'};
		if ( ! defined $mnum ) {
			x_error 'Le mandat n\'a pas de numero';
		}

		$props->{'mandat'} = $mnum;
	} else {
		$props->{'mandat'} = 'useless';
	}
		
	my $aid = $ligne->{'ADRESSE_ID'};
	if ( !defined $aid ) {
		x_error 'La ligne n\'a pas d\'adresse associee.';
		return undef;
	}

	$props->{'aid'} = $aid;
		
	my $adr = adresse_par_id($aid);
	if ( !defined $adr ) {
		x_error 'L\'adresse numero '.$aid.' associee a la ligne n\'existe pas en base.';
		return undef;
	}
	$props->{'nom'} = $adr->{'ADRESSE_NOM'};
	$props->{'adresse'} = $adr->{'ADRESSE_ADR'};
	$props->{'cp'} = $adr->{'ADRESSE_CP'};
	$props->{'ville'} = $adr->{'ADRESSE_VILLE'};
	
	my $email = $adr->{'ADRESSE_MAIL'};
	if ( defined $email ) {
		$props->{'email'} = $email;
	}

	my $pid = $props->{'tarif'};
	if ( ! defined $pid ) {
		x_error "L'attente de FAS n'a pas recu le tarif applicable";
		return undef;
	}
		
	my $prix = prix_par_id($pid);
	if ( ! defined $prix ) {
		x_error "Le prix numero ".$pid." n'est pas trouvable en base";
		return undef;
	}

	my $fasht  = $prix->{'PRIX_FASHT'};
	my $fasttc = $prix->{'PRIX_FASTTC'};
	my $aboht  = $prix->{'PRIX_ABOHT'};
	my $abottc = $prix->{'PRIX_ABOTTC'};
	$props->{'fas-ht'}  = $fasht;
	$props->{'fas-ttc'} = $fasttc;
	$props->{'abo-ht'}  = $aboht;
	$props->{'abo-ttc'} = $abottc;

	my $option = $props->{'option'};
	my $debit  = $props->{'debit'};
	my $offre = Config_Key('adsl/tables.cfg',$option,$debit);
	if ( ! defined $offre ) {
		x_error "Je n'ai pas trouv l'offre Cegetel pour option='$option' et debit='$debit'. Sans importance de nos jours.";
#		return undef;
	}
	$props->{'offre-demandee'} = $offre;

	$offre = Config_Key('adsl/tables.cfg',$option.'-9t',$debit);
	if ( ! defined $offre ) {
		x_error "Je n'ai pas trouv l'offre Neuf pour option='$option' et debit='$debit'. Sans importance de nos jours.";
#		return undef;
	}
	$props->{'offre-demandee-9t'} = $offre;

	$offre = Config_Key('adsl/tables.cfg',$option.'-nerim',$debit);
	if ( ! defined $offre ) {
		x_error "Je n'ai pas trouv l'offre Nerim pour option='$option' et debit='$debit'. Critique.";
		return undef;
	}
	$props->{'offre-demandee-nerim'} = $offre;

	$props->{'degroupage'} = 'Partiel';
	$props->{'statut-ligne'} = 'A';
	if ( ! defined $props->{'cegetel'} ) {
		$props->{'cegetel'} = 0;
	}

	my $did = debit_par_debit($debit);
	if ( ! defined $did ) {
		x_error "Je ne trouve pas le dbit <$debit> dans la base, je continue quand meme";
	} else {
		$did = $did->{'DEBIT_ID'};
		$props->{'did'} = $did;
	}

	return '';
}

sub __eot_elig($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	if ( $email ) {
		my $type = 'depl1';
		if ( defined $props->{'modif'} && $props->{'modif'} ) {
			$type = 'depl2';
		}
		__envoie_mail($email,$type,$props->{'telephone'},{
			'FASTTC' => __prt_eur($props->{'fas-ttc'}),
			'urlsuivi' => $urlsuivi,
			'dplnum' => $props->{dplnum},
			});
	}
	new_info_ligne($lid,'inline','Debut deploiement',
		"Toutes les informations ont ete controlees par la tache\n".
		"de deploiement, elles sont valides. La ligne est effectivement\n".
		"eligible au debit demande.");
	set_deploiement_start($props->{deplid});
	return '';
}

sub __eot_fas($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	set_deploiement_fas($props->{deplid});
	if ( $email ) {
		__envoie_mail($email,'paye',$props->{'telephone'},{
			'urlsuivi' => $urlsuivi,
			'dplnum' => $props->{dplnum},
			});
	}
	new_info_ligne($lid,'inline','Recu FAS',
		"La tache d'attente de paiement des FAS et de reception\n".
		"des documents s'est bien terminee.");
	set_ligne_state($props->{ligneid},'building');
}

sub __eot_radius($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	set_deploiement_rad($props->{deplid});
	if ( $email ) {
		__envoie_mail($email,'radius',$props->{'telephone'},{
			'urlsuivi' => $urlsuivi,
			%$props
			});
	}
	new_info_ligne($lid,'inline','Compte Radius',
		"Le compte radius a ete cree normalement.\n".
		"Pour le moment 1 IP.");
}

sub __eot_cdetd($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	set_deploiement_cde($props->{deplid});
	if ( $email ) {
		__envoie_mail($email,'envoi',$props->{'telephone'},{
			'urlsuivi' => $urlsuivi,
			%$props
			});
	}
	new_info_ligne($lid,'inline','Commande TD envoyee',
		"La commande TD a ete transmise. Le fichier a ete accepte.");
}

sub __eot_cdeN($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	set_deploiement_cde($props->{deplid});
	if ( $email ) {
		__envoie_mail($email,'envoi',$props->{'telephone'},{
			'urlsuivi' => $urlsuivi,
			%$props
			});
	}
	new_info_ligne($lid,'inline','Commande Nerim envoyee',
		"La commande Nerim a ete transmise. Le fichier a ete accepte. FIXME");
}

sub __eot_cde9t($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	set_deploiement_cde($props->{deplid});
	if ( $email ) {
		__envoie_mail($email,'envoi',$props->{'telephone'},{
			'urlsuivi' => $urlsuivi,
			%$props
			});
	}
	new_info_ligne($lid,'inline','Commande 9T envoyee',
		"La commande 9T a ete transmise. Le fichier a ete accepte.");
}

sub __eot_artd($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	set_deploiement_ar($props->{deplid});
	if ( $email ) {
		__envoie_mail($email,'artd',$props->{'telephone'},{
			'urlsuivi' => $urlsuivi,
			%$props
			});
	}
	new_info_ligne($lid,'inline','AR TD positif',
		"TD nous a envoye un AR positif.");
}

sub __eot_arN($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	set_deploiement_ar($props->{deplid});
	#set_ligne_idld($lid,$props->{'id-sips'});
#	if ( $email ) {
#		__envoie_mail($email,'arN',$props->{'telephone'},{
#			'urlsuivi' => $urlsuivi,
#			%$props
#			});
#	}
	new_info_ligne($lid,'inline','AR Nerim positif',
		"Nerim nous a envoye un AR positif. Ligne prete?");
}

sub __eot_ar9t($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	set_deploiement_ar($props->{deplid});
	set_ligne_idld($lid,$props->{'id-sips'});
	if ( $email ) {
		__envoie_mail($email,'artd',$props->{'telephone'},{
			'urlsuivi' => $urlsuivi,
			%$props
			});
	}
	new_info_ligne($lid,'inline','AR 9T positif',
		"9T nous a envoye un AR positif.");
}

sub __eot_crtd($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	set_deploiement_cr($props->{deplid});
	if ( $email ) {
		__envoie_mail($email,'crtd',$props->{'telephone'},{
			'urlsuivi' => $urlsuivi,
			%$props
			});
	}
	new_info_ligne($lid,'inline','CR TD positif',
		"TD nous a envoye un CR positif.");
}

sub __eot_cr9t($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	set_deploiement_cr($props->{deplid});
	if ( $email ) {
		__envoie_mail($email,'crtd',$props->{'telephone'},{
			'urlsuivi' => $urlsuivi,
			%$props
			});
	}
	new_info_ligne($lid,'inline','CR 9T positif',
		"9T nous a envoye un CR positif.");
}

sub __end_depl_ligne($) {
	my ( $props ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	set_deploiement_fin($props->{deplid});
	if ( defined $props->{'modif'} && $props->{'modif'} ) {
		my $pid = $props->{'tarif'};
		set_ligne_prix($lid,$pid);
		set_ligne_option($lid,$props->{'option'});
		set_ligne_debit($lid,$props->{'did'});
	} else {
		set_ligne_dtok($lid);
		set_ligne_dtfac($lid);
		set_ligne_state($lid,'ok');
	}
	if ( $email ) {
		__envoie_mail($email,'deplok',$props->{'telephone'},{
			'urlsuivi' => $urlsuivi,
			'offre-cde' => Config_Key('adsl/tables.cfg','reverse',$props->{'offre-demandee'}),
			'offre-ok'  => Config_Key('adsl/tables.cfg','reverse',$props->{'offre-demandee'}),
			%$props
			});
	}
	new_info_ligne($lid,'inline','Fin du traitement de la commande',
		"Tout est termine pour ce deploiement de ligne ADSL.");
	
}

sub __feot($$$) {
	my ( $props, $etape, $tel ) = @_;
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	__envoie_mail(undef,'bureau-reprise',$props->{'telephone'},{
			'tel' => $tel,
			'etape' => $etape,
			'ETAPE' => Config_Key('adsl/tables.cfg','task-reverse',$etape)
			});
	new_info_ligne($lid,'inline','Reprise manuelle sur erreur',
		"Le deploiement de cette ligne a fait l'objet d'une reprise\n".
		"sur erreur.");
}

sub deployer_ligne_adsl($$$) {
	my ( $props, $event, $date ) = @_;
	my $pref = Config_Section('adsl/tables.cfg','task-prefix');
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	if ( $event eq 'init' ) {
		my $ret = __init_depl_ligne($props);
		if ( ! defined $ret ) {
			return undef;
		}
		return '';
	} elsif ( $event =~ /^EOT-$pref->{elig}/ ) {
		__eot_elig($props);
	} elsif ( $event =~ /^EOT-$pref->{fas}\// ) {
		__eot_fas($props);
	} elsif ( $event =~ /^EOT-$pref->{radius}\// ) {
		__eot_radius($props);
	} elsif ( $event =~ /^EOT-$pref->{cdetd}\// ) {
		__eot_cdetd($props);
	} elsif ( $event =~ /^EOT-$pref->{'wait_ar_td'}\// ) {
		__eot_artd($props);
	} elsif ( $event =~ /^EOT-$pref->{'wait_cr_td'}\// ) {
		__eot_crtd($props);
	} elsif ( $event eq 'end' ) {
		__end_depl_ligne($props);
	} elsif ( $event =~ /^FEOT-([A-Z]+)\/(\d*)$/ ) {
		my ( $etape, $tel ) = ( $1, $2 );
		__feot($props,$etape,$tel);
	} elsif ( $event eq 'REJET-ARTD' ) {
		x_error "Recu une notification de rejet d'ARTD. Faire suivre par mail a l'abonne.";
		if ( $email ) {
			__envoie_mail($email,'rejet-arcde',$props->{'telephone'},{
				'urlsuivi' => $urlsuivi,
				%$props
			});
		}
		new_info_ligne($lid,'inline','AR de rejet par TD',
			"TD nous a fait parvenir un AR de rejet de la commande.\n".
			"Plus d'infos dans la tache de deploiement.");
	} elsif ( $event eq 'CRNOK' ) {
		x_error "Recu une notification de rejet de CRTD. Faire suivre par mail a l'abonne.";
		if ( $email ) {
			__envoie_mail($email,'depl-crnok',$props->{'telephone'},{
				'urlsuivi' => $urlsuivi,
				%$props
			});
		}
		new_info_ligne($lid,'inline','CR de rejet par TD',
			"TD nous a fait parvenir un CR de rejet de la commande.\n".
			"Plus d'infos dans la tache de deploiement.");
	} elsif ( $event =~ /^ETUDOK\/(.*)$/ ) {
		my $date = $1;
		x_error "Recu une notification d'etude OK. Faire suivre par mail a l'abonne.";
		if ( $email ) {
			__envoie_mail($email,'depl-etudok',$props->{'telephone'},{
				'date' => $date,
				'urlsuivi' => $urlsuivi,
				%$props
			});
		}
		new_info_ligne($lid,'inline','CR etude OK par TD',
			"TD nous a fait parvenir un CR d'etude OK sur cette commande.\n".
			"Ce message n'a pas de sens et n'a pas lieu d'etre dans les\n".
			"commandes de FDN.\n".
			"Date prevue de mise en service: $date.");
	} elsif ( $event =~ /^SATUR\/(.*)$/ ) {
		my $date = $1;
		x_error "Recu une notification de saturation. Faire suivre par mail a l'abonne.";
		if ( $email ) {
			__envoie_mail($email,'depl-satur',$props->{'telephone'},{
				'date' => $date,
				'urlsuivi' => $urlsuivi,
				%$props
			});
		}
		new_info_ligne($lid,'inline','CR de saturation par TD',
			"TD nous a fait parvenir un CR de saturation des DSLAMs.\n".
			"Date prevue de mise en service: $date.");
	} else {
		x_info "Tache depl-adsl a recu l'evennement innatendu ".$event;
	}
	return '';
}

sub deployer_ligne_adsl_nerim($$$) {
	my ( $props, $event, $date ) = @_;
	my $pref = Config_Section('adsl/tables.cfg','task-prefix');
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	if ( $event eq 'init' ) {
		$props->{'type'} = 'nerim';
		my $ret = __init_depl_ligne($props);
		debug "L'initialisation du deploiement renvoie $ret";
		if ( ! defined $ret ) {
			x_error "Pas reussi a preparer la commande. Echec.";
			return undef;
		}
		return '';
	} elsif ( $event =~ /^EOT-$pref->{elig}/ ) {
		__eot_elig($props);
		$event =~ /^EOT-(.*)$/;
		$props->{'elig-key'} = $1;
	} elsif ( $event =~ /^EOT-$pref->{fas}\// ) {
		__eot_fas($props);
		$event =~ /^EOT-(.*)$/;
		$props->{'fas-key'} = $1;
	} elsif ( $event =~ /^EOT-$pref->{radius}\// ) {
		__eot_radius($props);
		$event =~ /^EOT-(.*)$/;
		$props->{'radius-key'} = $1;
	} elsif ( $event =~ /^EOT-$pref->{cdenerim}\// ) {
		__eot_cdeN($props);
		$event =~ /^EOT-(.*)$/;
		$props->{'cde-key'} = $1;
	} elsif ( $event =~ /^EOT-$pref->{'wait_ok_nerim'}\// ) {
		__eot_arN($props);
	} elsif ( $event eq 'end' ) {
		__end_depl_ligne($props);
	} elsif ( $event =~ /^FEOT-([A-Z]+)\/(\d*)$/ ) {
		my ( $etape, $tel ) = ( $1, $2 );
		__feot($props,$etape,$tel);
	} else {
		x_info "Tache depl-nerim a recu l'evennement innatendu ".$event;
	}
	return '';
}

sub deployer_ligne_adsl_9t($$$) {
	my ( $props, $event, $date ) = @_;
	my $pref = Config_Section('adsl/tables.cfg','task-prefix');
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	if ( $event eq 'init' ) {
		my $ret = __init_depl_ligne($props);
		debug "L'initialisation du deploiement renvoie $ret";
		if ( ! defined $ret ) {
			x_error "Pas reussi a preparer la commande. Echec.";
			return undef;
		}
		return '';
	} elsif ( $event =~ /^EOT-$pref->{elig}/ ) {
		__eot_elig($props);
		$event =~ /^EOT-(.*)$/;
		$props->{'elig-key'} = $1;
	} elsif ( $event =~ /^EOT-$pref->{fas}\// ) {
		__eot_fas($props);
		$event =~ /^EOT-(.*)$/;
		$props->{'fas-key'} = $1;
	} elsif ( $event =~ /^EOT-$pref->{radius}\// ) {
		__eot_radius($props);
		$event =~ /^EOT-(.*)$/;
		$props->{'radius-key'} = $1;
	} elsif ( $event =~ /^EOT-$pref->{cde9t}\// ) {
		__eot_cde9t($props);
		$event =~ /^EOT-(.*)$/;
		$props->{'cde-key'} = $1;
	} elsif ( $event =~ /^EOT-$pref->{'wait_ar_9t'}\// ) {
		__eot_ar9t($props);
	} elsif ( $event =~ /^EOT-$pref->{'wait_cr_9t'}\// ) {
		__eot_cr9t($props);
	} elsif ( $event eq 'end' ) {
		__end_depl_ligne($props);
	} elsif ( $event =~ /^FEOT-([A-Z]+)\/(\d*)$/ ) {
		my ( $etape, $tel ) = ( $1, $2 );
		__feot($props,$etape,$tel);
	} elsif ( $event eq 'REJET-ARTD' ) {
		x_error "Recu une notification de rejet d'ARTD. Faire suivre par mail a l'abonne.";
		if ( $email ) {
			__envoie_mail($email,'rejet-arcde',$props->{'telephone'},{
				'urlsuivi' => $urlsuivi,
				%$props
			});
		}
		new_info_ligne($lid,'inline','AR de rejet par NeufCegetel',
			"NeufCegetel nous a fait parvenir un AR de rejet de la commande.\n".
			"Plus d'infos dans la tache de deploiement.");
	} else {
		x_info "Tache depl-adsl9 a recu l'evennement innatendu ".$event;
	}
	return '';
}

sub test_eligibilite_ligneN($$$) { # Test
	return test_eligibilite_ligne(@_);
}

sub test_eligibilite_ligne($$$) { # test
	my ( $props, $event, $date ) = @_;
	if ( $event eq 'init' ) {
		x_info "Lancement d'un test d'ligiblit, attente rsultat";
		my $offre = $props->{'debit'}.$props->{'option'};
		$props->{'offre'} = $offre;
		if ( ! defined $props->{'type'} ) {
			$props->{'type'} = 'elig';
		}
		conduse('FDN::Sql::Plutar::Basic');
		plutar_select_db('adsl');
		my $eid = new_eligibilite($props->{'telephone'}, $props->{'offre'});
		my $pp = {
			'tel' => $props->{'telephone'},
			'offre' => $props->{'offre'},
			'eid' => $eid
		};
		if ( defined $props->{'cp'} ) {
			$pp->{'cp'} = $props->{'cp'};
		}
		lock_plutar();
		my $pid = new_plutar($props->{'type'},'now');
		set_plutar_properties($pid,$pp);
		unlock_plutar();
		$props->{'eligibilite-id'} = $eid;
		$props->{'plutar-id'} = $pid;
		return 'ELIG-'.$eid;
	}
	if ( $event =~ /^ELIG-/ ) {
		my $ev = event_par_event($event);
		my $evid = $ev->{'EVENT_ID'};
		my $p = get_event_properties($evid);
		if ( $p->{'faisable'} ) {
			x_info "Reu rsultat ligibilit. C'est bon.";
			$props->{'eligible'} = 1;
			return '';
		} else {
			x_error "Reu rsultat ligibilit. RSULTAT NGATIF. Commande bloque.";
			__envoie_mail(undef,'bureau-elig',$props->{'telephone'},$props);
			$props->{'eligible'} = 0;
			return undef;
		}
	}
	if ( $event eq 'end' ) {
		return '';
	}
	x_info "J'ai (test_elig) reu cet vennement curieux: $event. On fait semblant de rien.";
	return '';
}

sub attends_paiement_fas($$$) { # Test
	my ( $props, $event, $date ) = @_;
	if ( $event eq 'init' ) {
		x_info "Attente FAS pour la ligne ".$props->{telephone};
		return 'FAS-'.$props->{telephone};
	} elsif ( $event eq 'FAS-'.$props->{telephone} ) {
		x_info "Recu FAS pour la ligne ".$props->{telephone};
		return '';
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info "J'ai (attends-fas) recu cet evennement curieux: ".
			$event;
		return '';
	}
}

sub attend_ok_nerim($$$) {
	my ( $props, $event, $date ) = @_;
	if ( $event eq 'init' ) {
		x_info "Attente OK pour la ligne ".$props->{telephone};
		return 'OK-'.$props->{'ordretd-id'};
	} elsif ( $event eq 'OK-'.$props->{$props->{'ordretd-id'}} ) {
		x_info "Recu OK pour la ligne ".$props->{telephone};
		return '';
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info "J'ai (attend_ok_nerim) recu cet evennement curieux: ".
			$event;
		return '';
	}
}

sub prepare_commande_nerim($$$) { # Test
	my ( $props, $event, $date ) = @_;
	return __prepare_commande_any($props, $event, $date, sub {
		my $props = shift;
		$props->{'login-nerim'} = 'fdn-'.$props->{'ordretd-id'}.'-'.$props->{'telephone'};
		return __ligne_ordre_nerim (
			'login-nerim'	=> $props->{'login-nerim'},
			'titulaire'	=> $props->{'nom'},
			'adresse'	=> $props->{'adresse'},
			'complement'	=> '',
			'ville'		=> $props->{'ville'},
			'cp'		=> $props->{'cp'},
			'nd'		=> $props->{'telephone'},
			'offre'		=> $props->{'offre'}
			);
		}
	);
}

sub prepare_commande_td($$$) { # Test
	my ( $props, $event, $date ) = @_;
	return __prepare_commande_any($props, $event, $date, sub { 
		my $props = shift;
		return __ligne_ordre_td (
			'ordre'			=> 'CREATION',
			'offre'			=> $props->{'offre'},
			'id-fdn'		=> $props->{'ordretd-id'},
			'mandat'		=> $props->{'mandat'},
			'nom'			=> $props->{'nom'},
			'prenom'		=> '',
			'adresse'		=> $props->{'adresse'},
			'cp'			=> $props->{'cp'},
			'ville'			=> $props->{'ville'},
			'type-ligne'		=> 'TL',
			'statut-ligne'		=> 'A',
			'nd'			=> $props->{'telephone'},
			'adresse-construction'	=> '',
			'cpladr-construction'	=> '',
			'cp-construction'	=> '',
			'ville-construction'	=> '',
			'nom-construction'	=> '',
			'tel-construction'	=> $props->{'telephone'},
			'fax-construction'	=> '',
			'sav'			=> '',
			'contrat'		=> '2005-093', # Quid ?
			'adr-livraison'		=> '',
			'vpi-livraison'		=> '',
			'vci-livraison'		=> '',
			'desserte-interne'	=> '',
			'lg-desserte'		=> '',
			'dispo-locaux'		=> '',
			'dispo-construction'	=> '',
			'id-osm'		=> '',
			'interface-xdsl'	=> '',
			'ancien-operateur'	=> '',
			'commentaire'		=> ''
			);
		}
	);
}

sub prepare_commande_9t($$$) { # Test
	my ( $props, $event, $date ) = @_;
	return __prepare_commande_any($props, $event, $date, sub {
		my $props = shift;
		my $date = strftime "%Y%m%d", localtime;
		my $code = 'ACTIVATION';
		my $type_modif = '';
		my $id_ldcom = '';
		if ( defined $props->{'modif'} && $props->{'modif'} ) {
			$code = 'MODIFICATION';
			$type_modif = 'DEBIT';
			$id_ldcom = $props->{'idld'};
		}
		# FIXME Vrifier qu'on a le ligne-id dans $props
		return __ligne_ordre_9t(
			'code_echange'               => $code,                  # 03 
			'date_commande'              => $date,                  # 02 Quid ?
			'id_contrat'                 => '2005-093',             # 05 FIXME Mettre en conf
			'id_commande_client'         => $props->{'ordretd-id'}, # 06
			'id_ldcom'                   => $id_ldcom,              # 43
			'id_service_administratif'   => '',                     # 48 Quid?
			'type_modif'                 => $type_modif,            # 26
			'type_operation'             => '',                     # 44 Utile pour migration FT, dtails? Quid?
			'code_service'               => $props->{'offre'},      # 04
			'reference_eligibilite'      => '',                     # 07 Vide
			'id_mandat'                  => '',                     # 08
			'code_package_services_voix' => '',                     # 46 Pas de VoIP
			'type_numero'                => '',                     # 51 Pas de VoIP
			'nom_prenom_utilisateur'     => $props->{'nom'},        # 09
			'adresse_utilisateur'        => $props->{'adresse'},    # 10
			'compl_ adresse_utilisateur' => '',                     # 11
			'code_postal_utilisateur'    => $props->{'cp'},         # 12
			'commune_utilisateur'        => $props->{'ville'},      # 13
			'reference_utilisateur'      => 'tid '.$props->{'tid'}, # 29 Sert a rien, on met le tid qui est unique.
			'login_utilisateur'          => '',                     # 30
			'code_siret'                 => '',                     # 31
			'mdp_utilisateur'            => '',                     # 53 L'usage n'en est pas clair
			'email_utilisateur'          => '',                     # 54 L'usage n'en est pas clair
			'contrat'                    => '',                     # 57 Pas clair
			'id_facturation'             => '',                     # 58
			'type_ligne'                 => 'TL',                   # 14
			'statut_ligne'               => $props->{'statut-ligne'},# 15
			'identifiant_ligne'          => $props->{'telephone'},  # 16
			'nom_prenom_contact'         => $props->{'nom'},        # 23
			'telephone_contact'          => $props->{'telephone'},  # 24
			'telephone2_contact'         => '',                     # 36
			'email_contact'              => '',                     # 37
			'type_degroupage'            => $props->{'degroupage'}, # 17
			'portabilite'                => '',                     # 18
			'regime_sav'                 => 'NORMAL',               # 19
			'mode_livraison'             => 'IP',                   # 27
			'conduit'                    => '',                     # 28
			'option_mes'                 => 'NON',                  # 39
			'longueur_desserte_interne'  => '',                     # 40
			'option_vp'                  => '',                     # 41
			'infrastructure'             => '',                     # 55
			'achat_cpe'                  => 'NON',                  # 31
			'location_cpe'               => 'NON',                  # 32
			'interface'                  => 'CUIVRE',               # 42
			'installation_cpe'           => 'NON',                  # 33
			'routeur'                    => '',                     # 35
			'modem'                      => '',                     # 34
			'numero_IP_8AB'              => '',                     # 49
			'numero_IP_geo'              => '',                     # 50
			'fqdn'                       => '',                     # 56
			'commentaire'                => '',                     # 25
			);
		}
	);
	
}

sub __prepare_commande_any($$$$) { # Test
	my ( $props, $event, $date, $fct ) = @_;
	if ( $props->{'cegetel'} ) {
		x_info "Pas besoin de preparer la commande TD/9T/Nerim pour la ligne (cas Cegetel).";
		$props->{'ordretd-id'} = get_next($dbh,'ORDRETD_ID');
		return '';
	}
	if ( $event eq 'init' ) {
		x_info "Je prepare la commande TD/9T/Nerim pour la ligne ".
			$props->{telephone}." pour ".$props->{offre};

		my $oid = new_ordretd();
		if ( !defined $oid ) {
			$props->{'erreur'} = "Pas reussi a creer un ORDRETD!";
			x_error "Pas reussi a creer un ordre TD. Renvoyer 'init' a la tache ".$props->{'tid'};
			return undef;
		}
		$props->{'ordretd-id'} = $oid;
		my $ordre = &$fct($props);
		if ( ! defined $ordre ) {
			x_error "Echec de creation de l'ordre a envoyer";
			return undef;
		}
		$props->{'ordretd'} = $ordre;
		set_ordretd_ligne($oid,$ordre);
		x_info "J'attends l'evennement ARFIC-".$props->{'ordretd-id'};
		return 'ARFIC-'.$props->{'ordretd-id'};
	} elsif ( $event eq 'ARFIC-'.$props->{'ordretd-id'} ) {
		x_info "La commande TD/9T/Nerim pour ".$props->{telephone}." a ete recue.";
		$props->{'etat-cdetd'}='ok';
		return '';
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info  "J'ai (cdetd/9t/N) recu cet evennement curieux: ".
			$event;
		return '';
	}
}

sub cree_login_radius($$$) { # Test
	my ( $props, $event, $date ) = @_;
	if ( $event eq 'init' || $event eq 'NEW-IPADDR' ) {
		if ( $props->{'login'} =~ /./ ) {
			# S'il y a deja un compte radius, c'est deja fait
			# (cas NNX, par exemple)
			return '';
		}
		my $nom = $props->{'nom'};
		my $lid = $props->{'ligneid'};
		my $uid = create_radius_account($lid,$nom);
		if ( ! defined $uid ) {
			# On manque probablement d'IP, on se met en standby
			del_event_par_event('NEW-IPADDR');
			return 'NEW-IPADDR';
		}
		my $user = raduser_par_id($uid);
		$props->{'login'} = $user->{'RADUSER_LOGIN'};
		my @uattrs = uattr_par_raduser_id($uid);
		for my $a ( @uattrs ) {
			my $atr = $a->{'UATTR_ATTR'};
			my $val = $a->{'UATTR_VALUE'};
			if ( $atr eq 'Framed-IP-Address' ) {
				$props->{'ipaddr'} = $val;
			} elsif ( $atr eq 'User-Password' ) {
				$props->{'passwd'} = $val;
			}
		}
		return '';
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		info "J'ai (radius) recu l'evennement innattendu: ".$event;
		return '';
	}
	return undef;
}

sub __traite_ar_td($$$) { # Test
	my ( $props, $event_prop, $ptid ) = @_;
	if ( $event_prop->{'statut'} eq 'TRANSMISE' ) {
		# Tout va bien, je stocke les infos
		return '';
	} elsif ( $event_prop->{'statut'} eq 'REJETEE' ) {
		# Tout va mal!
		my $code = $event_prop->{'code-rejet'};
		x_error "Une commande a ete rejetee par TD.";
		x_error "Code du rejet: ".$code;
		$props->{'code-rejet'} = $code;
		if ( defined $rejets_td->{$code} ) {
			x_error "Motif: ".$rejets_td->{$code};
			$props->{'message-rejet'} = $rejets_td->{$code};
		} else {
			x_error "Code d'erreur inconnu";
			$props->{'message-rejet'} = "Ce code de rejet est inconnu";
		}
		if ( $ptid ) {
			new_run($ptid,'REJET-ARTD');
		}
		__envoie_mail(undef,'bureau-rejetar',$props->{'telephone'},$props);
		return undef;
	} else {
		x_error "Contenu de l'AR incomprehensible:";
		x_error "La recevabilite est ".$event_prop->{'statut'}." qui n'est ni TRANSMISE ni REJETEE";
		return undef;
	}
	x_error "Je ne devrait pas tre l";
	return undef;
}

sub attend_ar_td($$$) {
	return __attend_ar_generique(@_,\&__traite_ar_td);
}

sub __traite_ar_9t($$$) { # Test
	my ( $props, $event_prop, $ptid ) = @_;
	if ( $event_prop->{'statut'} eq 'ACCEPTEE' ) {
		# Tout va bien, je stocke les infos
		return '';
	} elsif ( $event_prop->{'statut'} eq 'REFUSEE' ) {
		# Tout va mal!
		my $code = $event_prop->{'code-rejet'};
		x_error "Une commande a ete rejetee par 9T.";
		x_error "Code du rejet: ".$code;
		$props->{'code-rejet'} = $code;
		if ( defined $rejets_9t->{$code} ) {
			x_error "Motif: ".$rejets_9t->{$code};
			$props->{'message-rejet'} = $rejets_9t->{$code};
		} else {
			x_error "Code d'erreur inconnue";
			$props->{'message-rejet'} = "Ce code de rejet est inconnu";
		}
		if ( $ptid ) {
			new_run($ptid,'REJET-ARTD');
		}
		__envoie_mail(undef,'bureau-rejetar',$props->{'telephone'},$props);
		return undef;
	} else {
		x_error "Contenu de l'AR 9T incomprhensible:";
		x_error "Le status est ".$event_prop->{'statut'}." qui n'est ni ACCEPTEE ni REFUSEE.";
		return undef;
	}
	x_error "N'a rien  faire ici";
	return undef;
}

sub attend_ar_9t($$$) {
	return __attend_ar_generique(@_,\&__traite_ar_9t);
}

sub __attend_ar_generique($$$$) {
	my ( $props, $event, $date, $traitement ) = @_;
	my $arev = 'ARTD-'.$props->{'ordretd-id'};
	if ( $props->{'cegetel'} ) {
		x_info "Pas besoin d'attendre l'AR TD/9T (cas Cegetel)";
		return '';
	}
	if ( $event eq 'init' ) {
		info "J'attends l'AR TD/9T pour la ligne ".$props->{telephone};
		info "Attente evennement ".$arev;
		if ( ! defined $props->{'ptid'} ) {
			$props->{'ptid'} = -1;
		}
		return $arev;
	} elsif ( $event eq $arev ) {
		my $ptid = $props->{'ptid'};
		x_info "J'ai recu l'AR TD/9T\n";
		my $ev = event_par_event($event);
		my $eid = $ev->{'EVENT_ID'};
		my $event_prop = get_event_properties($eid);
		if ( ! defined $props->{'ARs'} ) {
			$props->{'ARs'} = [];
		}
		push @{$props->{'ARs'}}, $event_prop;
		
		
		$props->{'id-sips'} = $event_prop->{'numcde'};
		$props->{'date-cde-recue'} = $event_prop->{'date-recu'};
		$props->{'date-cde-traitee'} = $event_prop->{'date-traitee'};
		$props->{'date-cde-finie'} = $event_prop->{'date-future'};
		$props->{'commentaire-td'} = $event_prop->{'commentaire'};

		if ( $props->{'telephone'} != $event_prop->{'telephone'} ) {
			x_error "Curieux, cet AR ne porte pas sur ma ligne. Je continue neanmois.";
			$props->{'erreur'} = "Recu un AR pour le ".$event_prop->{'telephone'}." alors que j'attend pour ".$props->{'telephone'};
		}
		return &$traitement($props,$event_prop,$ptid);
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info "J'ai (wait ar) recu l'evennement curieux: ".
			$event;
		return '';
	}
}

sub __attend_cr_generique($$$$) {
	my ( $props, $event, $date, $traite_cr ) = @_;
	if ( $props->{'cegetel'} ) {
		x_info "Pas besoin d'attendre le CR TD (cas Cegetel)";
		return '';
	}
	my $crev = 'CRTD-'.$props->{'ordretd-id'};
	if ( $event eq 'init' ) {
		info "J'attends le CR TD pour la ligne ".$props->{telephone};
		info "Attente evennement ".$crev;
		if ( ! defined $props->{'ptid'} ) {
			$props->{'ptid'} = -1;
		}
		return $crev;
	} elsif ( $event eq $crev ) {
		my $ptid = $props->{'ptid'};
		x_info "J'ai recu un CR TD";
		my $ev = event_par_event($event);
		my $eid = $ev->{'EVENT_ID'};
		my $event_prop = get_event_properties($eid);
		if ( ! defined $props->{'CRs'} ) {
			$props->{'CRs'} = [];
		}
		push @{$props->{'CRs'}}, $event_prop;

		return &$traite_cr($props, $event, $event_prop);
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info "J'ai (wait cr) recu l'evennement curieux: ".
			$event;
		return '';
	}
}

sub __traite_cr_td() {
	my ( $props, $event, $event_prop ) = @_;
	
	$props->{'commentaire-td'} = $event_prop->{'commentaire-td'};
	if ( $event_prop->{'statut'} eq 'TRAITEE_OK' ) {
		x_info "CR positif, tout va bien, on boucle la commande.";
		$props->{'offre-td'} = $event_prop->{'offre'};
		$props->{'date-cr'} = $event_prop->{'date-cr'};
		$props->{'date-ok'} = $event_prop->{'date-future'};
		$props->{'new-tel'} = $event_prop->{'new-tel'};
		$props->{'id-crtd'} = $event;
		return '';
	} elsif ( $event_prop->{'statut'} eq 'TRAITEE_NOK' ) {
		my $code = $event_prop->{'date-future'};
		x_error "Une commande a ete rejetee definitivement par TD.";
		x_error "Code du rejet (CR): ".$code;
		$props->{'code-rejet'} = $code;
		if ( defined $rejets_cr_td->{$code} ) {
			x_error "Motif: ".$rejets_cr_td->{$code};
			$props->{'message-rejet'} = $rejets_cr_td->{$code};
		} else {
			x_error "Code d'erreur inconnu";
			$props->{'message-rejet'} = "Ce code de rejet est inconnu";
		}
		my $ptid = $props->{'ptid'};
		if ( $ptid ) {
			new_run($ptid,'CRNOK');
		}
		__envoie_mail(undef,'bureau-crnok',$props->{'telephone'},$props);
		return undef;
	} elsif ( $event_prop->{'statut'} eq 'ETUDE_OK' ) {
		x_info "CR d'etude (non-demande), rien de grave.";
		my $date = $event_prop->{'date-future'};
		my $ptid = $props->{'ptid'};
		$props->{'date-etude'} = $date;
		if ( $ptid ) {
			new_run($ptid,'ETUDOK/'.$date);
		}
		__envoie_mail(undef,'bureau-etudok',$props->{'telephone'},$props);
		my $ev = event_par_event($event);
		my $eid = $ev->{'EVENT_ID'};
		if ( ! $eid ) {
			x_error "Je dois supprimer l'evennement <$event> que je ne trouve pas en base...";
		} else {
			del_event_properties($eid);
			del_event($eid);
		}
		x_info "Mise en service attendue le ".$date;
		x_info "Attente evennement ".$event." apres ETUDE_OK\n";
		return $event;
	} elsif ( $event_prop->{'statut'} eq 'SATURE' ||
		  $event_prop->{'statut'} eq 'SATUREE' ) {
		x_info "CR de saturation, embetant";
		my $date = $event_prop->{'date-future'};
		my $ptid = $props->{'ptid'};
		$props->{'date-sature'} = $date;
		if ( $ptid ) {
			new_run($ptid,'SATUR/'.$date);
		}
		__envoie_mail(undef,'bureau-satur',$props->{'telephone'},{%$props,%$event_prop});
		my $ev = event_par_event($event);
		my $eid = $ev->{'EVENT_ID'};
		if ( ! $eid ) {
			x_error "Je dois supprimer l'evennement <$event> que je ne trouve pas en base (cas 2)...";
		} else {
			del_event_properties($eid);
			del_event_par_event($event);
		}
		x_info "Mise en service attendue le ".$date;
		x_info "Attente evennement ".$event." apres SATURE";
		return $event;
	} else {
		x_error "Le contenu du CR est incomprehensible";
		x_error "Le resultat est <".$event_prop->{'statut'}."> qui n'est aucune des valeurs connues";
		return undef;
	}
}

sub attend_cr_td($$$) {
	my ( $props, $event, $date ) = @_;
	return __attend_cr_generique($props, $event, $date, \&__traite_cr_td);
}

sub __traite_cr_9t($$$) {
	my ( $props, $event, $event_prop ) = @_;

	$props->{'commentaire-9t'} = $event_prop->{'commentaire'};
	if ( $event_prop->{'statut'} eq 'EFFECTUEE' ) {
		x_info "CR positif, tout va bien, on boucle la commande.";
		$props->{'offre-td'} = $event_prop->{'offre-td'};
		$props->{'date-cr'} = $event_prop->{'date-recu'};
		$props->{'date-ok'} = $event_prop->{'date-traitee'};
		$props->{'idcrtd'} = $event;
		return '';
	} elsif ( $event_prop->{'statut'} eq 'IMPOSSIBLE' ) {
		my $code = $event_prop->{'code-rejet'};
		x_error "Une commande a t rejete dfinitivement par 9T.";
		x_error "Le motif du rejet est: ".$code;
		$props->{'code-rejet'} = $code;
		my $msg = $rejets_9t->{$code};
		if ( defined $msg ) {
			x_error "Motif: ".$msg;
			$props->{'message-rejet'} = $msg;
		} else {
			x_error "Code rejet inconnu (ou alors le code est en fait un message)";
			$props->{'message-rejet'} = "Code rejet inconnu. C'est surement dj un message.";
		}
		my $ptid = $props->{'ptid'};
		if ( $ptid ) {
			new_run($ptid,'CRNOK');
		}
		__envoie_mail(undef,'bureau-crnok',$props->{'telephone'},$props);
		return undef;
	} else {
		x_error "Le contenu du CR est incomprhensible";
		x_error "Le type du CR est <".$event_prop->{'statut'}."> qui n'est aucune des valeurs connues";
		return undef;
	}
}

sub attend_cr_9t($$$) {
	my ( $props, $event, $date ) = @_;
	return __attend_cr_generique($props, $event, $date, \&__traite_cr_9t);
}

























sub __get_ligne_info_tech($) {
	my ( $props ) = @_;
	my $lid = $props->{'ligneid'};
	if ( ! $lid ) {
		x_error "Il me manque le parametre 'ligneid'";
		return undef;
	}

	my $ligne = ligne_par_id($lid);
	if ( ! defined $ligne ) {
		x_error "La ligne numero $lid n'existe pas";
		return undef;
	}

	my $ru = raduser_par_ligne_id($lid);
	my $rid;
	if ( ! defined $ru ) {
		x_error "La ligne '$lid' n'a pas de compte radius associe.";
		$rid = 0;
	} else {
		$rid = $ru->{'RADUSER_ID'};
	}
	$props->{'radiusid'} = $rid;

	my $ipid;
	if ( $rid ) {
		my $ip = ipaddr_par_raduser_id($rid);
		if ( ! defined $ip ) {
			x_error "Le compte radius '$rid' n'a pas d'IP associee.";
			return undef;
		}
		$ipid = $ip->{'IPADDR_ID'};
	} else {
		$ipid = 0;
	}
	$props->{'ipid'} = $ipid;

	my $aid = $ligne->{'ADRESSE_ID'};
	if ( ! $aid ) {
		x_error "La ligne '$lid' n'a pas d'adresse.";
		return undef;
	}

	my $adr = adresse_par_id($aid);
	if ( ! defined $adr ) {
		x_error "La ligne '$lid' dit avoir l'adresse '$aid' qui n'existe pas";
		return undef;
	}

	if ( defined $adr->{'ADRESSE_MAIL'} ) {
		$props->{'email'} = $adr->{'ADRESSE_MAIL'};
	}
	return '';
}

sub perte_ligne_adsl($$$) {
	my ( $props, $event, $date ) = @_;
	my $pref = Config_Section('adsl/tables.cfg','task-prefix');
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	if ( $event eq 'init' ) {
		x_info "On commence  valider la perte de la ligne ".$props->{'ligneid'};
		my $res = __get_ligne_info_tech($props);
		if ( ! defined $res ) {
			x_error "Echec au demarrage de la validation de la perte de la ligne";
			return undef;
		}
		my $email = $props->{'email'};
		if ( $email ) {
			__envoie_mail($email,'perte',$props->{'telephone'},$props);
		}
		new_info_ligne($lid,'inline','Debut de perte',
			"La tche de validation de la perte a trouv les infos utiles.\n".
			"La validation de la perte est donc lance.");
	} elsif ( $event =~ /EOT-$pref->{resil_radius}/ ) {
		if ( $email ) {
			__envoie_mail($email,'resil-rad',$props->{'telephone'},$props);
		}
		new_info_ligne($lid,'inline','Blocage compte radius',
			"Le compte radius de la ligne a ete desactive.");
	} elsif ( $event =~ /^EOT-$pref->{free_ip}/ ) {
		new_info_ligne($lid,'inline','Liberation des IPs',
			"Les adresses IPs associees a cette ligne ont ete liberees.");
	} elsif ( $event =~ /^EOT-$pref->{stop_factu}/ ) {
		if ( $email ) {
			__envoie_mail($email,'resil-factu',$props->{'telephone'},$props);
		}
		new_info_ligne($lid,'inline','Arret de la facturation',
			"La facturation de la ligne s'arrete aujourd'hui.");
	} elsif ( $event eq 'end' ) {
		new_info_ligne($lid,'inline','Fin du process de validation de la perte d\'accs',
			"Le process de validation de la perte de l'accs est termin.");
	} else {
		x_info "La tache de validation de la perte de la ligne ".$props->{'telephone'}." a recu ".
			"cet evenement innattendu: '$event'. On continue, comme si de rien n'etait.";
	}
	return '';
}

sub resilier_ligne_adsl($$$) {
	my ( $props, $event, $date ) = @_;
	my $pref = Config_Section('adsl/tables.cfg','task-prefix');
	my $email = $props->{'email'};
	my $lid   = $props->{'ligneid'};
	if ( $event eq 'init' ) {
		x_info "On commence la resiliation de la ligne ".$props->{'ligneid'};

		if ( ! $lid ) {
			x_error "Il me manque le parametre 'ligneid'";
			return undef;
		}

		my $ligne = ligne_par_id($lid);
		if ( ! defined $ligne ) {
			x_error "La ligne numero $lid n'existe pas";
			return undef;
		}
		$props->{'option'} = $ligne->{'LIGNE_OPT'};
		$props->{'telephone'} = $ligne->{'LIGNE_TEL'};

		my $did = $ligne->{'DEBIT_ID'};
		if ( ! $did ) {
			x_error "Cette ligne n'a pas de debit...";
			return undef;
		}
		
		my $debit = debit_par_id($did);
		if ( ! defined $debit ) {
			x_error "Cette ligne a le debit '$did' qui n'existe pas";
			return undef;
		}
		$props->{'debit'} = $debit->{'DEBIT_DEBIT'};

		my $offre = Config_Key('adsl/tables.cfg',$props->{'option'},$props->{'debit'});
		if ( ! $offre ) {
			x_error "Le debit '".$props->{'debit'}."' en option '".
				$props->{'option'}."' n'est pas dans le fichier de conf";
			return undef;
		}
		$props->{'offre'} = $offre;
		
		my $aid = $ligne->{'ADRESSE_ID'};
		if ( ! $aid ) {
			x_error "La ligne '$lid' n'a pas d'adresse.";
			return undef;
		}

		my $adr = adresse_par_id($aid);
		if ( ! defined $adr ) {
			x_error "La ligne '$lid' dit avoir l'adresse '$aid' qui n'existe pas";
			return undef;
		}
		$props->{'nom'}     = $adr->{'ADRESSE_NOM'};
		$props->{'adresse'} = $adr->{'ADRESSE_ADR'};
		$props->{'cp'}      = $adr->{'ADRESSE_CP'};
		$props->{'ville'}   = $adr->{'ADRESSE_VILLE'};

		my $ru = raduser_par_ligne_id($lid);
		my $rid;
		if ( ! defined $ru ) {
			x_error "La ligne '$lid' n'a pas de compte radius associe.";
			$rid = 0;
		} else {
			$rid = $ru->{'RADUSER_ID'};
		}
		$props->{'radiusid'} = $rid;

		my $ipid;
		if ( $rid ) {
			my $ip = ipaddr_par_raduser_id($rid);
			if ( ! defined $ip ) {
				x_error "Le compte radius '$rid' n'a pas d'IP associee.";
				return undef;
			}
			$ipid = $ip->{'IPADDR_ID'};
		} else {
			$ipid = 0;
		}
		$props->{'ipid'} = $ipid;
		
		if ( defined $adr->{'ADRESSE_MAIL'} ) {
			$props->{'email'} = $adr->{'ADRESSE_MAIL'};
			$email = $props->{'email'};
		}
		if ( $email ) {
			__envoie_mail($email,'resil1',$props->{'telephone'},$props);
		}
		new_info_ligne($lid,'inline','Debut de resiliation',
			"La tache de resiliation a trouve toutes les infos utiles,\n".
			"la resiliation est donc lancee.");
	} elsif ( $event =~ /^EOT-$pref->{restd}/ ) {
		if ( $email ) {
			__envoie_mail($email,'resil-td',$props->{'telephone'},$props);
		}
		new_info_ligne($lid,'inline','Envoie de la resiliation a TD',
			"La resiliation de cette ligne a ete envoyee a TD.");
	} elsif ( $event =~ /^EOT-$pref->{resil_radius}/ ) {
		if ( $email ) {
			__envoie_mail($email,'resil-rad',$props->{'telephone'},$props);
		}
		new_info_ligne($lid,'inline','Blocage compte radius',
			"Le compte radius de la ligne a ete desactive.");
	} elsif ( $event =~ /^EOT-$pref->{free_ip}/ ) {
		new_info_ligne($lid,'inline','Liberation des IPs',
			"Les adresses IPs associees a cette ligne ont ete liberees.");
	} elsif ( $event =~ /^EOT-$pref->{stop_factu}/ ) {
		if ( $email ) {
			__envoie_mail($email,'resil-factu',$props->{'telephone'},$props);
		}
		new_info_ligne($lid,'inline','Arret de la facturation',
			"La facturation de la ligne s'arrete aujourd'hui.");
	} elsif ( $event =~ /^EOT-$pref->{wait_ar_td}\// ) {
		new_info_ligne($lid,'inline','Resiliation recue par TD',
			"TD nous a renvoye un AR positif pour cette resiliation");
	} elsif ( $event =~ /^EOT-$pref->{wait_cr_td}\// ) {
		if ( $email ) {
			__envoie_mail($email,'resil-crtd',$props->{'telephone'},$props);
		}
		new_info_ligne($lid,'inline','Resiliation faite par TD',
			"TD nous a renvoye un CR positif pour cette resiliation");
	} elsif ( $event eq 'end' ) {
		new_info_ligne($lid,'inline','Fin du process de resiliation',
			"Le process de resiliation est termine.");
	} elsif ( $event eq 'REJET-ARTD' ) {
		x_error "Recu une notification de rejet d'ARTD. Bureau deja prevenu.";
		new_info_ligne($lid,'inline','AR de rejet par TD',
			"TD nous a fait parvenir un AR de rejet de la commande de resiliation.\n".
			"Plus d'infos dans la tache de resiliation.");
	} elsif ( $event eq 'CRNOK' ) {
		x_error "Recu une notification de rejet de CRTD. Bureau deja prevenu.";
		new_info_ligne($lid,'inline','CR de rejet par TD',
			"TD nous a fait parvenir un CR de rejet de la commande de resiliation.\n".
			"Plus d'infos dans la tache de resiliation.");
	} elsif ( $event =~ /^ETUDOK\/(.*)$/ ) {
		my $date = $1;
		x_error "Recu une notification d'etude OK sur une resiliation.";
		new_info_ligne($lid,'inline','CR etude OK par TD',
			"TD nous a fait parvenir un CR d'etude OK sur cette resiliation.\n".
			"Ce message n'a vraiment aucun sens...\n".
			"Date prevue de mise en service: $date.");
	} elsif ( $event =~ /^SATUR\/(.*)$/ ) {
		my $date = $1;
		x_error "Recu une notification de saturation sur cette resiliation.";
		new_info_ligne($lid,'inline','CR de saturation par TD',
			"TD nous a fait parvenir un CR de saturation des DSLAMs sur resil.\n".
			"Ce message n'a vraiment aucun sens...\n".
			"Date prevue de mise en service: $date.");
	} else {
		x_info "La tache de resiliation de la ligne ".$props->{'telephone'}." a recu ".
			"cet evenement innattendu: '$event'. On continue, comme si de rien n'etait.";
	}
	return '';
}

sub prepare_resil_9t($$$) {
	my ( $props, $event, $date ) = @_;
	return __prepare_commande_any($props, $event, $date, sub {
		my $props = shift;
		my $date = strftime "%Y%m%d", localtime;
		my $code = 'SUPPRESSION';
		my $type_modif = '';
		my $id_ldcom = $props->{'idld'};
		# FIXME Vrifier qu'on a le ligne-id dans $props
		return __ligne_ordre_9t(
			'code_echange'               => $code,                  # 03 
			'date_commande'              => $date,                  # 02 Quid ?
			'id_contrat'                 => '2005-093',             # 05 FIXME Mettre en conf
			'id_commande_client'         => $props->{'ordretd-id'}, # 06
			'id_ldcom'                   => $id_ldcom,              # 43
			'id_service_administratif'   => '',                     # 48 Quid?
			'type_modif'                 => $type_modif,            # 26
			'type_operation'             => '',                     # 44 Utile pour migration FT, dtails? Quid?
			'code_service'               => $props->{'offre'},      # 04
			'reference_eligibilite'      => '',                     # 07 Vide
			'id_mandat'                  => '',                     # 08
			'code_package_services_voix' => '',                     # 46 Pas de VoIP
			'type_numero'                => '',                     # 51 Pas de VoIP
			'nom_prenom_utilisateur'     => $props->{'nom'},        # 09
			'adresse_utilisateur'        => $props->{'adresse'},    # 10
			'compl_ adresse_utilisateur' => '',                     # 11
			'code_postal_utilisateur'    => $props->{'cp'},         # 12
			'commune_utilisateur'        => $props->{'ville'},      # 13
			'reference_utilisateur'      => 'tid '.$props->{'tid'}, # 29 Sert a rien, on met le tid qui est unique.
			'login_utilisateur'          => '',                     # 30
			'code_siret'                 => '',                     # 31
			'mdp_utilisateur'            => '',                     # 53 L'usage n'en est pas clair
			'email_utilisateur'          => '',                     # 54 L'usage n'en est pas clair
			'contrat'                    => '',                     # 57 Pas clair
			'id_facturation'             => '',                     # 58
			'type_ligne'                 => 'TL',                   # 14
			'statut_ligne'               => $props->{'statut-ligne'},# 15
			'identifiant_ligne'          => $props->{'telephone'},  # 16
			'nom_prenom_contact'         => $props->{'nom'},        # 23
			'telephone_contact'          => $props->{'telephone'},  # 24
			'telephone2_contact'         => '',                     # 36
			'email_contact'              => '',                     # 37
			'type_degroupage'            => $props->{'degroupage'}, # 17
			'portabilite'                => '',                     # 18
			'regime_sav'                 => 'NORMAL',               # 19
			'mode_livraison'             => 'IP',                   # 27
			'conduit'                    => '',                     # 28
			'option_mes'                 => 'NON',                  # 39
			'longueur_desserte_interne'  => '',                     # 40
			'option_vp'                  => '',                     # 41
			'infrastructure'             => '',                     # 55
			'achat_cpe'                  => 'NON',                  # 31
			'location_cpe'               => 'NON',                  # 32
			'interface'                  => 'CUIVRE',               # 42
			'installation_cpe'           => 'NON',                  # 33
			'routeur'                    => '',                     # 35
			'modem'                      => '',                     # 34
			'numero_IP_8AB'              => '',                     # 49
			'numero_IP_geo'              => '',                     # 50
			'fqdn'                       => '',                     # 56
			'commentaire'                => '',                     # 25
			);
		}
	);
	
}

sub prepare_resil_td($$$) {
	my ( $props, $event, $date ) = @_;
	if ( $event eq 'init' ) {
		x_info "Je prepare la resiliation TD pour la ligne id:".$props->{'ligneid'};
		my $oid = new_ordretd();
		if ( !defined $oid ) {
			$props->{'erreur'} = "Pas reussi a creer un ordre TD!";
			return undef;
		}
		$props->{'ordretd-id'} = $oid;
		my $ordre = __ligne_ordre_td(
			'ordre'			=> 'RESIL',
			'offre'			=> $props->{'offre'},
			'id-fdn'		=> $props->{'ordretd-id'},
			'mandat'		=> '', 
			'nom'			=> $props->{'nom'},
			'prenom'		=> '',
			'adresse'		=> $props->{'adresse'},
			'cp'			=> $props->{'cp'},
			'ville'			=> $props->{'ville'},
			'type-ligne'		=> 'TL',
			'statut-ligne'		=> 'A',
			'nd'			=> $props->{'telephone'},
			'adresse-construction'	=> '',
			'cpladr-construction'	=> '',
			'cp-construction'	=> '',
			'ville-construction'	=> '',
			'nom-construction'	=> '',
			'tel-construction'	=> '',
			'fax-construction'	=> '',
			'sav'			=> '',
			'contrat'		=> '2005-093', # Quid ?
			'adr-livraison'		=> '',
			'vpi-livraison'		=> '',
			'vci-livraison'		=> '',
			'desserte-interne'	=> '',
			'lg-desserte'		=> '',
			'dispo-locaux'		=> '',
			'dispo-construction'	=> '',
			'id-osm'		=> '',
			'interface-xdsl'	=> '',
			'ancien-operateur'	=> '',
			'commentaire'		=> ''
			);
		$props->{'ordretd'} = $ordre;
		set_ordretd_ligne($oid,$ordre);
		x_info "J'attends l'evennement ARFIC-".$props->{'ordretd-id'};
		return 'ARFIC-'.$props->{'ordretd-id'};
	} elsif ( $event eq 'ARFIC-'.$props->{'ordretd-id'} ) {
		x_info "La resiliation TD pour ".$props->{telephone}." a ete recue.";
		return '';
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info  "La tache d'envoie de la resiliation a TD a recu cet evennement curieux: ".
			"'$event'. On continue comme si de rien n'etait.";
		return '';
	}
}

sub resiliation_radius($$$) { # Test
	my ( $props, $event, $date ) = @_;
	if ( $event eq 'init' ) {
		my $rid = $props->{'radiusid'};
		if ( $rid == 0 ) {
			return '';
		}
		my $ru = raduser_par_id($rid);
		if ( ! defined $ru ) {
			x_error "Le compte radius numero $rid n'existe pas.";
			return undef;
		}
		my $login = $ru->{'RADUSER_LOGIN'};
		if ( $login =~ /fdn\.(fr|nerim)$/ ) {
			$login =~ s/fdn\.(fr|nerim)$/\/VALID/;
		} elsif ( $login =~ /VALID$/ ) {
			x_info "Le compte radious numero $rid est deja invalide";
			return '';
		} else {
			x_error "Le compte radius numero $rid ne se termine pas par 'fdn.fr' ou 'fdn.nerim'";
			return undef;
		}
		set_raduser_login($rid,$login);
		return '';
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info "La tche de rsiliation du compte radius a reu cet vennement curieux: '$event'. On continue comme si de rien n'tait.";
		return '';
	}
}

sub free_ip($$$) { # Test
	my ( $props, $event, $date ) = @_;
	if ( $event eq 'init' ) {
		my $ipid = $props->{'ipid'};
		if ( $ipid == 0 ) {
			return '';
		}
		my $ip = ipaddr_par_id($ipid);
		if ( ! defined $ip ) {
			x_error "L'adresse IP numero $ipid n'existe pas.";
			return undef;
		}
		set_ipaddr_etat($ipid,'free');
		return '';
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info "La tache de liberation des IPs a recu cet evennement curieux: '$event'. On conitnue comme si de rien n'etait.";
		return '';
	}
}

sub stop_factu_ligne($$$) {
	my ( $props, $event, $date ) = @_;
	if ( $event eq 'init' ) {
		my $lid = $props->{'ligneid'};
		my $date = $props->{'date'};
		my $lig = ligne_par_id($lid);
		if ( ! defined $lig ) {
			x_error "Ligne numero $lid n'existe pas.";
			return undef;
		}
		if ( $lig->{'LIGNE_STATE'} ne 'del' ) {
			set_ligne_state($lid,'del');
		} else {
			x_info "Ligne deja resiliee";
		}
		if ( $lig->{'LIGNE_DTOUT'} eq '0000-00-00 00:00:00' ) {
			set_ligne_dtout($lid,$date);
		} else {
			x_info "Facturation deja arretee";
		}
		if ( $lig->{'LIGNE_TEL'} =~ /^\d{10}$/ ) {
			my $res_id;
			if ( $props->{'ptid'} ) {
				$res_id = $props->{'ptid'};
			} else {
				$res_id = $props->{'tid'};
			}
			if ( ! $res_id ) {
				$res_id = $lig->{'LIGNE_TEL'};
			}
			set_ligne_tel($lid,$lig->{'LIGNE_TEL'}.'.r'.$res_id);
		} else {
			x_info "Numero de telephone deja libre";
		}
		return '';
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info "La tache d'arret de la facturation a recu cet evennement curieux: '$event'. On conitnue comme si de rien n'etait.";
		return '';
	}
}

#sub exemple_tache_atomique($$$) {
#	my ( $props, $event, $date ) = @_;
#	if ( $event eq 'init' ) {
#	} elsif ( $event eq 'end' ) {
#	} else {
#		x_info "La tache TACHE a recu cet evennement curieux: '$event'. On conitnue comme si de rien n'etait.";
#		return '';
#	}
#}








sub changer_ligne_adsl_nerim($$$) {
	my ( $props, $event, $date ) = @_;
	$props->{'modif'} = 1;
	my $pref = Config_Section('adsl/tables.cfg','task-prefix');
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	if ( $event eq 'init' ) {
		# FIXME Il faut que le mandat soit clon pour aller avec le nouveau dploiement
		# FIXME Il faut des prix sans FAS?
		my $ret = __init_depl_ligne($props);
		debug "L'initialisation de la modification renvoie $ret.";
		if ( ! defined $ret ) {
			x_error "Pas reussi a preparer la modif. Echec.";
			return undef;
		}
		return '';
	} elsif ( $event =~ /^EOT-$pref->{eligN}/ ) {
		__eot_elig($props);
	} elsif ( $event =~ /^EOT-$pref->{cdenerim}\// ) {
		__eot_cdeN($props);
	} elsif ( $event =~ /^EOT-$pref->{'wait_ar_nerim'}\// ) {
		__eot_arN($props);
	} elsif ( $event eq 'end' ) {
		__end_depl_ligne($props);
	} elsif ( $event =~ /^FEOT-([A-Z]+)\/(\d*)$/ ) {
		my ( $etape, $tel ) = ( $1, $2 );
		__feot($props,$etape,$tel);
	} else {
		x_info "La tache de modification de ligne ADSL a recu cet evennement curieux: $event. On continue comme si de rien n'tait.";
	}
	return '';
}


sub changer_ligne_adsl_9t($$$) {
	my ( $props, $event, $date ) = @_;
	$props->{'modif'} = 1;
	my $pref = Config_Section('adsl/tables.cfg','task-prefix');
	my $email = $props->{'email'};
	my $lid = $props->{'ligneid'};
	if ( $event eq 'init' ) {
		# FIXME Il faut que le mandat soit clon pour aller avec le nouveau dploiement
		# FIXME Il faut des prix sans FAS?
		my $ret = __init_depl_ligne($props);
		debug "L'initialisation de la modification renvoie $ret.";
		if ( ! defined $ret ) {
			x_error "Pas reussi a preparer la modif. Echec.";
			return undef;
		}
		return '';
	} elsif ( $event =~ /^EOT-$pref->{elig}/ ) {
		__eot_elig($props);
	} elsif ( $event =~ /^EOT-$pref->{cde9t}\// ) {
		__eot_cde9t($props);
	} elsif ( $event =~ /^EOT-$pref->{'wait_ar_9t'}\// ) {
		__eot_ar9t($props);
	} elsif ( $event =~ /^EOT-$pref->{'wait_cr_9t'}\// ) {
		__eot_cr9t($props);
	} elsif ( $event eq 'end' ) {
		__end_depl_ligne($props);
	} elsif ( $event =~ /^FEOT-([A-Z]+)\/(\d*)$/ ) {
		my ( $etape, $tel ) = ( $1, $2 );
		__feot($props,$etape,$tel);
	} elsif ( $event eq 'REJET-ARTD' ) {
		x_error "Recu une notification de rejet d'ARTD. Faire suivre par mail a l'abonne.";
		if ( $email ) {
			__envoie_mail($email,'rejet-arcde',$props->{'telephone'},{
				'urlsuivi' => $urlsuivi,
				%$props
			});
		}
		new_info_ligne($lid,'inline','AR de rejet par NeufCegetel',
			"NeufCegetel nous a fait parvenir un AR de rejet de la commande.\n".
			"Plus d'infos dans la tache de modification.");
	} else {
		x_info "La tache de modification de ligne ADSL a recu cet evennement curieux: $event. On continue comme si de rien n'tait.";
	}
	return '';
}









sub mail_bureau($$$) {
	my ( $props, $event, $date ) = @_;
	if ( $event eq 'init' ) {
		my $type = $props->{'type'};
		my $tel  = $props->{'telephone'};
		if ( ! defined $tel ) {
			$tel = '1122334455';
		}
		__envoie_mail(undef,$type,$tel,$props);
		return '';
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info "La tache mail_bureau a reu cet vennement curieux: '$event'. On continue comme si de rien n'tait.";
		return '';
	}
}





sub notif_change_num($$$) {
	my ( $props, $event, $date ) = @_;
	if ( $event eq 'init' ) {
		my $oldnum = $props->{'oldnum'};
		my $newtel = $props->{'newnum'};
		my $actions = '';
		$actions .= "Je cherche la ligne  partir de l'ancien numro ($oldnum).\n";
		my $ligne = ligne_par_tel($oldnum);
		my $lid;
		my $cid;
		my $cmail;
		if ( defined $ligne ) {
			$lid = $ligne->{'LIGNE_ID'};
			$actions .= "J'ai trouv une ligne, numro $lid.\n";
			$actions .= "Il faudrait donc faire un set_ligne_tel($lid,'$newtel');\n";
			$actions .= "On encore, en sql:\n";
			$actions .= "update LIGNE set LIGNE_TEL = '$newtel' where LIGNE_ID = $lid;\n";
			$actions .= "Faire  la main si c'est raisonnable. Automatiser, aussi.\n";
			$actions .= "Pour automatiser, c'est dans FDN::Adsl::Wf.pm, fonction notif_change_num.\n\n";

			$actions .= "Il faut galement rattacher une info  la ligne disant qu'il y a eu changement\n";
			$actions .= "new_info_ligne($lid,'inline','Changement de numro','texte...');\n\n";
			
			$actions .= "Je cherche maintenant le client d'aprs la ligne.\n";
			$cid = $ligne->{'CLIENT_ID'};
			my $client = client_par_id($cid);
			if ( defined $client ) {
				$actions .= "C'est le client numro $cid. Trouv en base.\n";
				$actions .= "Je remonte sont adresse.\n";
				my $aid = $client->{'ADRESSE_ID'};
				my $adresse = adresse_par_id($aid);
				if ( defined $adresse ) {
					$actions .= "Adresse trouve en base. Numro $aid.\n";
					$cmail = $adresse->{'ADRESSE_MAIL'};
				} else {
					$actions .= "Son adresse n'existe pas. On ne peut pas le prvenir.\n";
				}
			} else {
				$actions .= "Je n'ai pas trouv le client... Trs curieux. Voir  la main.\n";
			}
			if ( defined $cmail ) {
				$actions .= "Le client existe, il a une adresse mail. Lui envoyer un mail.\n";
				$actions .= "Son adresse: $cmail\n";
			} else {
				$actions .= "On n'a pas trouv d'adresse mail. Juste prvenir le bureau.\n";
			}
		} else {
			$actions .= "Je n'ai pas trouv de ligne avec ce numro. Visiblement c'est pas chez nous.\n";
		}
		$props->{'actions'} = $actions;
		#FIXME Il faut remplacer 'undef' par $cmail, quand on saura un peu de quoi il retourne.
		#Il faut galement revoir le mail (changer de type, c'est pas uniquement pour le bureau).
		__envoie_mail(undef,'bureau-not-non',$oldnum,$props);
		return '';
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info "La tache notif_change_num a reu cet vennement curieux: '$event'. On continue comme si de rien n'tait.";
		return '';
	}
}




sub notif_perte_ligne($$$) {
	my ( $props, $event, $date ) = @_;
	my $ack = 'ACK-'.$props->{'tid'};
	if ( $event eq 'init' ) {
		my $tel = $props->{'telephone'};
		my $ligne = ligne_par_tel($tel);
		if ( ! defined $ligne ) {
			x_error "Reu notification de perte de la ligne <$tel>, introuvable. Echec.";
			return undef;
		}
		my $lid = $ligne->{'LIGNE_ID'};
		my $cid = $ligne->{'CLIENT_ID'};
		my $client = client_par_id($cid);
		if ( ! defined $client ) {
			x_error "Reu notification de perde de la ligne <$tel>, ne trouve pas le client <$cid> associ. Echec.";
			return undef;
		}
		my $aid = $client->{'ADRESSE_ID'};
		my $adresse = adresse_par_id($aid);
		my $cmail;
		if ( defined $adresse ) {
			$cmail = $adresse->{'ADRESSE_MAIL'};
			$props->{'cmail'} = $cmail;
		}
		$props->{'ligneid'} = $lid;
		__envoie_mail($cmail,'perte-ligne',$tel,$props);
		__envoie_mail(undef,'bureau-perte-ligne',$tel,$props);
		new_validation('notif-perte',$ack,'perte ligne le '.$props->{'date-effet'},$lid,$cid);
		new_info_ligne($lid,'inline','Notification perte d acces',
			"Recu notification de perte d'acces de NeufCegetel le ".$props->{'date-effet'}." ".
			"mail envoy  l'abonn, attente de retour de sa part");
		return $ack;
	} elsif ( $event eq $ack ) {
		my $ev = event_par_event($event);
		my $evid = $ev->{'EVENT_ID'};
		my $propev = get_event_properties($evid);
		my $cmail;
		if ( $props->{'cmail'} ) {
			$cmail = $props->{'cmail'};
		}
		my $lid = $props->{'ligneid'};
		if ( $propev->{'type'} eq 'normale' ) {
			# Si l'evennement indique une perte normale:
			# - lancer une tache type perte-ligne-normal
			my $nprops = {
				'ligneid' => $props->{'ligneid'},
				'telephone' => $props->{'telephone'}
				};
			my $ntid = launch_task('perte-ligne-normal',$nprops);
			if ( ! $ntid ) {
				x_error "Echec au lancement de la tache de perte normale. Consulter les logs.";
				return undef;
			}
			$props->{'tache-perte-normale'} = $ntid;
			new_info_ligne($lid,'inline','Perte normale',
				"La notification de perte d'accs a t confirme par l'abonn ".
				"on lance les d-construction de la ligne dans les bases de FDN");
			return '';
		} elsif ( $propev->{'type'} eq 'anormale' ) {
			# Si l'evennement indique une perte anormale mais reelle:
			# - lancer une tache type perte-ligne-anormal
			#my $nprops = {
			#	# FIXME
			#	};
			#my $ntid = launch_task('perte-ligne-anormale',$nprops);
			#$props->{'tache-perte-anormale'} = $ntid;
			#return '';
			my $tel = $props->{'telephone'};
			x_error "La perte de la ligne $tel est anormale. Il faut reprendre la ligne. Je ne sais pas faire.";
			x_error "Je place la tache en echec";
			__envoie_mail($cmail,'perte-ligne-anormale',$tel,$props);
			new_info_ligne($lid,'inline','Perte anormale',
				"On a reu une info de l'abonn nous indiquant que sa ligne ne devait pas ".
				"tre supprime. On ne traite pas en automatique, il faut reprendre en ".
				"manuel pour relancer la commande");
			return undef;
		} else {
			# si l'evennement est une erreur de Neuf
			# - envoyer un mail au bureau+adherent pour signaler la fin de l'incident.
			my $tel = $props->{'telephone'};
			__envoie_mail($cmail,'fin-perte-ligne',$tel,$props);
			new_info_ligne($lid,'inline','Fin d incident',
				"La notification transmise par NeufCegetel est une erreur. La ligne continue de marcher. ".
				"Tout va bien. Incident termin.");
			return '';
		}
	} elsif ( $event eq 'end' ) {
		return '';
	} else {
		x_info "La tache notif_perte_ligne a reu cet vennement curieux: '$event'. On continue comme si de rien n'tait.";
		return '';
	}
}


sub __envoie_mail($$$$) {
	my ( $email, $type, $tel, $vars ) = @_;
	my $dir   = Config_Key ('adsl/global.cfg','dirs','mailtpl');
	my $tpl   = Config_Key ('adsl/subs/mail.cfg','mail-'.$type,'template');
	my $sujet = Config_Key ('adsl/subs/mail.cfg','mail-'.$type,'subject');
	if ( ! defined $vars->{'tel'} ) {
		$vars->{'tel'} = $tel;
	}
	my $texte = remplace($dir.'/'.$tpl,$vars,1);
	
	my $forceto = Config_Key ('adsl/global.cfg','mail','forceto');
	if ( $email && $forceto ) {
		$sujet .= " [was for $email]";
		$email = $forceto;
	}
	
	my $from = Config_Key('adsl/global.cfg','mail','from');
	my $to;
	my $bcc;
	if ( defined $email ) {
		$to = $email;
		$bcc = Config_Key('adsl/global.cfg','mail','bcc');
	} else {
		$to = Config_Key('adsl/global.cfg','mail','fdn');
	}
	$sujet = "FDN: $tel: ".$sujet;
	my $ret;
	my $testing = Config_Key('adsl/global.cfg','mail','testing');
	my $message = [
			'To' => $to,
			'From' => $from,
			'Message' => $texte,
			'Subject' => $sujet,
			'Bcc' => $bcc,
			'X-Fdn-Tel' => $tel
			];
	if ( ! $testing ) {
		$ret = sendmail ( @$message );
	} else {
		$ret = 1;
		push @mails, { @$message };
	}
	if ( !$ret ) {
		x_error "Echec d'envoi d'un mail.";
		x_error $Mail::Sendmail::error;
		x_error $Mail::Sendmail::log;
		x_error "To: $to";
		x_error "From: $from";
		x_error "Subject: $sujet";
		x_error "Bcc: $bcc";
		x_error "X-Fdn-Tel: $tel";
		x_error "MSG\n$texte\nMSG";
	} else {
		x_info "Mail type $type envoye a $to";
	}
}

sub __add_champ_len($$);
sub __ligne_ordre_td(%) {
	my %valeurs = @_;
	my $ligne;
	if ( defined $valeurs{'ordre'} ) {
		$ligne = $valeurs{'ordre'}.';';					# Champ  1
	} else {
		return undef;
	}
	$ligne .= __add_champ_len( 11,$valeurs{'offre'});			# Champ  2
	$ligne .= __add_champ_len( 15,$valeurs{'id-fdn'});			# Champ  3
	$ligne .= __add_champ_len(  8,$valeurs{'mandat'});			# Champ  4
	$ligne .= __add_champ_len( 60,$valeurs{'nom'});				# Champ  5
	$ligne .= __add_champ_len( 60,$valeurs{'prenom'});			# Champ  6
	$ligne .= __add_champ_len(128,$valeurs{'adresse'});			# Champ  7
	$ligne .= __add_champ_len(  5,$valeurs{'cp'});				# Champ  8
	$ligne .= __add_champ_len( 64,$valeurs{'ville'});			# Champ  9
	$ligne .= __add_champ_len(  2,$valeurs{'type-ligne'});			# Champ 10
	$ligne .= __add_champ_len(  1,$valeurs{'statut-ligne'});		# Champ 11
	$ligne .= __add_champ_len( 10,$valeurs{'nd'});				# Champ 12
	$ligne .= __add_champ_len(128,$valeurs{'adresse-construction'});	# Champ 13
	$ligne .= __add_champ_len( 15,$valeurs{'cpladr-construction'});		# Champ 14
	$ligne .= __add_champ_len(  5,$valeurs{'cp-construction'});		# Champ 15
	$ligne .= __add_champ_len( 64,$valeurs{'ville-construction'});		# Champ 16
	$ligne .= __add_champ_len( 64,$valeurs{'nom-construction'});		# Champ 17
	$ligne .= __add_champ_len( 10,$valeurs{'tel-construction'});		# Champ 18
	$ligne .= __add_champ_len( 10,$valeurs{'fax-construction'});		# Champ 19
	$ligne .= __add_champ_len( 10,$valeurs{'sav'});				# Champ 20
	$ligne .= __add_champ_len(  8,$valeurs{'contrat'});			# Champ 21
	$ligne .= __add_champ_len( 80,$valeurs{'adr-livraison'});		# Champ 22
	$ligne .= __add_champ_len(  2,$valeurs{'vpi-livraison'});		# Champ 23
	$ligne .= __add_champ_len(  5,$valeurs{'vci-livraison'});		# Champ 24
	$ligne .= __add_champ_len(  1,$valeurs{'desserte-interne'});		# Champ 25
	$ligne .= __add_champ_len( 10,$valeurs{'lg-desserte'});			# Champ 26
	$ligne .= __add_champ_len(  8,$valeurs{'dispo-locaux'});		# Champ 27
	$ligne .= __add_champ_len(  8,$valeurs{'dispo-construction'});		# Champ 28
	$ligne .= __add_champ_len( 16,$valeurs{'id-osm'});			# Champ 29
	$ligne .= __add_champ_len(  3,$valeurs{'interface-xdsl'});		# Champ 30
	$ligne .= __add_champ_len(  8,$valeurs{'ancien-operateur'});		# Champ 31
	$ligne .= __clean_champ($valeurs{'commentaire'});			# Champ 32
	return $ligne;
}

sub __ligne_ordre_nerim(%) {
	my %valeurs = @_;
	my $ligne;
	$ligne .= __clean_champ($valeurs{'login-nerim'}).';';
	$ligne .= __clean_champ($valeurs{'titulaire'}).';';
	$ligne .= __clean_champ($valeurs{'adresse'}).';';
	$ligne .= __clean_champ($valeurs{'complement'}).';';
	$ligne .= __clean_champ($valeurs{'ville'}).';';
	$ligne .= __clean_champ($valeurs{'cp'}).';';
	$ligne .= __clean_champ($valeurs{'nd'}).';';
	$ligne .= __clean_champ($valeurs{'offre'});
	return $ligne;
}

sub __ligne_ordre_9t(%) {
	my %valeurs = @_;
	my $ligne;
	my $dir;
	$dir = Config_Key('adsl/global.cfg','dirs','soaptpl');
	$ligne = remplace("$dir/cmd_9t.xml", \%valeurs, undef );
	if ( ! defined $ligne ) {
		error "Echec de cration commande: ".
			$FDN::Web::TemplateParse::TP_ERREUR->{'desc'};
	}
	return $ligne;
}

sub __clean_champ($) {
	my ( $champ ) = @_;
	$champ = '' if ( !defined $champ );
	$champ =~ s/\s{1,}/ /g;
	$champ =~ s/;/-/g;
	return $champ;
}

sub __add_champ_len($$) {
	my ( $longueur, $champ ) = @_;
	$champ = __clean_champ($champ);
	$champ =~ s/^(.{,$longueur-1})/$1/;
	return $champ.';' ;
}

sub __prt_eur($) {
	my ( $px ) = @_;
	$px =~ s/(\d{2})$/,$1 EUR/;
	return $px;
}

sub x_error($) {
	print STDERR "ERR: ".$_[0]."\n";
	error $_[0];
}

sub x_info($) {
	print STDERR "INF: ".$_[0]."\n";
	info $_[0];
}

sub clean_old_events($) {
	my ( $key ) = @_;
	$key =~ /^([A-Z]+)\/([0-9]+)$/;
	my ( $type, $tel ) = ( $1, $2 );
	if ( $type eq 'TD' ) {
		1;
	} elsif ( $type eq 'AR' ) {
		del_event_par_event('ARTD-'.$tel);
	} elsif ( $type eq 'CR' ) {
		del_event_par_event('CRTD-'.$tel);
	}
}







1;
