#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Web::TemplateParse;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Adsl::Factu;

my $cgi = new CGI;
my $vars = $cgi->Vars;


my $form = form_read('adsl/form/factu.cfg','cmois');
if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

# Cloture effective du mois
my $annee = $vars->{annee};
$annee =~ s/^annee//;
my $mois = $vars->{mois};
$mois  =~ s/^mois//;

my $clid = cloture_mois($annee,$mois);
my $page = {};
if ( $clid ) {
	my @crs = creance_par_cloture_id($clid);
	$page = tableau_2d_pognon('adsl/rewrite.tbl','creance','CREANCE',\@crs);
} else {
	$page->{'ERROR'} = "chec de la cloture. Il faut plucher les logs.";
	my $dir = Config_Key('adsl/global.cfg','dirs','htmltpl');
	$page = remplace($dir.'/page-err.tpl',$page,1);
}
eject_page($page);

