#!/usr/bin/perl

use strict;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

my $page;

my @cls = tous_clients_facture();
if ( $#cls == -1 ) {
	eject_page_error("Aucun client ne paye par facture");
	exit(0);
}

my $nbcl = 0;
my $nbcr = 0;
my @rcls;
for my $cl ( @cls ) {
	my $cid = $cl->{'CLIENT_ID'};
	my @crs = creance_par_client_id_etat($cid,'due');
	if ( $#crs == -1 ) {
		$cl->{'nbcr'} = 0;
	} else {
		$cl->{'nbcr'} = @crs;
		$nbcr += @crs;
		$nbcl ++;
		push @rcls, $cl;
	}
}

if ( $nbcl eq 0 ) {
	eject_page_error("Aucun client facturable n'a de dette");
	exit(0);
}

$page = tableau_2d('adsl/rewrite.tbl','creafac',\@rcls,
	"Clients facturables ayant des dettes");
eject_page($page);
exit(0);


