#!/usr/bin/perl

use strict;
use FDN::Common::Config;
use FDN::Adsl::Map;
use FDN::Adsl::Utils;

my $mapdir = Config_Key('adsl/global.cfg','dirs','mapdir');
my $link = Config_Key('adsl/global.cfg','web','link_maps');
my $page = "<p>Reconstruction des cartes</p>\n";

my $large = 500;
my $small = 100;

sub do_map($$$$) {
	my ( $descr, $file, $fct, $map ) = @_;

	eval( "$fct('$mapdir/$file', $large);" );
	eval( "$fct('$mapdir/tn-$file', $small);" );
	$page .= "<p>$descr: <a href=\"$link?map=$map\">grand</a> ".
	                    "<a href=\"$link?map=tn-$map\">petit</a></p>\n";
}

my $maps = Config_Key('adsl/maps.cfg','global','@map');
for my $m ( @$maps ) {
	my $cfg = Config_Section('adsl/maps.cfg','map-'.$m);
	my $descr = $cfg->{'descr'};
	my $file  = $cfg->{'file'};
	my $fct   = $cfg->{'fct'};
	do_map($descr,$file,$fct,$m);
}

eject_page($page);
