#!/usr/bin/perl

use strict;
use CGI;
use FDN::Web::Forms qw(:dynamics);
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Sql::Workflow::Basic;
use FDN::Sql::Workflow::Run;

workflow_select_db('adsl');
workflow_select_config('adsl/wf.cfg');

my $cgi = new CGI;
my $vars = $cgi->Vars;


if ( !defined $vars->{'taskid' } ) {
	eject_page_index();
	exit(0);
}
my $form = form_read('adsl/form/task.cfg','mproptask');
my $tid = $vars->{taskid};
my $task = task_par_id($tid);
my $props = get_task_properties($tid);
ajoute_proptask($form,$task,$props);
form_keep_val($form,$vars);

if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $newprops = $props;
for my $p ( keys %$props ) {
	if ( ref($props->{$p}) eq '' ) {
		$newprops->{$p} = $vars->{'prop'.$p};
	}
}
if ( defined $vars->{nprop} & $vars->{nprop} ne '' ) {
	$newprops->{$vars->{nprop}} = $vars->{nval};
	$form = form_read('adsl/form/task.cfg','mproptask');
	ajoute_proptask($form,$task,$newprops);
}
update_task_properties($tid,$newprops);
eject_page(affiche_form($form,$vars));

sub ajoute_proptask($$$) {
	my ( $form, $task, $props ) = @_;
	my $tinfo = get_task_infos($task->{'TASK_NAME'});
	my $cfg = {};
	my $block = $form->{blocksbyname}->{proptask};
	if ( !defined($block) ) {
		die "Block n'existe pas dans le formulaire!\n";
	}
	for my $p ( keys %$props ) {
		if ( ref($props->{$p}) ne '' ) {
			next;
		}
		my $c = {};
		my $name = 'prop'.$p;
		$c->{name} = $name;
		$c->{value} = $props->{$p};
		$c->{keep} = 'true';
		$c->{label} = $p;
		$c->{type} = 'text';
		if ( defined $tinfo->{'byname'}->{$p} ) {
			if ($tinfo->{'byname'}->{$p}->{'opt'} eq 'mandatory' ) {
				$c->{mandatory} = 'true';
				$c->{label} .= '*';
			}
			$c->{regexp} = '/'.$tinfo->{'byname'}->{$p}->{'syn'}.'/';
		}
		$cfg->{'field-'.$name} = $c;
		my $field = form_new_field($cfg,$name);
		form_add_field($block,$field);
	}
}



