#!/usr/bin/perl

use strict;
use CGI;
use POSIX qw(strftime);
use Mail::Sendmail;
use FDN::Sql::Basic;
use FDN::Common::Config;
use FDN::Adsl::DBC;
use FDN::Adsl::Basic;
use FDN::Adsl::Utils;
use FDN::Adsl::New;

my $cgi = new CGI;
my $vars = $cgi->Vars;

my $cid = $vars->{'cid'};
if ( ! defined $cid ) {
	$cid = $vars->{'client'};
}
my $form = form_nadh($vars);

if ( $vars->{'do'} ne 'yes' ) {
	$vars->{'client'} = $cid;
	$vars->{'prix'} = 81;
	$vars->{'libelle'} = 'Adhesion FDN';
	$vars->{'type'} = 'annuel';
	$vars->{'date'} = '';
	$vars->{'debut'} = strftime "%Y-%m-%d", localtime;;
	$vars->{'fin'} = '2035-12-31 00:00:00';
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

# Donner un numro d'adhrent
goto END if ( ! defined $cid );
my $client = client_par_id($cid);
goto END if ( ! defined $client );
goto END if ( $client->{'CLIENT_NUMADH'} != -1 );
my $num = get_next($dbh,'adh');
goto END if ( ! defined $num );
goto END if ( $num <= 0 );
goto END if ( $num !~ /^\d+$/ );
set_client_numadh($cid,$num);

# Ajouter un payant
modifie_payant($vars,undef);
my $from = $vars->{'from'};
back_from("adresse",$from);

# Inscrire  la liste ag@
my $sympa = Config_Key('adsl/global.cfg','mail','sympa');
my $bcc = Config_Key('adsl/global.cfg','mail','bcc');
my $aid = $client->{'ADRESSE_ID'};
goto END if ( ! defined $aid );
my $adr = adresse_par_id($aid);
goto END if ( ! defined $adr );
goto END if ( ! $adr->{'ADRESSE_MAIL'} );
my $mail = $adr->{'ADRESSE_MAIL'};
my $msg = [
	'From' => 'listmaster@fdn.fr',
	'To' => $sympa,
	'Subject' => 'ADD ag@fdn.fr '.$mail.' '.$client->{'CLIENT_NOM'},
	'Message' => 'quit',
	'Bcc' => $bcc,
];
sendmail(@$msg);

END:
my $from = $vars->{'from'};
back_from('nadh',$from);

