#!/usr/bin/perl

use strict;
use CGI;
use FDN::Web::Forms;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Adsl::Factu;

my $cgi = new CGI;
my $vars = $cgi->Vars;


my $form = form_read('adsl/form/factu.cfg','nprlbq');
if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $annee = $vars->{annee};
$annee =~ s/^annee//;
$annee =~ s/^...//;
my $mois = $vars->{mois};
$mois =~ s/^mois//;
my $jour = $vars->{jour};

if ( $jour > $jours[$mois-1] ) {
	$errors = { 'syntax' => [ { err => "Il n'y a pas tant de jours ce mois-la, je n'en compte que ".$jours[$mois-1] } ] };
	eject_page(affiche_form($form,$vars));
	exit(0);
}

$jour =~ s/^(\d)$/0$1/;

# Creation effective du prelevement
creation_prelevement(
	$vars->{nom},
	'prl-'.$jour.$mois.$annee.'.txt',
	$jour.$mois.$annee);

eject_page_index();
