#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Adsl::Infos;
use FDN::Sql::Workflow::Run;

my $cgi = new CGI;
my $vars = $cgi->Vars;

if ( ! defined $vars->{'ligneid'} ) {
	my @lignes = ligne_par_state('new');
	my $page = tableau_2d('adsl/rewrite.tbl','ligne-fas',\@lignes);
	eject_page($page);
	exit(0);
}

my $lid = $vars->{'ligneid'};
if ( $vars->{'do'} ne 'yes' ) {
	my $ligne = ligne_par_id($lid);
	my $cid = $ligne->{'CLIENT_ID'};
	my $client = client_par_id($cid);
	my $page;
	my @infos;

	$page  = tableau_1d('adsl/rewrite.tbl','ligne',$ligne,"Description de la ligne");
	$page .= tableau_1d('adsl/rewrite.tbl','client',$client,"Description du client");

	@infos = toutes_infos_ligne($lid);
	$page .= tableau_2d('adsl/rewrite.tbl','infos',\@infos,"Informations sur la ligne");

	@infos = toutes_infos_client($cid);
	$page .= tableau_2d('adsl/rewrite.tbl','infos',\@infos,"Informations sur le client");

	$page .= "<p>Il faut vrifier la prsence de tous ces lments:<br>\n".
		 "<b>Nouvel adhrent:</b></p>\n".
		 "<ul>\n".
		 "<li>l'image du bulletin d'adhsion;</li>\n".
		 "<li>l'image de l'autorisation de prlvement;</li>\n".
		 "<li>la saisie du RIB pour le prlvement (l'item &nbsp;Paiment&nbsp;\n".
		 "    dans la description du client ne doit pas mentionner de Facture, mais\n".
		 "    l'identifiant du RIB);</li>\n".
		 "<li>l'image de la pice d'identit de l'adhrent;</li>\n".
		 "<li>l'image du justificatif (carte d'tudiant, etc) si l'adhrent\n".
		 "    demande le tarif prfrentiel.\n".
		 "</ul>\n".
		 "<p><b>Nouvelle ligne ADSL:</b></p>\n".
		 "<ul>\n".
		 "<li>l'image du bulletin d'abonnement pour la ligne (deux pages, donc\n".
		 "    deux images)</li>\n".
		 "<li>l'image de la facture France Tlcom</li>\n".
		 "<li>l'image du mandat de dgroupage, si le dbit souscrit est en\n".
		 "    dgroup</li>\n".
		 "</ul>\n".
		 "<p>Si un des lments manque, il faut retourner le scanner, ou attendre\n".
		 "de le recevoir selon le cas. <b>Ne pas valider de ligne s'il manque des\n".
		 "documents!</b></p>";
	
	$page .= '<p><a href="paye-fas.cgi?ligneid='.$lid.'&do=yes">Valider</a></p>';
	eject_page($page);
	exit(0);
}

my $ligne = ligne_par_id($lid);
my $tel = $ligne->{'LIGNE_TEL'};
my $event = 'FAS-'.$tel;
# Mise en facturation sera faite en fin de construction.
#set_ligne_dtfac($lid);
workflow_select_db('adsl');
send_event($event);
#TODO Creer une creance negative correspondant au paiement.
my $index = Config_Key('adsl/global.cfg','web','index');
print "Location: $index\n\n";

