#!/usr/bin/perl

use CGI;
use FDN::Common::Modules;
use FDN::Web::Forms;
use FDN::Adsl::Basic;
use FDN::Adsl::Utils;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','padresse');
if ( ! defined $form ) {
	die "Undefined form";
}
if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $aid = $vars->{'aid'};
my $type = $vars->{'type'};
my $adresse = adresse_par_id($aid);

if ( ! defined $type ) {
	$type = 'tiers';
}

my $tpls = {
	'a4scape' => 'enveloppe4',
	'a4' => 'enveloppe3',
	'demi' => 'enveloppe2',
	'tiers' => 'enveloppe'
};

my $template = $tpls->{$type};

if ( ! defined $template ) {
	$template = $tpls->{'tiers'};
}

conduse('FDN::TeX::TeX');
if ( ! set_tex_config('adsl/tex-tmp.cfg') ) {
	die "Horribly";
}

my $hash = {
	'NOM' => '',
	'ADRESSE' => '',
	'CP' => '',
	'VILLE' => ''
};

if ( defined $adresse ) {
	$hash->{'NOM'}     = $adresse->{'ADRESSE_NOM'};
	$hash->{'ADRESSE'} = $adresse->{'ADRESSE_ADR'};
	$hash->{'CP'}      = $adresse->{'ADRESSE_CP'};
	$hash->{'VILLE'}   = $adresse->{'ADRESSE_VILLE'};
}

my $env = make_pdf_file($template,'enveloppe',$hash);

if ( -f $env ) {
	send_pdf_file($env,'enveloppe.pdf');
} else {
	eject_page_error("Pas russi  produire le fichier PDF qui va bien.");
}
