#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Common::Modules;
use FDN::Web::TemplateParse;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Adsl::Factu;

my $cgi = new CGI;
my $vars = $cgi->Vars;


my $form = form_read('adsl/form/factu.cfg','pfactu');
# Ajoute toutes les factures, dans l'ordre (due, envoyee, payee)
ajoute_liste_factures($form);
if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

# Affichage de la facture
my $hash = {};

my $fid = $vars->{factu};
$fid =~ s/^factu//;
my $facture = facture_par_id($fid);

my $cid = $facture->{'CLIENT_ID'};
my $client = client_par_id($cid);

my $aid = $client->{'ADRESSE_ID'};
my $adresse = adresse_par_id($aid);

my @crs = creance_par_facture_id($fid);
$hash->{fid}    = $fid;
$hash->{cid}    = $cid;
$hash->{numero} = $facture->{'FACTURE_NUM'};
$hash->{date}   = $facture->{'FACTURE_DATE'};
$hash->{client} = $client->{'CLIENT_NOM'}."\n";
$hash->{adresse}= $adresse->{'ADRESSE_NOM'}."\n";
$hash->{adresse}.= $adresse->{'ADRESSE_ADR'}."\n";
$hash->{adresse}.= $adresse->{'ADRESSE_CP'}." ".$adresse->{'ADRESSE_VILLE'}."\n";

if ( $vars->{format} eq 'html' ) {
	$hash->{tableau} = tableau_2d_pognon('adsl/rewrite.tbl','facture-html','CREANCE',\@crs);
	my $dir = Config_Key('adsl/global.cfg','dirs','htmltpl');
	my $page = remplace($dir.'/facture.tpl',$hash,1);
	eject_page($page);
}
if ( $vars->{format} eq 'text' ) {
	$hash->{tableau} = tableau_2d_pognon_text('adsl/rewrite.tbl','facture-text','CREANCE',\@crs);
	my $dir = Config_Key('adsl/global.cfg','dirs','texttpl');
	my $page = remplace($dir.'/facture.tpl',$hash,1);
	eject_page_text($page);
}
if ( $vars->{format} eq 'pdf' ) {
	my $dir = Config_Key('adsl/global.cfg','dirs','stockpdf');
	my $file = $dir.'/factures/fact-'.$facture->{'FACTURE_NUM'}.'.pdf';
	if ( ! -f $file ) {
		conduse('FDN::TeX::TeX');
		set_tex_config('adsl/tex.cfg');
		$FDN::TeX::TeX::debug=1;
		$hash->{tableau} = tableau_2d_pognon_tex('adsl/rewrite.tbl','facture-tex','CREANCE',\@crs);
		my $res = make_pdf_file('facture','.',$hash);
		system("cp $res $file");
	}
	send_pdf_file($file);
}


