#!/usr/bin/perl

use strict;
use FDN::Adsl::Utils;
use FDN::Common::Config;
use FDN::TeX::TeX;
use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $name = $vars->{'name'};
my $file;

set_tex_config('adsl/tex-tmp.cfg');

if ( $name =~ /^test/ ) {
	$file = "/test/$name.jpg";
} elsif ( $name =~ /^tn-/ ) {
	$file = "/thumbnails/$name.jpg";
} else {
	$file = "/jpeg/$name.jpg";
}

my $dir = Config_Key('adsl/global.cfg','dirs','imgdir');
if ( ! -f $dir.$file ) {
	eject_page_error("Le fichier image $dir$file n'existe pas.");
} else {
	my $hash = {
		'pages' => [ { 'page' => $dir.$file } ]
	};
	my $pdf = make_pdf_file('images','images',$hash);
	send_pdf_file($pdf,'docs.pdf');
}

