#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Common::Modules;
use FDN::Common::Logger;
use FDN::Web::TemplateParse;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Adsl::Factu;

my $cgi = new CGI;
my $vars = $cgi->Vars;


my $form = form_read('adsl/form/factu.cfg','pprlbq');
# Ajoute la liste des prelevements dans l'ordre (dus, envoyes, payes)
ajoute_liste_prelevements($form);
if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

# Affichage du prelevement
my $hash = {};

my $pid = $vars->{prlbq};
$pid =~ s/^prlbq//;
my $prlbq = prlbq_par_id($pid);

my @pls = prllig_par_prlbq_id($pid);
my $total = 0;
for my $p ( @pls ) {
	$total += $p->{'PRLLIG_MONTANT'};
}
$hash->{nom} = $prlbq->{'PRLBQ_NOM'};
$hash->{date} = $prlbq->{'PRLBQ_DATE'};
$hash->{nblig} = scalar @pls;
$hash->{total} = prt_euro($total);

if ( $vars->{format} eq 'html' ) {
	$hash->{tableau} = tableau_2d('adsl/rewrite.tbl','prelevement-html',\@pls);
	my $dir = Config_Key('adsl/global.cfg','dirs','htmltpl');
	my $page = remplace($dir.'/prelevement.tpl',$hash,1);
	eject_page($page);
}
if ( $vars->{format} eq 'text' ) {
	$hash->{tableau} = tableau_2d_text('adsl/rewrite.tbl','prelevement-text',\@pls);
	my $dir = Config_Key('adsl/global.cfg','dirs','texttpl');
	my $page = remplace($dir.'/prelevement.tpl',$hash,1);
	eject_page_text($page);
}
if ( $vars->{format} eq 'pdf' ) {
	my $dir = Config_Key('adsl/global.cfg','dirs','stockpdf');
	my $file = $dir.'/prlbq/prlbq-'.$prlbq->{'PRLBQ_DATE'}.'-'.$prlbq->{PRLBQ_ID}.'.pdf';
	if ( ! -f $file ) {
		debug "File $file not found, creating it.";
		conduse('FDN::TeX::TeX');
		debug "Loading config";
		set_tex_config('adsl/tex.cfg');
		debug "Config loaded";
		$hash->{tableau} = tableau_2d_tex('adsl/rewrite.tbl','prelevement-tex',\@pls);
		my $res = make_pdf_file('prlbq','.',$hash);
		system("cp $res $file");
	}
	if ( ! -f $file ) {
		eject_page_error("Failed to create pdf page.");
		exit(0);
	}
	send_pdf_file($file);
}


