#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Common::Modules;
use FDN::Common::Logger;
use FDN::Web::TemplateParse;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::TeX::TeX;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Adsl::Factu;

set_tex_config('adsl/tex.cfg');
my $cgi = new CGI;
my $vars = $cgi->Vars;


my $form = form_read('adsl/form/factu.cfg','pprllig');
# Ajoute la liste des prelevements dans l'ordre (dus, envoyes, payes)
ajoute_liste_prelevements($form);
if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

# Affichage du prelevement
my $hash = {};

my $pid = $vars->{prlbq};
$pid =~ s/^prlbq//;
my $prlbq = prlbq_par_id($pid);

my @pls = prllig_par_prlbq_id($pid);
my $page;
for my $p ( @pls ) {
	my $plid = $p->{'PRLLIG_ID'};
	my $cid  = $p->{'CLIENT_ID'};
	my $dir = Config_Key('adsl/global.cfg','dirs','stockpdf');
	my $file = $dir.'/prllig/'.$cid.'/prl-'.$prlbq->{'PRLBQ_DATE'}.'-'.$plid.'.pdf';
	if ( ! -f $file ) {
		my @crs = creance_par_prllig_id($plid);
		my $date = '9999-99-99 99:99:99';
		for my $c ( @crs ) {
			if ( $c->{'CREANCE_DATEDUE'} lt $date ) {
				$date = $c->{'CREANCE_DATEDUE'};
			}
		}
		$hash->{tableau} = tableau_2d_pognon_tex('adsl/rewrite.tbl','facture-tex','CREANCE',\@crs);
		$hash->{pid} = $plid;
		my $tmp = $date;
		$tmp =~ s/^(\d\d\d\d)-(\d\d)-(\d\d) .*$/$1$2$3/;
		$hash->{numero} = $tmp.'-'.$cid.'-'.$pid.'-'.$plid;
		my $cl = client_par_id($cid);
		my $adr = adresse_par_id($cl->{'ADRESSE_ID'});
		$tmp = 	$cl->{'CLIENT_NOM'}."\n".
			$adr->{'ADRESSE_NOM'}."\n".
			$adr->{'ADRESSE_ADR'}."\n".
			$adr->{'ADRESSE_CP'}." ".$adr->{'ADRESSE_VILLE'};
		$hash->{adresse} = $tmp;
		$hash->{dateprl} = $prlbq->{'PRLBQ_DATE'};
		$hash->{date} = $date;
		$hash->{banque} = $p->{'PRLLIG_BANQUE'};
		$hash->{guichet} = $p->{'PRLLIG_GUICHET'};
		$hash->{compte} = $p->{'PRLLIG_COMPTE'};
		my $res = make_pdf_file('prllig',$cid,$hash);
		system("cp $res $file");
	}
	if ( -f $file ) {
		$page .= "<p>Fichier <a href=\"print-prllig2.cgi?pid=$plid>$file</a>.</p>";
	} else {
		$page .= "<div class=\"error\">Fichier $file en echec.</p>";
	}
}
eject_page($page);



