#!/usr/bin/perl

use strict;
use CGI;
use FDN::Web::Forms;
use FDN::Sql::Workflow::Basic;
use FDN::Sql::Workflow::Run;
use FDN::Adsl::Utils;
use FDN::Adsl::Wf;

my $cgi = new CGI;
my $vars = $cgi->Vars;


my $form = form_read('adsl/form/task.cfg','purge');
if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

workflow_select_db('adsl');
workflow_select_config('adsl/wf.cfg');

my $tid  = $vars->{taskid};
my $task = task_par_id($tid);
if ( defined $task ) {
	purge_task($tid);
	clean_old_events($task->{'TASK_KEY'});
}
eject_page_index();
