#!/usr/bin/perl

use strict;
use CGI;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

my $cgi = new CGI;
my $vars = $cgi->Vars;


my $form = form_read('adsl/subs/resil.cfg','rligne');
if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $tel = $vars->{tel};
my $lid = $vars->{lid};

if ( ! $tel && ! $lid ) {
	add_form_error('syntax','Il faut quand meme remplir un des deux champs');
}

my $ligne;
if ( $lid ) {
	$ligne = ligne_par_id($lid);
	$tel = $ligne->{'LIGNE_TEL'};
} else {
	$ligne = ligne_par_tel($tel);
	$lid = $ligne->{'LIGNE_ID'};
}

my $cid = $ligne->{'CLIENT_ID'};
my $client = client_par_id($cid);

my $page;
$page .= "<p>Ligne retenue: id=$lid, tel=$tel</p>";
$page .= tableau_1d('adsl/rewrite.tbl','ligne',$ligne,"Description de la ligne");
$page .= tableau_1d('adsl/rewrite.tbl','client',$client,"Description de l'abonn");
$page .= "<div class=\"error\"><p>On rsilie pour de vrai dfinitivement cette ligne?</p></div>";
$form = form_read('adsl/subs/resil.cfg','rligne2');
$page .= affiche_form($form,$vars);
eject_page($page);
