#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Adsl::Infos;
use FDN::Sql::Workflow::Run;

my $cgi = new CGI;
my $vars = $cgi->Vars;


if ( ! defined $vars->{'vid'} ) {
	my @vals = validation_par_type_etat('notif-perte','new');
	my $page = tableau_2d('adsl/rewrite.tbl','liste-perte',\@vals);
	eject_page($page);
	exit(0);
}

my $vid = $vars->{'vid'};
my $val = validation_par_id($vid);
my $lid = $val->{'LIGNE_ID'};
my $cid = $val->{'CLIENT_ID'};

my $props = {};
if ( defined $vars->{'type'} ) {
	if ( $vars->{'type'} =~ /^(normale|anormale|erreur)$/ ) {
		$props->{type} = $vars->{type};
	}
}


if ( $vars->{'do'} ne 'yes' || ! defined $props->{type} ) {
	my $ligne = ligne_par_id($lid);
	my $client = client_par_id($cid);
	my $page;
	my @infos;

	$page  = tableau_1d('adsl/rewrite.tbl','ligne',$ligne,"Description de la ligne");
	$page .= tableau_1d('adsl/rewrite.tbl','client',$client,"Description du client");

	@infos = toutes_infos_ligne($lid);
	$page .= tableau_2d('adsl/rewrite.tbl','infos',\@infos,"Informations sur la ligne");

	@infos = toutes_infos_client($cid);
	$page .= tableau_2d('adsl/rewrite.tbl','infos',\@infos,"Informations sur le client");

	$page .= '<p><a href="valide-perte.cgi?vid='.$vid.'&do=yes&type=normale">Valider, perte normale (rsil, dmnagement, etc).</a></p>';
	$page .= '<p><a href="valide-perte.cgi?vid='.$vid.'&do=yes&type=anormale">Valider, perte anormale (erreur d\'un autre oprateur, slaming).</a></p>';
	$page .= '<p><a href="valide-perte.cgi?vid='.$vid.'&do=yes&type=erreur">Valider, erreur de Neuf (on n\'a pas perdu la ligne).</a></p>';
	eject_page($page);
	exit(0);
}

# Prendre l'vennement dans la $val
# L'envoyer avec le bon type.

my $event = $val->{'VALIDATION_EVENT'};
workflow_select_db('adsl');
send_event($event,$props);
new_info_ligne($lid,'inline','perte de ligne','Perte de ligne valide avec le type '.$props->{type});
set_validation_etat($vid,'done');
my $index = Config_Key('adsl/global.cfg','web','index');
print "Location: $index\n\n";

