#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vadhaccess');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $adhid = $vars->{'adhid'};
my $login = $vars->{'login'};

if ( ! $adhid && ! $login ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
	eject_page(affiche_form($form,$vars));
	exit(0);		
}

my $adh;
if ( $adhid ) {
	$adh = adhaccess_par_id($adhid);
} else {
	$adh = adhaccess_par_login($login);
}

if ( ! defined $adh ) {
	eject_page_error("Cet accs n'existe pas.");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','adhaccess',$adh,
	"Une accs web ".
	forward_to('adhaccess',$adhid,"adh$adhid"));

eject_page($page);

