#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vadresse');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $aid = $vars->{'aid'};
my $adresse = adresse_par_id($aid);

if ( ! defined $adresse ) {
	eject_page_error("Cette adresse n'existe pas.");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','adresse',$adresse,
	"Une adresse ".
	forward_to('adresse',$aid,"adresse$aid")."<br>".
	forward_to('padresse-tiers',"$aid&do=yes","adresse$aid")." ".
	forward_to('padresse-tiers0',"0&do=yes","adresse$aid")."<br>".
	forward_to('padresse-demi',"$aid&do=yes","adresse$aid")." ".
	forward_to('padresse-demi0',"0&do=yes","adresse$aid")."<br>".
	forward_to('padresse-a4',"$aid&do=yes","adresse$aid")." ".
	forward_to('padresse-a40',"0&do=yes","adresse$aid")."<br>".
	forward_to('padresse-a4scape',"$aid&do=yes","adresse$aid")." ".
	forward_to('padresse-a4scape0',"0&do=yes","adresse$aid")
	);

eject_page($page);

