#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vclient');

if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $cid = $vars->{'cid'};
my $tel = $vars->{'tel'};

if ( ! $cid && ! $tel ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $client;
if ( $cid ) {
	$client = client_par_id($cid);
} else {
	my $ligne = ligne_par_tel($tel);
	if ( defined $ligne ) {
		$cid = $ligne->{'CLIENT_ID'};
		$client = client_par_id($cid);
	}
}

if ( ! defined $client ) {
	eject_page_error("Ce client n'existe pas");
	exit(0);
}

$page .= tableau_1d('adsl/rewrite.tbl','client-detail',$client,
	'Description de l\'abonn - partie compta<br>'.
	forward_to('client-normal',$cid,'').' '.
	forward_to('client-compta',$cid,'').' '.
	forward_to('client-technique',$cid,'').'<br>'.
	forward_to('client',$cid,"client-compta$cid")
	);

my $pid;
$pid = $client->{'PRELEVEMT_ID'};
if ( $pid > 0 ) {
	my $prelevemt;
	$prelevemt = prelevemt_par_id($pid);
	$page .= tableau_1d('adsl/rewrite.tbl','prelevemt',$prelevemt,
		'Coordonnes bancaires de l\'abonn '.
		forward_to('prelevemt',$pid,"client-compta$cid"));
} else {
	$page .= '<div class="error"><p>Paiement par facture</p></div>';
}

my @payants = payant_par_client_id($cid);
$page .= tableau_2d('adsl/rewrite.tbl','payant',\@payants,
	'Items payants de l\'abonn '.
	forward_to('npayant',"$cid","client-compta$cid"));

my @creances = creance_par_client_id($cid);
$page .= tableau_2d('adsl/rewrite.tbl','creance',\@creances,
	'Crances de l\'abonn '.
	forward_to('ncreance',"$cid","client-compta$cid"));

my @prls = prllig_par_client_id($cid);
$page .= tableau_2d('adsl/rewrite.tbl','prllig',\@prls,
	'Lignes de prlvements de l\'abonn');

my @facs = facture_par_client_id($cid);
$page .= tableau_2d('adsl/rewrite.tbl','facture',\@facs,
	'Factures de l\'abonn');

my @pais = paiement_par_client_id($cid);
$page .= tableau_2d('adsl/rewrite.tbl','paiement',\@pais,
	'Paiements de l\'abonn '.
	forward_to('npaiement',"client$cid","client-compta$cid"));

eject_page($page);
