#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vclient');

if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $cid = $vars->{'cid'};
my $tel = $vars->{'tel'};

if ( ! $cid && ! $tel ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $client;
if ( $cid ) {
	$client = client_par_id($cid);
} else {
	my $ligne = ligne_par_tel($tel);
	if ( defined $ligne ) {
		$cid = $ligne->{'CLIENT_ID'};
		$client = client_par_id($cid);
	}
}

if ( ! defined $client ) {
	eject_page_error("Ce client n'existe pas");
	exit(0);
}

$page .= tableau_1d('adsl/rewrite.tbl','client-detail',$client,
	'Description de l\'abonn - partie technique<br>'.
	forward_to('client-normal',$cid,'').' '.
	forward_to('client-compta',$cid,"").' '.
	forward_to('client-technique',$cid,'').'<br>'.
	forward_to('client',$cid,"client-technique$cid")
	);

my @lignes = ligne_par_client_id($cid);
$page .= tableau_2d('adsl/rewrite.tbl','ligne',\@lignes,
	'Lignes de l\'abonn');

my @validations = validation_par_client_id($cid);
$page .= tableau_2d('adsl/rewrite.tbl','validation',\@validations,
	'Validations en attente');

my @users = unixuser_par_client_id($cid);
$page .= tableau_2d('adsl/rewrite.tbl','unixuser',\@users,
	'Utilisateurs unix '.
	forward_to('nunixuser',$cid,"client-technique$cid"));

my @sites = site_par_client_id($cid);
$page .= tableau_2d('adsl/rewrite.tbl','site',\@sites,
	"Sites de l'abonn ".
	forward_to('nsite',$cid,"client-technique$cid"));

my @doms = domaine_par_client_id($cid);
$page .= tableau_2d('adsl/rewrite.tbl','domaine',\@doms,
	 "Domaines de l'abonn ".
	 forward_to('ndomaine',$cid,"client-technique$cid"));

eject_page($page);
