#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Adsl::Infos;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vclient');

if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $cid = $vars->{'cid'};
my $tel = $vars->{'tel'};
my $num = $vars->{'numadh'};

if ( ! $cid && ! $tel && ! $num ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des trois champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $client;
if ( $cid ) {
	$client = client_par_id($cid);
} elsif ( $num ) {
	$client = client_par_numadh($num);
} else {
	my $ligne = ligne_par_tel($tel);
	if ( defined $ligne ) {
		$cid = $ligne->{'CLIENT_ID'};
		$client = client_par_id($cid);
	}
}

if ( ! defined $client ) {
	eject_page_error("Ce client n'existe pas");
	exit(0);
}
$cid = $client->{'CLIENT_ID'};
$num = $client->{'CLIENT_NUMADH'};

my $setadh = '';
if ( $client->{'CLIENT_NUMADH'} == -1 ) {
	$setadh = ' '.forward_to('numadh',$cid,"client$cid");
}

$page .= tableau_1d('adsl/rewrite.tbl','client-detail',$client,
	'Description de l\'abonn - partie gnrale<br>'.
	forward_to('client-normal',$cid,'').' '.
	forward_to('client-compta',$cid,"").' '.
	forward_to('client-technique',$cid,'').'<br>'.
	forward_to('client',$cid,"client$cid").
	$setadh
	);

my $aid;
$aid = $client->{'ADRESSE_ID'};
my $adresse;
$adresse = adresse_par_id($aid);
$page .= tableau_1d('adsl/rewrite.tbl','adresse',$adresse,
	'Adresse de l\'abonn '.
	forward_to('adresse',$aid.'&cid='.$cid,"client$cid"));

my $access;
$access = adhaccess_par_client_id($cid);
my $accid = $access->{'ADHACCESS_ID'};
$page .= tableau_1d('adsl/rewrite.tbl','adhaccess',$access,
	"Identifiant de connexion web de l'abonn ".
	forward_to('adhaccess',"$accid&client=$cid","client$cid"));

my @infos = toutes_infos_client($cid);
$page .= tableau_2d('adsl/rewrite.tbl','infos',\@infos,"Informations sur l'abonn".
	forward_to('nscan',"&client=$cid","client$cid"));

eject_page($page);
