#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vcloture');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $cid = $vars->{'cid'};
my $cloture = $vars->{'cloture'};

if ( !$cid and !$cloture ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $cl;
if ( $cid ) {
	$cl = cloture_par_id($cid);
} else {
	$cloture =~ /^(\d\d)\/(\d{4})/;
	my $dt = "$2$1";
	$cl = cloture_par_date($dt);
}

if (! defined $cl ) {
	eject_page_error("Cette cloture n'existe pas");
	exit(0);
}

$cid = $cl->{'CLOTURE_ID'};
$page = tableau_1d('adsl/rewrite.tbl','cloture',$cl,
	"Description de la cloture");

my @crs = creance_par_cloture_id($cid);
$page .= tableau_2d_pognon('adsl/rewrite.tbl','creance','CREANCE',\@crs,
	"Creances associees");

eject_page($page);

		
