#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Adsl::Infos;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vcompta');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $cid = $vars->{'cid'};
my $compta = compta_par_id($cid);

if ( ! defined $compta ) {
	eject_page_error("Ce groupe de documents n'existe pas");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','compta',$compta,
	"Un groupe de documents ".
	forward_to('compta',$cid,"compta$cid"));

my @infos = toutes_infos_compta($cid);
$page .= tableau_2d('adsl/rewrite.tbl','infos',\@infos,
        "Documents dans ce groupe ".
	"(<a href=\"new-scan.cgi?doctype=compta&compta=$cid\">Ajouter</a>)");
	

eject_page($page);

