#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vdeploiement');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $depl;
my $did;
my $num;
if ( defined $vars->{'did'} && $vars->{'did'} ) {
	$did  = $vars->{'did'};
	$depl = deploiement_par_id($did);
	$num = $depl->{'DEPLOIEMENT_NUM'};
} elsif ( defined $vars->{'deplnum'} && $vars->{'deplnum'} ) {
	$num = $vars->{'deplnum'};
	$depl = deploiement_par_num($num);
	$did = $depl->{'DEPLOIEMENT_ID'};
} else {
	add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

if ( ! defined $depl ) {
	eject_page_error("Ce dploiement n'existe pas");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','deploiement',$depl);

eject_page($page);

