#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Adsl::Basic;
use FDN::Adsl::Utils;

my $cgi = new CGI;
my $vars = $cgi->Vars;

my $dplnum = $vars->{dplnum};
my $doc = $vars->{doc};

if ( ! defined $dplnum ||
     ! defined $doc ) {
	# PANIC
	eject_page_error("Il manque le type de document et/ou le numro de dploiement. C'EST UN BUG.");
	exit(0);
}

my $dpl = deploiement_par_num($dplnum);
if ( ! defined $dpl ) {
	eject_page_error("Ce dploiement n'existe pas. C'EST UN BUG.");
	exit(0);
}

my $dir = Config_Key('adsl/global.cfg','dirs','stockpdf');
$dir .= '/'.$dplnum.'/';
if ( $doc eq 'prelevement' ) {
	my $file = $dir.'autorisation.pdf';
	send_pdf_file($file);
	exit(0);
}
if ( $doc eq 'adhesion' ) {
	my $file = $dir.'adhesion.pdf';
	send_pdf_file($file);
	exit(0);
}
if ( $doc eq 'souscription' ) {
	my $file = $dir.'souscription.pdf';
	send_pdf_file($file);
	exit(0);
}

eject_page_error("Type de document inconnu. C'EST UN BUG.");

