#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vdomaine');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $did;
my $domaine;
if ( $vars->{'did'} ) {
	$did = $vars->{'did'};
	$domaine = domaine_par_id($did);
} elsif ( $vars->{'domaine'} ) {
	$domaine = domaine_par_nom($vars->{'domaine'});
} else {
	$domaine = undef;
}

if ( ! defined $domaine ) {
	eject_page_error("Ce domaine n'existe pas.");
	exit(0);
}

$did = $domaine->{'DOMAINE_ID'};

$page = tableau_1d('adsl/rewrite.tbl','domaine-detail',$domaine,
	"Un domaine ".
	forward_to('domaine',$did,"domaine$did"));

eject_page($page);

