#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vfacture');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $fid = $vars->{'fid'};
my $fac = facture_par_id($fid);

if (! defined $fac ) {
	eject_page_error("Cette facture n'existe pas");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','facture',$fac,
	"Description de la facture ".
	"(<a href=\"print-facture.cgi?factu=factu$fid&format=pdf&do=yes\">Imprimer</a>) ".
	"(<a href=\"print-facture.cgi?factu=factu$fid&format=text&do=yes\">Export texte</a>)");

my @crs = creance_par_facture_id($fid);
$page .= tableau_2d_pognon('adsl/rewrite.tbl','creance','CREANCE',\@crs,
	"Crances couvertes par la facture");

eject_page($page);

		
