#!/usr/bin/perl

use strict;
use CGI;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;


my $cgi = new CGI;
my $vars = $cgi->Vars;

my $form = form_read('adsl/form/view.cfg','vipaddr');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $ipid = $vars->{'ipid'};
my $ipaddr = $vars->{'ipaddr'};

if ( !$ipid and !$ipaddr ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $ip;
if ( $ipid ) {
	$ip = ipaddr_par_id($ipid);
} else {
	$ip = ipaddr_par_addr($ipaddr);
}

if ( ! defined $ip ) {
	eject_page_error("Cette adresse IP n'existe pas");
	exit(0);
}

eject_page(tableau_1d('adsl/rewrite.tbl','ipaddr',$ip));

		
