#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Adsl::Infos;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;
my $aid;

my $form = form_read('adsl/form/view.cfg','vligne');

if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $lid = $vars->{'lid'};
my $tel = $vars->{'tel'};

if ( ! $lid && ! $tel ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $ligne;
if ( $lid ) {
	$ligne = ligne_par_id($lid);
} else {
	$ligne = ligne_par_tel($tel);
}

if ( ! defined $ligne ) {
	eject_page_error("Cette ligne n'existe pas");
	exit(0);
}

my $cid = $ligne->{'CLIENT_ID'};
$page = tableau_1d('adsl/rewrite.tbl','ligne-detail',$ligne,
	"Description de la ligne ".
	forward_to('ligne',$lid,"ligne$lid"));

my $dpl = deploiement_par_ligne_id($lid);
my $mandat = mandat_par_deploiement_id($dpl->{'DEPLOIEMENT_ID'});
$page .= tableau_1d('adsl/rewrite.tbl','mandat',$mandat,
	"Mandat de dgroupage associ");

my $user = raduser_par_ligne_id($lid);
$page .= tableau_1d('adsl/rewrite.tbl','raduser',$user,
	"Compte radius associ");

my @validations = validation_par_ligne_id($lid);
$page .= tableau_2d('adsl/rewrite.tbl','validation', \@validations,
	'Validations pour cette ligne');

my @infos = toutes_infos_ligne($lid);
$page .= tableau_2d('adsl/rewrite.tbl','infos',\@infos,
	"Informations sur la ligne".
	forward_to('nscan',"&ligne=$lid&client=$cid","ligne$lid"));

$aid = $ligne->{'ADRESSE_ID'};
my $adr = adresse_par_id($aid);

$page .= tableau_1d('adsl/rewrite.tbl','adresse',$adr,
	"Adresse de la ligne ".
	forward_to('adresse',$aid,"ligne$lid"));

eject_page($page);

