#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vpaiement');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $pid = $vars->{'pid'};
my $num = $vars->{'numero'};

if ( ! $pid && ! $num ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $paiement;
if ( $pid ) {
	$paiement = paiement_par_id($pid);
} else {
	$paiement = paiement_par_num($num);
}

if ( ! defined $paiement ) {
	eject_page_error("Ce paiement n'existe pas");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','paiement',$paiement,
	"Un paiement ".
	forward_to('paiement',$pid,"paiement$pid"));

eject_page($page);

