#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vprllig');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $pid = $vars->{'pid'};
my $prl = prllig_par_id($pid);

if ( ! defined $prl ) {
	eject_page_error("Cette ligne de prlvement n'existe pas");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','prllig',$prl,
	"Une ligne d'un prlvement ".
	forward_to('Rprllig',$pid,"prllig$pid").' '.
	forward_to('Eprllig',$pid,"prllig$pid") );

my @crs = creance_par_prllig_id($pid);
$page .= tableau_2d('adsl/rewrite.tbl','creance',\@crs,
	"Crances couvertes");

eject_page($page);

