#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vraduser');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $gid;
my $uid = $vars->{'uid'};
my $user = $vars->{'raduser'};

if ( !$uid and !$user ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $raduser;
if ( $uid ) {
	$raduser = raduser_par_id($uid);
} else {
	$raduser = raduser_par_login($user);
}

if (! defined $raduser ) {
	eject_page_error("Cet utilisateur radius n'existe pas");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','raduser',$raduser);

$uid = $raduser->{'RADUSER_ID'};
my @uattrs = uattr_par_raduser_id($uid);
$page .= tableau_2d('adsl/rewrite.tbl','uattr',\@uattrs,
	"Attributs de l'utilisateur ".
	forward_to('nuattr',$uid,"raduser$uid"));

$gid = $raduser->{'RADGROUP_ID'};
my @gattrs = gattr_par_radgroup_id($gid);
$page .= tableau_2d('adsl/rewrite.tbl','gattr',\@gattrs,
	"Attributs du groupe".
	forward_to('ngattr',$gid,"raduser$uid"));

eject_page($page);

		
