#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vsite');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $sid;
my $site;
if ( $vars->{'sid'} ) {
	$sid = $vars->{'sid'};
	$site = site_par_id($sid);
} elsif ( $vars->{'site'} ) {
	$site = site_par_site($vars->{'site'});
} elsif ( $vars->{'login'} ) {
	$site = site_par_login($vars->{'login'});
} else {
	$site = undef;
}

if ( ! defined $site ) {
	eject_page_error("Ce site n'existe pas.");
	exit(0);
}

$sid = $site->{'SITE_ID'};

$page = tableau_1d('adsl/rewrite.tbl','site',$site,
	"Un site ".
	forward_to('site',$sid,"site$sid"));

eject_page($page);

