#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vuattr');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $uid = $vars->{'uid'};
my $uattr = uattr_par_id($uid);

if ( ! defined $uattr ) {
	eject_page_error("Cet attribut utilisateur radius n'existe pas");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','uattr',$uattr,
	"Un attribut radius utilisateur ".
	forward_to('uattr',$uid,"uattr$uid"));

eject_page($page);

