#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vunixgroup');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $id = $vars->{'id'};
my $gid = $vars->{'gid'};
my $login = $vars->{'login'};

if ( ! $id && ! $gid && ! $login ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des trois champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $user;
if ( $id ) {
	$user = unixgroup_par_id($id);
} elsif ( $gid ) {
	$user = unixgroup_par_gid($gid);
} else {
	$user = unixgroup_par_name($login);
}

if ( ! defined $user ) {
	eject_page_error("Ce groupe unix n'existe pas.");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','unixgroup-detail',$user,
	"Une groupe unix".
	forward_to('unixgroup',$id,"unixgroup$id"));

eject_page($page);

