#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vunixuser');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $id = $vars->{'id'};
my $uid = $vars->{'uid'};
my $login = $vars->{'login'};

if ( ! $id && ! $uid && ! $login ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des trois champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $user;
if ( $id ) {
	$user = unixuser_par_id($id);
} elsif ( $uid ) {
	$user = unixuser_par_uid($uid);
} else {
	$user = unixuser_par_name($login);
}

if ( ! defined $user ) {
	eject_page_error("Cet utilisateur unix n'existe pas.");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','unixuser-detail',$user,
	"Une utilisateur unix".
	forward_to('unixuser',$id,"unixuser$id"));

eject_page($page);

