#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use CGI;

my $cgi = new CGI;
my $vars = $cgi->Vars;
my $page;

my $form = form_read('adsl/form/view.cfg','vvalidation');
if ( $vars->{'do'} ne 'yes' ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}
if ( !check_transition($form,$vars) ) {
        eject_page(affiche_form($form,$vars));
        exit(0);
}

my $vid = $vars->{'id'};
my $vev = $vars->{'event'};

if ( ! $vid && ! $vev ) {
	add_form_error('mandatory',"Il faut quand meme renseigner un des deux champs");
	eject_page(affiche_form($form,$vars));
	exit(0);
}

my $val;
if ( $vid ) {
	$val = validation_par_id($vid);
} else {
	$val = validation_par_login($vev);
}

if ( ! defined $val ) {
	eject_page_error("Cetle validation n'existe pas.");
	exit(0);
}

$page = tableau_1d('adsl/rewrite.tbl','validation',$val,
	"Une validation attendue ".
	forward_to('validation',$vid,"val$vid"));

eject_page($page);

