#!/usr/bin/perl

use strict;
use CGI;
use FDN::Web::Forms;
use FDN::Web::Array;
use FDN::Web::TemplateParse;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;
use FDN::Common::Logger;
use FDN::Common::Modules;
use FDN::Common::Config;

my $cgi = new CGI;
my $vars = $cgi->Vars;


my $form = form_read('adsl/adhs/suivi.cfg','suivi');
if ( $vars->{'do'} ne 'yes' ) {
	eject_page(affiche_form($form,$vars));
	exit(0);
}
if ( !check_transition($form,$vars) ) {
echec:
	eject_page(affiche_form($form,$vars));
	exit(0);
}

# Suivi effectif de la commande
my $dplnum = $vars->{dplid};
my $tel   = $vars->{tel};

my $deploiement = deploiement_par_num($dplnum);
if ( !defined $deploiement ) {
	error "Pas de commande numero $dplnum";
	goto echec;
}

my $ligne = ligne_par_tel($tel);
if ( !defined $ligne ) {
	error "Pas de ligne $tel";
	goto echec;
}

if ( $deploiement->{'LIGNE_ID'} != $ligne->{'LIGNE_ID'} ) {
	error "Le deploiement ne cadre pas avec la ligne";
	goto echec;
}

my $client = client_par_id($ligne->{'CLIENT_ID'});
if ( !defined $client ) {
	error "Le client n'existe pas";
	goto echec;
}

my $debit = debit_par_id($ligne->{'DEBIT_ID'});
my $page;

my $infos = { %$deploiement, %$ligne, %$client, %$debit };
$page  .= tableau_1d('adsl/rewrite.tbl','deploiement-suivi',$infos);
my $did = $deploiement->{'DEPLOIEMENT_ID'};
my $hash = {};
$hash->{URL} = Config_Key('adsl/global.cfg','web','urlsuivi');
$hash->{tel} = $tel;
$hash->{dplnum} = $dplnum;
$hash->{'mandat'}=0;
my $dir = Config_Key('adsl/global.cfg','dirs','stockpdf');
if ( -f $dir.'/'.$dplnum.'/autorisation.pdf' ) {
	$hash->{'prelevement'}=1;
}
if ( -f $dir.'/'.$dplnum.'/adhesion.pdf' ) {
	$hash->{'adhesion'}=1;
}
if ( -f $dir.'/'.$dplnum.'/souscription.pdf' ) {
	$hash->{'souscription'}=1;
}
my $dir = Config_Key('adsl/global.cfg','dirs','htmltpl');
$page .= remplace($dir.'/infos-commande.tpl',$hash,1);
eject_page($page);


