#!/usr/bin/perl

use strict;
use CGI;
use FDN::Common::Config;
use FDN::Common::Logger;
use FDN::Adsl::Basic;
use FDN::Adsl::Utils;

my $cgi = new CGI;
my $vars = $cgi->Vars;

my $tel = $vars->{tel};
my $dplnum = $vars->{dplnum};
my $doc = $vars->{doc};

if ( ! defined $tel ||
     ! defined $dplnum ||
     ! defined $doc ) {
	# PANIC
	exit(1);
}

my $dpl = deploiement_par_num($dplnum);
if ( ! defined $dpl ) {
	eject_page_error('Permission denied');
	exit(0);
}

my $ligne = ligne_par_tel($tel);
if ( ! defined $ligne ) {
	eject_page_error('Permission denied');
	exit(0);
}

if ( $dpl->{LIGNE_ID} != $ligne->{LIGNE_ID} ) {
	eject_page_error('Permission denied');
	exit(0);
}

if ( $doc eq 'mandat' ) {
	my $did = $dpl->{DEPLOIEMENT_ID};
	my $mdt = mandat_par_deploiement_id($did);
	if ( ! defined $mdt ) {
		eject_page_error('Permission denied');
		exit(0);
	}
	my $mandat = $mdt->{MANDAT_FICHIER};
	send_pdf_file($mandat,'mandat.pdf');
	exit(0);
}

my $dir = Config_Key('adsl/global.cfg','dirs','stockpdf');
$dir .= '/'.$dplnum.'/';
if ( $doc eq 'prelevement' ) {
	my $file = $dir.'autorisation.pdf';
	send_pdf_file($file);
	exit(0);
}
if ( $doc eq 'adhesion' ) {
	my $file = $dir.'adhesion.pdf';
	send_pdf_file($file);
	exit(0);
}
if ( $doc eq 'souscription' ) {
	my $file = $dir.'souscription.pdf';
	send_pdf_file($file);
	exit(0);
}

eject_page_error('Permission denied');
